/*
 * Copyright (c) Draconis Internet Package Project
 * Jens Heitmann <jh_draconis@users.sourceforge.net>
 * 
 * This software is licenced under the GNU Public License.
 * Please see COPYING for further information.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 * or have a look to http://www.gnu.org.
 * 
 * Author: Jens Heitmann
 * Version-Date: 2007-07-15
 * 
 */
 
#ifdef TRAPIT
#include <aes.h>
#include <stdio.h>
#include <string.h>

static char *file[200];
static long lines[200];
static long stack[200];
static int low_water = 0, high_water = 0;

void check_memory(char *file, long line);

/* logfunc(__FILE__, __LINE__); */

void logfunc(char *f, long l)
{
long stk = (long)&f;
int i;

#ifdef DBGMEM
	check_memory(f, l);
#endif

if (high_water != low_water)
	{
	i = high_water - 1;
	if (i == -1)
		i = 199;
		
	while(low_water != i)
		{
		if (stack[i] <= stk)
			{
			i--;
			if (i == -1)
				i = 199;
			}
		else
			break;
		}
	high_water = i + 1;
	if (high_water == 200)
		high_water = 0;
	}
	
if (low_water == high_water || lines[high_water] != l || strcmp(file[high_water], f))
	{
	file[high_water] = f;
	lines[high_water] = l;
	stack[high_water] = stk;

	high_water++;
	if (high_water == 200)
		high_water = 0;
	
	if (low_water == high_water)
		{
		low_water++;
		if (low_water == 200)
			low_water = 0;
		}
	}
}

void dump_locations(FILE *fh)
{
int i;

i = low_water;
while(i != high_water)
	{
	char *s;
		
	s = strrchr(file[i], '\\');
	if (!s) s = file[i]; else s++;
	fprintf(fh, "  %s %ld\n", s, lines[i]);
	
	i++;
	if (i == 200)
		i = 0;
	}
}

#endif