/*
 * Copyright (c) Draconis Internet Package Project
 * Jens Heitmann <jh_draconis@users.sourceforge.net>
 * 
 * This software is licenced under the GNU Public License.
 * Please see COPYING for further information.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 * or have a look to http://www.gnu.org.
 * 
 * Author: Jens Heitmann
 * Version-Date: 2007-07-15
 * 
 */
 
#include "extern.h"

static int cursor_state = 0;

/* ----------------
   | Cursor blink |
   ---------------- */
void cursor_control(void)
{
GRECT t1, t2;
int top;
int xy[4];

DEBUG();
wind_get_int(ROOT, WF_TOP, &top);
if (top == mail_wind)
	get_mailcursor((int *)&t2);
else
	return;

t2.g_w = 1;
	
wind_update(BEG_UPDATE);
graf_mouse(M_OFF, 0L);

wind_get(mail_wind, WF_FIRSTXYWH, &t1.g_x, &t1.g_y, &t1.g_w, &t1.g_h);
while(t1.g_w && t1.g_h)
	{
	if (rc_intersect(&t2, &t1))
		{
		xy[0] = t1.g_x;
		xy[1] = t1.g_y;
		xy[2] = t1.g_x + t1.g_w - 1;
		xy[3] = t1.g_y + t1.g_h - 1;
		vs_clip(vdi_handle, 1, xy);
		
		vswr_mode(vdi_handle, MD_XOR);
		vsf_interior(vdi_handle, FIS_SOLID);
		vr_recfl(vdi_handle, xy);
		vswr_mode(vdi_handle, MD_REPLACE);

		vs_clip(vdi_handle, 0, xy);
		}
		
	wind_get(mail_wind, WF_NEXTXYWH, &t1.g_x, &t1.g_y, &t1.g_w, &t1.g_h);
	}

graf_mouse(M_ON, 0L);
wind_update(END_UPDATE);

cursor_state ^= 1;
}

/* -----------------
   | Remove cursor |
   ----------------- */
void cursor_off(void)
{
if (!cursor_state)
	return;
	
cursor_control();
}

/* --------------
   | Set cursor |
   -------------- */
void cursor_on(void)
{
if (cursor_state)
	return;
	
cursor_control();
}
