/*
 * Copyright (c) Draconis Internet Package Project
 * Jens Heitmann <jh_draconis@users.sourceforge.net>
 * 
 * This software is licenced under the GNU Public License.
 * Please see COPYING for further information.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 * or have a look to http://www.gnu.org.
 * 
 * Author: Jens Heitmann
 * Version-Date: 2007-07-15
 * 
 */
 
#include "extern.h"

/* ------------------
   | Draw xor lines |
   ------------------ */
void draw_xor(int i, int x_base, int y_base, int width)
{
int xy[10];

xy[6] = xy[8] = xy[0] = x_base;
xy[9] = xy[3] = xy[1] = y_base + i * tx_height;;

xy[2] = xy[4] = x_base + width - 1;
xy[7] = xy[5] = xy[1] + tx_height - 1;
v_pline(vdi_handle, 5, xy);
}

/* ---------------------------
   | Drag selected mail list |
   --------------------------- */
void drag_list(int box, int page, int num, 
							 int win_x, int win_y, int win_w, int *cxy)
{
int i;

DEBUG();
vs_clip(vdi_handle, TRUE, cxy);
vswr_mode(vdi_handle, MD_XOR);
graf_mouse(M_OFF, 0L);

for (i = 0; i < num; i++)
	if (box_manager[box].index[page + i].sel & 1)
		draw_xor(i, win_x, win_y, win_w);
		
graf_mouse(M_ON, 0L);
vswr_mode(vdi_handle, MD_REPLACE);
vs_clip(vdi_handle, FALSE, cxy);
}
