/*
 * Copyright (c) Draconis Internet Package Project
 * Jens Heitmann <jh_draconis@users.sourceforge.net>
 * 
 * This software is licenced under the GNU Public License.
 * Please see COPYING for further information.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 * or have a look to http://www.gnu.org.
 * 
 * Author: Jens Heitmann
 * Version-Date: 2007-07-15
 * 
 */
 
#include "extern.h"

/* -----------------------
   | Font selector popup |
   ----------------------- */
int free_droplist(int x, int y, int w, char **strings)
{
int i, page, obj;
OBJECT *freedrop;
static int ftext[] = {FREEDROP1, FREEDROP2, FREEDROP3, FREEDROP4, FREEDROP5, FREEDROP6};
char fnames[6][33];
GRECT fr;
int last_obj = 0, count;

DEBUG();
count = 0;
while(strings[count])
	count++;
	
rsrc_gaddr(R_TREE, FREEDROP, &freedrop);

form_center(freedrop, &fr);
freedrop[0].ob_x = x; freedrop[0].ob_y = y;
freedrop[0].ob_width = w;

freedrop[FREEDROP_SBK].ob_x = w - freedrop[FREEDROP_SBK].ob_width;

for (i = 0; i < 6; i++)
	{
	freedrop[ftext[i]].ob_spec.tedinfo->te_ptext = fnames[i];
	freedrop[ftext[i]].ob_width = freedrop[FREEDROP_SBK].ob_x - 1;
	fnames[i][0] = 0;
	}

page = 0;
align_slider_objects(freedrop, FREEDROP_SBK, FREEDROP_UP, FREEDROP_SLD, FREEDROP_DRG, FREEDROP_DOWN);

wait_mouse_release();

for (i = 0; i < 6 && i < count; i++)	
	{
	strncpy(fnames[i], strings[page + i], 32);
	fnames[i][32] = 0;
	}
set_slider_objects(freedrop, FREEDROP_SLD, FREEDROP_DRG, count, page, 6, FALSE);	

open_frameless(freedrop, x - 1, y - 1);
wind_update(BEG_MCTRL);

do
	{
	do
		{	
		check_mouse();

		obj = objc_find(freedrop, ROOT, MAX_DEPTH, evnt.x, evnt.y);
		if (last_obj && last_obj != obj)
			{
			change_object(freedrop, last_obj,	freedrop[last_obj].ob_state & ~SELECTED);
			last_obj = 0;
			}
		
		if (obj > -1 && (freedrop[obj].ob_flags & SELECTABLE) && 
				!(freedrop[obj].ob_state & DISABLED) &&
				freedrop[obj].ob_spec.tedinfo->te_ptext[0] && last_obj != obj)
			{
			change_object(freedrop, obj, freedrop[obj].ob_state | SELECTED);
			last_obj = obj;
			}
		}while(!evnt.bstate);
	
	switch(obj)
		{
		case FREEDROP_UP:
			if (page > 0)
				{
				page--;
				delay(100);
				}
			break;
			
		case FREEDROP_DOWN:
			if (page < count - 6)
				{
				page++;
				delay(100);
				}
			break;
		
		case FREEDROP_SLD:
			{
			int ox, oy;
			
			objc_offset(freedrop, FREEDROP_DRG, &ox, &oy);
			if (evnt.y < oy)
				{
				page -= 6;
				if (page < 0) page = 0;
				}
			else
				{
				page += 6;
				if (page > count - 6)
					page = count - 6;
				}
			delay(100);
			break;
			}
			
		case FREEDROP_DRG:
			{
			int pos = graf_slidebox(freedrop, FREEDROP_SLD, FREEDROP_DRG, 1);
			page = (int)(pos * (long)(count - 6) / 1000);
			break;
			}
		}
		
	for (i = 0; i < 6 && i < count; i++)	
		{
		strncpy(fnames[i], strings[page + i], 32);
		fnames[i][32] = 0;
		redraw_object(freedrop, ftext[i]);
		}
	set_slider_objects(freedrop, FREEDROP_SLD, FREEDROP_DRG, count, page, 6, TRUE);	

	}while(obj == FREEDROP_UP || obj == FREEDROP_DOWN ||
				 obj == FREEDROP_SLD || obj == FREEDROP_DRG);

if (last_obj)
	change_object(freedrop, last_obj,	freedrop[last_obj].ob_state & ~SELECTED);

wait_mouse_release();
close_dialog(freedrop, TRUE);
	
wind_update(END_MCTRL);
	
if (obj > -1)
	{
	for (i = 0; i < 6; i++)
		if (obj == ftext[i])
			break;
			
	if (i < 6 && page + i < count)
		return page + i;
	}
return -1;
}
