/*
 * Copyright (c) Draconis Internet Package Project
 * Jens Heitmann <jh_draconis@users.sourceforge.net>
 * 
 * This software is licenced under the GNU Public License.
 * Please see COPYING for further information.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 * or have a look to http://www.gnu.org.
 * 
 * Author: Jens Heitmann
 * Version-Date: 2007-07-15
 * 
 */
 
#include "extern.h"

/* ------------------------------
   | Decode quoted header field |
   ------------------------------ */
long DecodeQuotedHeader(char *s, char *s1)
{
int v1, v2;
char *cp = s, *cp1 = s1;

while(*s1 && (*s1 != '?' || s1[1] != '='))
	{
	if (*s1 == '=')
		{
		v1 = s1[1] - '0'; if (v1 > 9) v1 -= 'A' - '9' - 1;
		v2 = s1[2] - '0'; if (v2 > 9) v2 -= 'A' - '9' - 1;
		*(s++) = (v1 << 4) | v2;
		s1 += 3;
		}
	else
		if (*s1 == '_')
			{
			*(s++) = ' ';
			s1++;
			}
		else
			*(s++) = *(s1++);
	}

if (*s1 == '?' && s1[1] == '=')
	s1 += 2;

return ((s - cp) << 16L) | (s1 - cp1);
}

/* -----------------------
   | Decode header field |
   ----------------------- */
void decode_header(char *line)
{
char *s, *s1;
char cset[20], enc;
int i;
long l;

DEBUG();
s = line;
while(*s)
	{
	if (*s == '=' && s[1] == '?')
		{
		s1 = s + 2;
		i = 0;
		while(*s1 != '?' && *s1)
			cset[i++] = *(s1++);
		cset[i] = 0;
		
		if (*s1 == '?')
			{
			s1++;
			enc = toupper(*(s1++));

			if (*s1 == '?')
				{
				s1++;
				
				if (enc == 'Q')
					l = DecodeQuotedHeader(s, s1);
				else
					if (enc == 'B')
						{
						}
					else
						l = 0L;
				
				s += l >> 16;
				s1 += l & 0xFFFF;
				memmove(s, s1, strlen(s1) + 1);		
				}
			}
		}
	s++;	
	}
}

