/*
 * Copyright (c) Draconis Internet Package Project
 * Jens Heitmann <jh_draconis@users.sourceforge.net>
 * 
 * This software is licenced under the GNU Public License.
 * Please see COPYING for further information.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 * or have a look to http://www.gnu.org.
 * 
 * Author: Jens Heitmann
 * Version-Date: 2007-07-15
 * 
 */
 
#include "extern.h"

int lbut_pos[8];
int lbut_no[8] = {32-1, 35-1, 38-1, 41-1, 44-1, 47-1, 50-1, 2-1};
static int defsize[] = {23, 23, 23, 8, 17, 22, 2};

static MFORM vert = {8,8,1,0,1,
										{0x0000, 0x0000, 0x0000, 0x0000, 0x381C, 
										 0x781E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x781E, 
										 0x381C, 0x0000, 0x0000, 0x0000, 0x0000},
										{0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
										 0x1008, 0x300C, 0x7FFE, 0x7FFE, 0x300C, 0x1008,
										 0x0000, 0x0000, 0x0000, 0x0000, 0x0000}};
int mouse_form = 0;

/* ---------------------------
   | Set normal mouse cursor |
   --------------------------- */
void set_normalmouse(void)
{
if (mouse_form != 0)
	{
	graf_mouse(ARROW, 0L);
	mouse_form = 0;
	}
}

/* -------------------------
   | Set size mouse cursor |
   ------------------------- */
void set_sizemouse(void)
{
if (mouse_form != 1)
	{
	graf_mouse(USER_DEF, &vert);
	mouse_form = 1;
	}
}

/* ---------------------------------------
   | Calculate horizontal button offsets |
   --------------------------------------- */
void calc_listbutpos(void)
{
int ispace, ox;

DEBUG();
ispace = isize / 2;
	
		 lbut_pos[0] = 2;																/* View 		*/
ox = lbut_pos[1] = 2  + isize + 4;									/* Edit 		*/
ox = lbut_pos[2] = ox + isize + ispace + 4;					/* Reply 		*/
ox = lbut_pos[3] = ox + isize + 4;									/* Forward	*/
ox = lbut_pos[4] = ox + isize + ispace + 4;					/* Save 		*/
ox = lbut_pos[5] = ox + isize + 4;									/* Print		*/
ox = lbut_pos[6] = ox + isize + 4;									/* Delete		*/
		 lbut_pos[7] = ox + isize + ispace + 4;					/* Close		*/
}


/* -----------------------------
   | Select mail editor button |
   ----------------------------- */
void select_listbutton(int box, int no)
{
DEBUG();
box_manager[box].lbut_selected[0] = 
box_manager[box].lbut_selected[1] = 
box_manager[box].lbut_selected[2] = 
box_manager[box].lbut_selected[3] = 
box_manager[box].lbut_selected[4] = 
box_manager[box].lbut_selected[5] = 
box_manager[box].lbut_selected[6] = 
box_manager[box].lbut_selected[7] = FALSE;

if (no != -1)
	box_manager[box].lbut_selected[no] = TRUE;
}
   
/* -------------------------
   | Draw a toolbar button |
   ------------------------- */
void draw_smallbutton(int box, int no, int x, int y)
{
int bnum;

DEBUG();
bnum = lbut_no[no]; 
if (box_manager[box].lbut_disabled[no])
	bnum += 2;
else
	if (box_manager[box].lbut_selected[no])
		bnum++;
		
blt_copy(mw_toolbar, 0, bnum * iheight, NULL, x, y, isize, iheight, S_ONLY);
}

/* --------------------------------------
   | Enable menu entries in list window |
   -------------------------------------- */
void list_enable(int box)
{
int ldisabled[8], i;

DEBUG();
memcpy(ldisabled, box_manager[box].lbut_disabled, sizeof(ldisabled));
if (!box_manager[box].list_marks)
	{
	menu_ienable(menu_adr, M_DEL, FALSE);
	menu_ienable(menu_adr, EDITMAIL, FALSE);
	menu_ienable(menu_adr, M_FWD, FALSE);
	menu_ienable(menu_adr, M_REPLY, FALSE);
	menu_ienable(menu_adr, M_AGAIN, FALSE);
	menu_ienable(menu_adr, M_SEND, FALSE);
	menu_ienable(menu_adr, SAVE_MSG, FALSE);
	menu_ienable(menu_adr, M_PRINT, FALSE);
	
	box_manager[box].lbut_disabled[0] = TRUE;			/* View 		*/
	box_manager[box].lbut_disabled[1] = TRUE;			/* Edit 		*/
	box_manager[box].lbut_disabled[2] = TRUE;			/* Reply 		*/
	box_manager[box].lbut_disabled[3] = TRUE;			/* Forward 	*/
	box_manager[box].lbut_disabled[4] = TRUE;			/* Save 		*/
	box_manager[box].lbut_disabled[5] = TRUE;			/* Print 		*/
	box_manager[box].lbut_disabled[6] = TRUE;			/* Delete 	*/
	}
else
	{
	menu_ienable(menu_adr, SAVE_MSG, TRUE);
	box_manager[box].lbut_disabled[0] = FALSE;			/* View 		*/
	box_manager[box].lbut_disabled[4] = FALSE;			/* Save 		*/

	if (box_manager[box].list_marks > 0)
		{
		menu_ienable(menu_adr, M_FWD, TRUE);
		box_manager[box].lbut_disabled[3] = FALSE;
		}
	else
		{
		menu_ienable(menu_adr, M_FWD, FALSE);
		box_manager[box].lbut_disabled[3] = TRUE;
		}
	
	if (!boxes[box].type && box_manager[box].list_marks == 1)
		{
		menu_ienable(menu_adr, M_REPLY, TRUE);
		box_manager[box].lbut_disabled[2] = FALSE;			/* Reply 		*/
		}
	else
		{
		menu_ienable(menu_adr, M_REPLY, FALSE);
		box_manager[box].lbut_disabled[2] = TRUE;				/* Reply 		*/
		}

	if (box_manager[box].list_marks == 1)
		{
		box_manager[box].lbut_disabled[5] = FALSE;		/* Print 		*/
		menu_ienable(menu_adr, M_PRINT, TRUE);
		menu_ienable(menu_adr, M_REPLY, TRUE);
		}
	else
		{
		menu_ienable(menu_adr, M_REPLY, FALSE);
		menu_ienable(menu_adr, M_PRINT, FALSE);
		box_manager[box].lbut_disabled[5] = TRUE;			/* Print 		*/
		}

	if (box != box_number("QUEUE"))
		{
		if (boxes[box].type)
			menu_ienable(menu_adr, M_AGAIN, TRUE);
		else
			menu_ienable(menu_adr, M_AGAIN, FALSE);
		menu_ienable(menu_adr, M_SEND, FALSE);
		}
	else
		{
		menu_ienable(menu_adr, M_AGAIN, FALSE);
		menu_ienable(menu_adr, M_SEND, TRUE);

		if (box_manager[box].list_marks == 1)
			{
			int i;
			
			for (i = 0; i < box_manager[box].box_entries; i++)
				if (box_manager[box].index[i].sel & 1)
					{
					if (strncmp(box_manager[box].index[i].subject, "RC: ", 4))
						{
						menu_ienable(menu_adr, EDITMAIL, TRUE);
						box_manager[box].lbut_disabled[1] = FALSE;			/* Edit 		*/
						}
					else
						{
						menu_ienable(menu_adr, EDITMAIL, FALSE);
						box_manager[box].lbut_disabled[1] = TRUE;			/* Edit 		*/
						}
					break;
					}
			}
		else
			{
			menu_ienable(menu_adr, EDITMAIL, FALSE);
			box_manager[box].lbut_disabled[1] = TRUE;			/* Edit 		*/
			}
		}
	menu_ienable(menu_adr, M_DEL, TRUE);
	box_manager[box].lbut_disabled[6] = FALSE;				/* Delete 	*/
	}

if (box_manager[box].box_entries)
	menu_ienable(menu_adr, M_SELALL, TRUE);
else
	menu_ienable(menu_adr, M_SELALL, FALSE);

box_manager[box].lbut_disabled[7] = FALSE;			/* Close 		*/

if (box_manager[box].list_wind > -1)
	for (i = 0; i < 8; i++)
		if (ldisabled[i] != box_manager[box].lbut_disabled[i])
			redraw_listbutton(box, i);
}

/* ----------------------------------
   | Calculate box column positions |
   ---------------------------------- */
void calc_column_positions(int box, int *col_pos, int *col_size)
{
int i, n;

DEBUG();
for (i = 0; i < 7; i++)
	if (box_manager[box].box_cols[i] < 0)
		box_manager[box].box_cols[i] = defsize[i];												/* Default old data */

n = box_manager[box].box_cols[6] > 0 ? 2 : 0;		
if (boxes[box].type == 0 || mail_options.allheads)
	{
	col_pos[0] = n;
	col_size[0] = box_manager[box].box_cols[0];
	n += col_size[0] + 3;
	}
else
	{
	col_pos[0] = 0;
	col_size[0] = 0;
	}

if (boxes[box].type == 1 || boxes[box].type == 3 || mail_options.allheads)
	{
	col_pos[1] = n;
	col_size[1] = box_manager[box].box_cols[1];
	n += col_size[1] + 3;
	}
else
	col_size[1] = 0;

for (i = 2; i < 6; i++)
	{
	col_pos[i] = n;
	if (box_manager[box].box_cols[i] > 0)
		{
		col_size[i] = box_manager[box].box_cols[i];
		n += col_size[i] + 3;
		}
	else
		col_size[i] = 0;
	}
}

/* --------------------
   | Mail list slider |
   -------------------- */
void set_listslider(int box)
{
int wx, wy, ww, wh;
int size, pos, new, old, hsize;
int col_pos[6], col_size[6];

DEBUG();
calc_column_positions(box, col_pos, col_size);
hsize = col_pos[5] + col_size[5]/* + 2*/;

wind_get(box_manager[box].list_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);
if (ww + box_manager[box].list_left * tx_width >= hsize * tx_width)
	{
	new = hsize - ww / tx_width;
	if (new < 0) new = 0;
	if (new != box_manager[box].list_left)
		{
		box_manager[box].list_left = new;
		redraw_listwindow(box, wx, wy, ww, wh);
		}
	}
	
if (ww >= hsize * tx_width)
	{
	size = 1000;
	pos = 0;
	}
else
	{
	pos = (int)(box_manager[box].list_left * 1000L / (hsize - ww / tx_width));
	size = (int)(ww * 1000L / tx_width / hsize);
	}
wind_get_int(box_manager[box].list_wind, WF_HSLSIZE, &old);
if (size != old)
	wind_set_int(box_manager[box].list_wind, WF_HSLSIZE, size);

wind_get_int(box_manager[box].list_wind, WF_HSLIDE, &old);
if (pos != old)
	wind_set_int(box_manager[box].list_wind, WF_HSLIDE, pos);

if ((wh - iheight) / tx_height - 1 + box_manager[box].list_page >= box_manager[box].box_entries)
	{
	new = box_manager[box].box_entries - (wh - iheight) / tx_height + 1;
	if (new < 0) new = 0;
	if (new != box_manager[box].list_page)
		{
		box_manager[box].list_page = new;
		redraw_listwindow(box, wx, wy, ww, wh);
		}
	}
	
if ((wh - iheight) / tx_height - 1 >= box_manager[box].box_entries)
	{
	if (box_manager[box].list_page > 0)
		{
		box_manager[box].list_page = 0;
		redraw_listwindow(box, wx, wy, ww, wh);
		}
	size = 1000;
	pos = 0;
	}
else
	{
	pos = (int)(box_manager[box].list_page * 1000L / (box_manager[box].box_entries - (wh - iheight) / tx_height + 1));
	size = (int)(((wh - iheight) / tx_height - 1) * 1000L / box_manager[box].box_entries);
	}

wind_get_int(box_manager[box].list_wind, WF_VSLSIZE, &old);
if (size != old)
	wind_set_int(box_manager[box].list_wind, WF_VSLSIZE, size);

wind_get_int(box_manager[box].list_wind, WF_VSLIDE, &old);
if (pos != old)
	wind_set_int(box_manager[box].list_wind, WF_VSLIDE, pos);
}
   
/* ----------------------
   | Set List info line |
   ---------------------- */
void set_listinfo(int box)
{
DEBUG();
if (box_manager[box].list_wind > -1)	
	{
	if (box_manager[box].box_entries > 0)
		{
		itoa(box_manager[box].box_entries, box_manager[box].list_info,	10);
		strcat(box_manager[box].list_info, " ");
	
		if (box_manager[box].box_entries > 1)
			strcat(box_manager[box].list_info, s_messgs);
		else
			strcat(box_manager[box].list_info, s_messg);
	
		strcat(box_manager[box].list_info, " (");
		ltoa(box_manager[box].box_total, box_manager[box].list_info + strlen(box_manager[box].list_info), 10);
		strcat(box_manager[box].list_info, " bytes)");
		
		if (box_manager[box].list_marked)
			{
			strcat(box_manager[box].list_info, " [");
			
			itoa(box_manager[box].list_marks, 
					 box_manager[box].list_info + strlen(box_manager[box].list_info),	10);
			strcat(box_manager[box].list_info, " ");
					
			if (box_manager[box].list_marks > 1)
				strcat(box_manager[box].list_info, s_messgs);
			else
				strcat(box_manager[box].list_info, s_messg);
			
			strcat(box_manager[box].list_info, " (");
			ltoa(box_manager[box].list_marked, 
					 box_manager[box].list_info + strlen(box_manager[box].list_info), 10);
			strcat(box_manager[box].list_info, " bytes) ");
			strcat(box_manager[box].list_info, s_marked);
			strcat(box_manager[box].list_info, "]");
			}
		}
	else
		strcpy(box_manager[box].list_info, s_nomssg);	
	
	wind_set_string(box_manager[box].list_wind, WF_INFO, box_manager[box].list_info);
	}
}		

/* --------------------
   | Open List window |
   -------------------- */
void list_window(int box)
{
DEBUG();
if (box_manager[box].list_wind == -1)
	unselect_all_list(box);

if (boxes[box].auto_apply)
	apply_filter(box);

if (box_manager[box].list_wind > -1)
	{
	abookset_wind = -1;
	wind_set_int(box_manager[box].list_wind, WF_TOP, 0);
	list_enable(box);
	}
else
	{
	GRECT wrec;

	wind_get_grect(ROOT, WF_WORKXYWH, &wrec);
	box_manager[box].list_wind = wind_create(NAME|CLOSER|FULLER|MOVER|INFO|SIZER|
															 UPARROW|DNARROW|VSLIDE|LFARROW|RTARROW|
															 HSLIDE, &wrec);
	box_manager[box].list_info = (char *)malloc(256);
	
	wind_set_string(box_manager[box].list_wind, WF_NAME, boxes[box].desc);
	set_listinfo(box);

	if (box_manager[box].box_coords[0] == -1)
		{
		box_manager[box].box_coords[0] =  wrec.g_x + wrec.g_w / 6;
		box_manager[box].box_coords[1] =  wrec.g_y + wrec.g_h / 6;
		box_manager[box].box_coords[2] =  wrec.g_w - wrec.g_w / 3;
		box_manager[box].box_coords[3] =  wrec.g_h - wrec.g_h / 3;
		}
	else	
		box_manager[box].box_coords[0] &= ~0x4000;

	if (box_manager[box].box_coords[0] > wrec.g_x + wrec.g_w)
		box_manager[box].box_coords[0] =  wrec.g_x + wrec.g_w / 6;

	if (box_manager[box].box_coords[1] > wrec.g_y + wrec.g_h)
		box_manager[box].box_coords[1] =  wrec.g_y + wrec.g_h / 6;
		
	if (box_manager[box].box_coords[2] > wrec.g_w)
		box_manager[box].box_coords[2] = wrec.g_w;
		
	if (box_manager[box].box_coords[3] > wrec.g_h)
		box_manager[box].box_coords[3] = wrec.g_h;
				
	wind_open(box_manager[box].list_wind, (GRECT *)&box_manager[box].box_coords[0]);
	register_window(box_manager[box].list_wind);
	
	box_manager[box].list_page = 0;
	box_manager[box].list_left = 0;
	box_manager[box].list_marks = 0;
	box_manager[box].list_marked = 0;
	set_listslider(box);
	list_enable(box);
	}
}

/* ---------------------
   | Close List window |
   --------------------- */
void close_listwindow(int box)
{
DEBUG();
if (box_manager[box].list_wind > -1)
	{
	wind_get(box_manager[box].list_wind, WF_CURRXYWH, 
									&box_manager[box].box_coords[0], 
									&box_manager[box].box_coords[1], 
									&box_manager[box].box_coords[2], 
									&box_manager[box].box_coords[3]);

	wind_close(box_manager[box].list_wind);
	unregister_window(box_manager[box].list_wind);
	wind_delete(box_manager[box].list_wind);
	box_manager[box].list_wind = -1;
	
	free(box_manager[box].list_info);
	
	save_box_index(box);
	}
}

/* ----------------------------------------
   | Redraw toolbar of mail editor window |
   ---------------------------------------- */
void redraw_listbar(int box)
{
int wx, wy, ww, wh;
int x, w;

DEBUG();
wind_get(box_manager[box].list_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);

x = wx;
w = ww;
while (w > 0)
	{
	blt_copy(mw_toolbar, 0, 0 * iheight, NULL, x, wy, isize, iheight, S_ONLY);
	x += isize;
	w -= isize;
	}	

draw_smallbutton(box, 1,	wx + lbut_pos[1], wy);		/* Edit */
draw_smallbutton(box, 0, wx + lbut_pos[0], wy);			/* Open 		*/
draw_smallbutton(box, 2, wx + lbut_pos[2], wy);			/* Reply 		*/
draw_smallbutton(box, 3, wx + lbut_pos[3], wy);			/* Forward 	*/
draw_smallbutton(box, 4, wx + lbut_pos[4], wy);			/* Save 		*/
draw_smallbutton(box, 5, wx + lbut_pos[5], wy);			/* Print 		*/
draw_smallbutton(box, 6, wx + lbut_pos[6], wy);			/* Delete 	*/
draw_smallbutton(box, 7, wx + lbut_pos[7], wy);			/* Close  	*/
}

/* ----------------------
   | Redraw list window |
   ---------------------- */
void redraw_listwindow(int box, int rx, int ry, int rw, int rh)
{
static int head_id[] = {FROMTEXT, TOTEXT, SUBJTEXT, SIZETEXT, DATETEXT, IDENTITYTEXT};
GRECT t1, t2;
int xy[4], xy2[4];
int wx, wy, ww, wh, x, y;
int t_xy[128];
int th, tw, hg, l, msg;
char t_buf[128];
int col_pos[6], col_size[6], i;

char weekday[80];
int  day, j;
char month[20];
int  year;
int  hour,minute;

DEBUG();
t2.g_x = rx;
t2.g_y = ry;
t2.g_w = rw;
t2.g_h = rh;

wind_update(BEG_UPDATE);
graf_mouse(M_OFF, 0L);

set_default_text();
vqt_extent(vdi_handle, "x", t_xy);
tw = (t_xy[4] - t_xy[0]);
th = (t_xy[5] - t_xy[1]);

vsl_color(vdi_handle, 1);
vsl_type(vdi_handle, 1);
vsl_width(vdi_handle, 1);

vst_color(vdi_handle, 1);

wind_get(box_manager[box].list_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);

x = wx - box_manager[box].list_left * tw;

calc_column_positions(box, col_pos, col_size);

wind_get(box_manager[box].list_wind, WF_FIRSTXYWH, &t1.g_x, &t1.g_y, &t1.g_w, &t1.g_h);
while(t1.g_w && t1.g_h)
	{
	if (rc_intersect(&t2, &t1))
		{
		xy[0] = t1.g_x;
		xy[1] = t1.g_y;
		xy[2] = t1.g_x + t1.g_w - 1;
		xy[3] = t1.g_y + t1.g_h - 1;
		vs_clip(vdi_handle, 1, xy);

		vswr_mode(vdi_handle, MD_REPLACE);	
		xy2[0] = wx;
		xy2[1] = wy + iheight + th;	
		xy2[2] = wx + ww - 1;
		xy2[3] = wy + wh - 1;
		vsf_interior(vdi_handle, FIS_HOLLOW);
		vr_recfl(vdi_handle, xy2);
		
		redraw_listbar(box);
		
		y = wy + iheight;
		hg = (t1.g_y + t1.g_h - y + th - 1) / th - 1;
		if (colours > 4)
			vsf_color(vdi_handle, 8);
		else
			vsf_color(vdi_handle, 0);
		
		vsf_interior(vdi_handle, FIS_SOLID);
		xy2[0] = wx;
		xy2[1] = y;
		xy2[2] = wx + ww - 1;
		xy2[3] = y + th - 1;
		vr_recfl(vdi_handle, xy2);
				
		vswr_mode(vdi_handle, MD_TRANS);

			/* Headlines */
		for (i = 0; i < 6; i++)
			if (col_size[i])
				{
				strcpy(t_buf, header_tree[head_id[i]].ob_spec.free_string);
				t_buf[col_size[i]] = 0;
				v_gtext(vdi_handle, x + col_pos[i] * tw, y, t_buf);
				}
				
		vswr_mode(vdi_handle, MD_REPLACE);

		xy2[0] = wx;
		xy2[2] = wx + ww - 1;
		xy2[1] = xy2[3] = wy + iheight;
		v_pline(vdi_handle, 2, xy2);

		if (box_manager[box].box_sort)
			{
			int col = box_manager[box].box_sort, sgn;
			int xy[8];
			
			if (box_manager[box].box_sort < 0)
				{
				col = -col;
				sgn = 0;
				}
			else
				sgn = 1;
			
			col--;
			if (col_size[col])
				{
				xy[0] = wx - box_manager[box].list_left * tw + (col_pos[col] + (int)strlen(header_tree[head_id[col]].ob_spec.free_string)) * tw;
				xy[2] = xy[0] + tw;
				xy[4] = xy[0] + tw / 2;
				xy[6] = xy[0];
				
				xy[1] = wy + th - 4 - sgn * th / 2 + iheight;
				xy[3] = xy[1];
				xy[5] = wy + th - 4 - th / 2 + sgn * th / 2 + iheight;
				xy[7] = xy[1];
				
				v_pline(vdi_handle, 4, xy);
				}
			}
			
		y = wy + 1 * th + iheight;
		vswr_mode(vdi_handle, MD_TRANS);
		for (msg = box_manager[box].list_page, l = 0; l < hg && msg < box_manager[box].box_entries; l++, msg++, y += th)
			{
			if (box_manager[box].index[msg].sel & 1)	
				{
				xy2[0] = wx; xy2[2] = wx + ww - 1;
				xy2[1] = wy + (l + 1) * th + iheight;
				xy2[3] = xy2[1] + th - 1;
				vsf_interior(vdi_handle, FIS_SOLID);
				vsf_color(vdi_handle, 1);
				vr_recfl(vdi_handle, xy2);
				
				vst_color(vdi_handle, 0);
				}

			if (!strncmp(box_manager[box].index[msg].subject, "RC: ", 4))
				{
				if (box_manager[box].index[msg].sel & 2) 
					vst_effects(vdi_handle, 4+1);
				else
					vst_effects(vdi_handle, 4);
				}
			else
				{
				if (box_manager[box].index[msg].sel & 2) 
					vst_effects(vdi_handle, 1);
				else
					vst_effects(vdi_handle, 0);
				
				if (box_manager[box].index[msg].color != -1 && 
						box_manager[box].index[msg].color < colours)
					vst_color(vdi_handle, box_manager[box].index[msg].color);
				else
					if (colours >= 16)
						{
						if (box_manager[box].index[msg].sel & 16)
							vst_color(vdi_handle, RED);
						else
							if (box_manager[box].index[msg].sel & 32)
								vst_color(vdi_handle, BLUE);
						}
				}
				
			if (box_manager[box].box_cols[6] > 0)	
				{
				if (box_manager[box].index[msg].sel & 4)
					{
					xy2[0] = x + 1;
					xy2[1] = wy + (l + 1) * th + th / 2 - 1 + iheight;
					xy2[2] = xy2[0] + 2;
					xy2[3] = xy2[1] + 2;
					vsf_interior(vdi_handle, FIS_SOLID);
					vsf_color(vdi_handle, 1);
					vr_recfl(vdi_handle, xy2);
					}
	
				if (box_manager[box].index[msg].sel & 8)
					{
					icon_copy(symbols, 10, (smallfont ? 8 : 16) * 3, 
								 		x + 6, wy + (l + 1) * th + iheight, 
								 		8, smallfont ? 8 : 16);
					}
				}
			
			if (col_size[0])
				{
				strncpy(t_buf, box_manager[box].index[msg].from, col_size[0]);
				t_buf[col_size[0]] = 0;
				v_gtext(vdi_handle, x + col_pos[0] * tw, 	y, t_buf);
				}
				
			if (col_size[1])
				{
				strncpy(t_buf, box_manager[box].index[msg].to, col_size[1]);
				t_buf[col_size[1]] = 0;
				v_gtext(vdi_handle, x + col_pos[1] * tw, y, t_buf);
				}
			
			if (col_size[2])
				{	
				strncpy(t_buf, box_manager[box].index[msg].subject, col_size[2]);
				t_buf[col_size[2]] = 0;
				v_gtext(vdi_handle, x + col_pos[2] * tw, y, t_buf);
				}

			if (col_size[3])
				{				
				sprintf(t_buf, "%8ld", box_manager[box].index[msg].body_len);
				t_buf[col_size[3]] = 0;
				v_gtext(vdi_handle, x + col_pos[3] * tw, y, t_buf);
				}
				
			if (col_size[4])
				{				
				if (box_manager[box].index[msg].date[0] == 0x02)
					sscanf(box_manager[box].index[msg].date + 1, "%d %4[A-Za-z] %d,%d:%d", 
								 &day, month, &year, &hour, &minute);
				else
					{
					if (sscanf(box_manager[box].index[msg].date, "%[^0-9]%d %4[A-Za-z]%d %d:%d:", 
											weekday, &day, month, &year, &hour, &minute) != 6)
						{
						j = 5;
					  while(box_manager[box].index[msg].date[j] && 
					  			box_manager[box].index[msg].date[j++] != ','); 	/* find start of date */
							sscanf(box_manager[box].index[msg].date + j, "%[^0-9]%d %4[A-Za-z]%d %d:%d:", 
										 weekday, &day, month, &year, &hour, &minute);				
						}
					}
	
				if (year < 100)
					if (year < 30)
						year += 2000;
					else
						year += 1900;
						
	/*		  if (year > 100) year %= 100;*/
			  month[3] = 0;
				sprintf(t_buf, "%2d %03s %04d,%02d:%02d", day, month, year, hour, minute);
				t_buf[col_size[4]] = 0;
	
				v_gtext(vdi_handle, x + col_pos[4] * tw, y, t_buf);
				}
				
			if (col_size[5])
				{
				strncpy(t_buf, box_manager[box].index[msg].identity, col_size[5]);
				t_buf[col_size[5]] = 0;
				v_gtext(vdi_handle, x + col_pos[5] * tw, y, t_buf);
				}

			if (box_manager[box].index[msg].sel & 1)	vst_color(vdi_handle, 1);
			if (box_manager[box].index[msg].sel & 16)	vst_color(vdi_handle, BLACK);
			}
		vst_effects(vdi_handle, 0);

		xy2[0] = wx;
		xy2[2] = wx + ww - 1;
		xy2[1] = xy2[3] = wy + th - 1 + iheight;
		v_pline(vdi_handle, 2, xy2);

		xy2[1] = wy + iheight;
		xy2[3] = wy + wh - 1;

		for (i = 0; i < 6; i++)
			if (col_size[i])
				{
				xy2[0] = xy2[2] = x + (col_pos[i] + col_size[i] + 2) * tw + tw / 2;
				v_pline(vdi_handle, 2, xy2);
				}
			
		vswr_mode(vdi_handle, MD_REPLACE);
		vs_clip(vdi_handle, 0, xy);
		}

	wind_get(box_manager[box].list_wind, WF_NEXTXYWH, &t1.g_x, &t1.g_y, &t1.g_w, &t1.g_h);
	}

graf_mouse(M_ON, 0L);
wind_update(END_UPDATE);
}

/* --------------------------
   | Message on mail window |
   -------------------------- */
void list_window_message(int *msg, int box)
{
int wx, wy, ww, wh;
int t_xy[8], tw, th;
int col_pos[6], col_size[6], hsize;
		
DEBUG();
set_default_text();
vqt_extent(vdi_handle, "x", t_xy);
tw = (t_xy[4] - t_xy[0]);
th = (t_xy[5] - t_xy[1]);

calc_column_positions(box, col_pos, col_size);
hsize = col_pos[5] + col_size[5]/* + 2*/;

wind_get(box_manager[box].list_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);
switch(msg[0])
	{
	case WM_REDRAW:
		redraw_listwindow(box, msg[4], msg[5], msg[6], msg[7]);
		break;
		
	case WM_CLOSED:
		close_listwindow(box);
		enabler();
		break;
		
	case WM_ARROWED:
		{
		switch(msg[4])
			{
			case WA_UPPAGE:
				if (box_manager[box].list_page > 0) 
					{
					box_manager[box].list_page -= (wh - iheight) / th - 1;
					if (box_manager[box].list_page < 0) box_manager[box].list_page = 0;
					redraw_listwindow(box, wx, wy, ww, wh);
					set_listslider(box);
					}
				break;
				
			case WA_DNPAGE:
				if (box_manager[box].list_page + ((wh - iheight) / th - 1) < box_manager[box].box_entries)
					{
					box_manager[box].list_page += (wh - iheight) / th - 1;
					if (box_manager[box].list_page + ((wh - iheight) / th - 1) >= box_manager[box].box_entries) 
						box_manager[box].list_page = box_manager[box].box_entries - (wh - iheight) / th + 1;

					redraw_listwindow(box, wx, wy + iheight, ww, wh);
					set_listslider(box);
					}
				break;
				
			case WA_UPLINE:
				if (box_manager[box].list_page > 0) 
					{
					box_manager[box].list_page--;
					blt_copy(NULL, wx, wy + tx_height + iheight, 
									 NULL, wx, wy + (tx_height << 1) + iheight, 
									 ww, wh - (tx_height << 1) - iheight, S_ONLY);
					redraw_listwindow(box, 
														wx, wy + tx_height + iheight, 
														ww, tx_height);
					set_listslider(box);
					}
				break;
				
			case WA_DNLINE:
				if (box_manager[box].list_page + ((wh - iheight) / th - 1) < box_manager[box].box_entries)
					{
					box_manager[box].list_page++;
					blt_copy(NULL, wx, wy + (tx_height << 1) + iheight, 
									 NULL, wx, wy + tx_height + iheight, 
									 ww, wh - (tx_height << 1) - iheight, S_ONLY);
					redraw_listwindow(box, 
														wx, wy + wh - tx_height - (wh % tx_height), 
														ww, tx_height + (wh % tx_height));
					set_listslider(box);
					}
				break;
				
			case WA_LFPAGE:
				if (box_manager[box].list_left > 0) 
					{
					box_manager[box].list_left -= ww / tw;
					if (box_manager[box].list_left < 0) box_manager[box].list_left = 0;
					redraw_listwindow(box, wx, wy, ww, wh);
					set_listslider(box);
					}
				break;
				
			case WA_RTPAGE:
				if (box_manager[box].list_left + (ww / tw) < hsize /*2 + 24 + 24  + 24 + 9 + 15*/)
					{
					box_manager[box].list_left += ww / tw;
					if (box_manager[box].list_left + (ww / tw) >= hsize/*2 + 24 + 24 + 24 + 9 + 15*/) 
						box_manager[box].list_left = hsize /*2 + 24 + 24 + 24 + 9 + 15 */ - ww / tw;

					redraw_listwindow(box, wx, wy, ww, wh);
					set_listslider(box);
					}
				break;
				
			case WA_LFLINE:
				if (box_manager[box].list_left > 0)
					{
					box_manager[box].list_left--;
					blt_copy(NULL, wx, wy + iheight, NULL, 
												 wx + tx_width, wy + iheight, 
												 ww - tx_width, wh - iheight, S_ONLY);
					redraw_listwindow(box, wx, wy + iheight, tx_width, wh - iheight);
					set_listslider(box);
					}
				break;
				
			case WA_RTLINE:
				if (hsize /*(2 + 24 + 24 + 24 + 9 + 15)*/ - box_manager[box].list_left > ww / tw)
					{
					box_manager[box].list_left++;
					blt_copy(NULL, wx + tx_width, wy + iheight, NULL, 
												 wx, wy + iheight, 
												 ww - tx_width, wh - iheight, S_ONLY);
					redraw_listwindow(box, wx + ww - tx_width - (ww % tx_width), wy + iheight, tx_width + (ww % tx_width), wh - iheight);
					set_listslider(box);
					}
				break;
			}
		break;
		}
		
	case WM_HSLID:
	  box_manager[box].list_left = (int)((long)msg[4] * (hsize /*24 + 24 + 24 + 9 + 15*/ - ww / tw) / 1000);
		redraw_listwindow(box, wx, wy, ww, wh);
		set_listslider(box);
		break;
		
	case WM_VSLID:
	  box_manager[box].list_page = (int)((long)msg[4] * (box_manager[box].box_entries - (wh - iheight) / th + 1) / 1000);
		redraw_listwindow(box, wx, wy, ww, wh);
		set_listslider(box);
		break;
	}			
}

/* ------------------------------
   | Open selected list entries |
   ------------------------------ */
void open_listselects(int box)
{
int i;

DEBUG();
for (i = 0; i < box_manager[box].box_entries; i++)
	if (box_manager[box].index[i].sel & 1)
		{
		if (view_mail(box, &box_manager[box].index[i], -1)) 
			{
			box_manager[box].index[i].sel &= 0xFC;
			save_box_index(box);
			}
		}
box_manager[box].list_marks = 0;
box_manager[box].list_marked = 0;
}

/* ------------------------------
   | Edit selected list entries |
   ------------------------------ */
void edit_listselects(int box)
{
int i;

DEBUG();
for (i = 0; i < box_manager[box].box_entries; i++)
	if (box_manager[box].index[i].sel & 1)
		{
		box_manager[box].list_marks--;
		box_manager[box].list_marked -= box_manager[box].index[i].body_len;
		box_manager[box].index[i].sel &= 0xFE;
		edit_mail(box, &box_manager[box].index[i]);
		break;
		}
redraw_all_listbuttons(box);
}

/* -------------------------------
   | List header selection popup |
   ------------------------------- */
static void list_columnpopup(int box)
{
OBJECT *poptree;
static int show_ids[] = {SHOWHEAD_FROM, SHOWHEAD_TO, SHOWHEAD_SUBJECT, SHOWHEAD_SIZE, 
												 SHOWHEAD_DATE, SHOWHEAD_ID, SHOWHEAD_MARKER};
int i, obj;

DEBUG();
rsrc_gaddr(R_TREE, SHOWHEAD_POPUP, &poptree);

for (i = 0; i < 7; i++)
	if (box_manager[box].box_cols[i] > 0)
		CheckObj(poptree, show_ids[i]);
	else
		UncheckObj(poptree, show_ids[i]);

if (boxes[box].type == 0 || mail_options.allheads)
	EnableObj(poptree, SHOWHEAD_FROM);
else
	{
	DisableObj(poptree, SHOWHEAD_FROM);
	UncheckObj(poptree, SHOWHEAD_FROM);
	}
	
if (boxes[box].type == 1 || boxes[box].type == 3 || mail_options.allheads)
	EnableObj(poptree, SHOWHEAD_TO);
else
	{
	DisableObj(poptree, SHOWHEAD_TO);
	UncheckObj(poptree, SHOWHEAD_TO);
	}
	
obj = popup(poptree);
for (i = 0; i < 7; i++)
	if (obj == show_ids[i])
		{
		int wx, wy, ww, wh;
		
		if (box_manager[box].box_cols[i] > 0)
			box_manager[box].box_cols[i] = 0;
		else
			box_manager[box].box_cols[i] = defsize[i];

		wind_get(box_manager[box].list_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);
		redraw_listwindow(box, wx, wy, ww, wh);
		set_listslider(box);
		save_box_index(box);

		break;
		}
}

static void list_contentpopup(int box)
{
int i;
OBJECT *poptree;
int wx, wy, ww, wh;

DEBUG();
if (box == box_number("QUEUE"))
	{
	rsrc_gaddr(R_TREE, OL_POPUP, &poptree);

	if (box_manager[box].list_marks > 0)
		{
		poptree[OPL_DEL].ob_state &= ~DISABLED;
		poptree[OPL_OPEN].ob_state &= ~DISABLED;
		if (box_manager[box].list_marks == 1)
			{
			for (i = 0; i < box_manager[box].box_entries; i++)
				if (box_manager[box].index[i].sel & 1)
					{
					if (strncmp(box_manager[box].index[i].subject, "RC: ", 4))
						EnableObj(poptree, OPL_EDIT);
					else
						DisableObj(poptree, OPL_EDIT);
					break;
					}
			}
		else
			DisableObj(poptree, OPL_EDIT);
		EnableObj(poptree, OPL_SEND);
		}
	else
		{
		DisableObj(poptree, OPL_DEL);
		DisableObj(poptree, OPL_OPEN);
		DisableObj(poptree, OPL_EDIT);
		DisableObj(poptree, OPL_SEND);
		}
			
	switch(popup(poptree))
		{
		case OPL_ALL:		select_all_list(box); 	break;
		case OPL_DEL:		delete_listmail(box);  break;
		case OPL_OPEN:		
			{
			open_listselects(box);
			break;
			}
		case OPL_EDIT:	
			{
			edit_listselects(box);
			break;
			}
		case OPL_SEND:	send_idqueue("\0", FALSE);	break;
		case OPL_CLOS:	close_listwindow(box); 	enabler(); 	break;
		}
	}
else
	{
	rsrc_gaddr(R_TREE, L_POPUP, &poptree);

	if (box_manager[box].list_marks > 0)
		{
		EnableObj(poptree, LP_DEL);
		EnableObj(poptree, LP_OPEN);
		EnableObj(poptree, LP_FWD);
		if (!boxes[box].type && box_manager[box].list_marks == 1)
			EnableObj(poptree, LP_REPL);
		else
			DisableObj(poptree, LP_REPL);
		if (boxes[box].type)
			EnableObj(poptree, LP_AGAIN);
		else
			DisableObj(poptree, LP_AGAIN);

		EnableObj(poptree, LP_MARKREAD);
		EnableObj(poptree, LP_MARKUNREAD);
		}
	else
		{
		DisableObj(poptree, LP_DEL);
		DisableObj(poptree, LP_OPEN);
		DisableObj(poptree, LP_FWD);
		DisableObj(poptree, LP_REPL);
		DisableObj(poptree, LP_AGAIN);
		DisableObj(poptree, LP_MARKREAD);
		DisableObj(poptree, LP_MARKUNREAD);
		}
			
	switch(popup(poptree))
		{
		case LP_ALL:		select_all_list(box); 	break;
		case LP_DEL:		delete_listmail(box);  	break;
		case LP_OPEN:		
			{
			for (i = 0; i < box_manager[box].box_entries; i++)
				if (box_manager[box].index[i].sel & 1)
					{
					if (view_mail(box, &box_manager[box].index[i], -1)) 
						{
						box_manager[box].index[i].sel &= 0xFD;
						save_box_index(box);
						}
					break;
					}
			break;
			}
			
		case LP_FWD:		
			forward_mail(box);									
			break;
			
		case LP_REPL:		
			reply_mail(box);										
			break;

		case LP_AGAIN:	send_again(box);										break;
		case LP_CLOSE:	close_listwindow(box); 	enabler(); 	break;
		
		case LP_MARKREAD:
			{
			for (i = 0; i < box_manager[box].box_entries; i++)
				if (box_manager[box].index[i].sel & 1)
					box_manager[box].index[i].sel &= ~2;

			save_box_index(box);
			wind_get(box_manager[box].list_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);
			redraw_listwindow(box, wx, wy + iheight, ww, wh - iheight);
			break;
			}

		case LP_MARKUNREAD:
			{
			for (i = 0; i < box_manager[box].box_entries; i++)
				if (box_manager[box].index[i].sel & 1)
					box_manager[box].index[i].sel |= 2;
					
			save_box_index(box);
			wind_get(box_manager[box].list_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);
			redraw_listwindow(box, wx, wy + iheight, ww, wh - iheight);
			break;
			}
			
		case LP_EDITFILTER:
			edit_filters(box);
			break;
			
		case LP_APPLYFILTER:
			apply_filter(box);
			break;
		}
	}
}

/* ------------------------
   | Click on mail window |
   ------------------------ */
void list_button(int box)
{
int i, j;
int wx, wy, ww, wh;

DEBUG();
wind_get(box_manager[box].list_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);

if (evnt.bstate & 2)
	{
	if (evnt.y > wy + iheight && evnt.y < wy + tx_height + iheight)
		list_columnpopup(box);
	else
		list_contentpopup(box);
	}
else
	{
	if (evnt.y >= wy && evnt.y < wy + iheight)
		{
		list_button_action(box);
		return;
		}
		
	if (evnt.y > wy + iheight && evnt.y < wy + tx_height + iheight)
		{
		set_sorting(box);
		return;
		}
		
	if (evnt.x < wx || evnt.x > wx + ww - 1 ||
			evnt.y < wy + tx_height + iheight || evnt.y > wy + iheight + wh - 1) 
		return;

	i = box_manager[box].list_page + (evnt.y - wy - tx_height - iheight) / tx_height;
	if (i >= 0 && i < box_manager[box].box_entries)
		{
		EVNTDATA ev;

	 	graf_mkstate(&ev);
 	
		if ((box_manager[box].index[i].sel & 1) && clicks < 2 && (ev.bstate & 1))
			drag_mail(box, box_manager[box].list_page, min((wh - iheight) / tx_height, 
								box_manager[box].box_entries - box_manager[box].list_page));
		else
			{
			int prev_marks = box_manager[box].list_marks;
			int low, high, w, h;
			
			if ((ev.bstate & 1) && clicks == 1)
				{
				graf_rubbox(evnt.x, evnt.y, 50, 2, &w, &h);
				low = i;
				high = box_manager[box].list_page + (evnt.y + h - wy - tx_height - iheight) / tx_height;
				if (high < 0)	high = 0;
				if (high >= box_manager[box].box_entries) high = box_manager[box].box_entries - 1;
				}
			else
				low = high = i;
			
			if (!(ev.kstate & 3) || clicks == 2)
				for (j = 0; j < box_manager[box].box_entries; j++)
					if (box_manager[box].index[j].sel & 1)
						{
						box_manager[box].index[j].sel ^= 1;
						box_manager[box].list_marked -= box_manager[box].index[j].body_len;
						box_manager[box].list_marks--;
							
						if (j >= box_manager[box].list_page && j < box_manager[box].list_page + (wh + tx_height - 1 - iheight) / tx_height)
							redraw_listwindow(box, 
								wx, wy + (j - box_manager[box].list_page) * tx_height + tx_height + iheight, 
								ww, tx_height);
						}
	
			if (clicks == 2)
				{
				if (box == box_number("QUEUE"))
					{
					if (strncmp(box_manager[box].index[i].subject, "RC: ", 4))
						edit_mail(box, &box_manager[box].index[i]);
					}
				else
					if (view_mail(box, &box_manager[box].index[i], -1))
						{
						box_manager[box].index[i].sel &= 0xFD;
						save_box_index(box);
						}
				}
			else
				{
				int sel;
					
				i = low;
				sel = box_manager[box].index[i].sel ^ 1;
				while(i <= high)
					{
					if (box_manager[box].index[i].sel != sel)
						{
						box_manager[box].index[i].sel = sel;
						if (sel & 1)
							{
							box_manager[box].list_marked += box_manager[box].index[i].body_len;
							box_manager[box].list_marks++;
							}
						else
							{
							box_manager[box].list_marked -= box_manager[box].index[i].body_len;
							box_manager[box].list_marks--;
							}
						}
					i++;
					}
				redraw_listwindow(box, wx, wy + (low - box_manager[box].list_page) * tx_height + tx_height + iheight, ww, (high - low + 1) * tx_height);
				}
			
			if ((!prev_marks || !box_manager[box].list_marks) && prev_marks != box_manager[box].list_marks)
				redraw_all_listbuttons(box);
			else
				if ((prev_marks == 1 || box_manager[box].list_marks == 1) && prev_marks != box_manager[box].list_marks)
					redraw_one_selbuttons(box);
			}
		}
	else
		{
		for (j = 0; j < box_manager[box].box_entries; j++)
			if (box_manager[box].index[j].sel & 1)
				{
				box_manager[box].index[j].sel ^= 1;
				box_manager[box].list_marked -= box_manager[box].index[j].body_len;
				box_manager[box].list_marks--;
				if (!box_manager[box].list_marks) redraw_all_listbuttons(box);
				
				if (j >= box_manager[box].list_page && j < box_manager[box].list_page + (wh + tx_height - 1 - iheight) / tx_height)
					redraw_listwindow(box,	
						wx, wy + (j - box_manager[box].list_page) * tx_height + tx_height + iheight, 
						ww, tx_height);
				}
		}
			
	enabler();
	set_listinfo(box);
	}
}

/* ----------------------------
   | Select all list messages |
   ---------------------------- */
void select_all_list(int box)
{
int i;
int wx, wy, ww, wh;

DEBUG();
for (i = 0; i < box_manager[box].box_entries; i++)
	box_manager[box].index[i].sel |= 1;
	
box_manager[box].list_marks = box_manager[box].box_entries;
box_manager[box].list_marked = box_manager[box].box_total;

wind_get(box_manager[box].list_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);
redraw_listwindow(box, wx, wy, ww, wh);

set_listinfo(box);
list_enable(box);
}

/* ----------------------------
   | Select all list messages |
   ---------------------------- */
void unselect_all_list(int box)
{
int i;
int wx, wy, ww, wh;

DEBUG();
for (i = 0; i < box_manager[box].box_entries; i++)
	box_manager[box].index[i].sel &= 0xFE;

box_manager[box].list_marks = 0;
box_manager[box].list_marked = 0;

if (box_manager[box].list_wind > -1)
	{	
	wind_get(box_manager[box].list_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);
	redraw_listwindow(box, wx, wy, ww, wh);

	set_listinfo(box);
	list_enable(box);
	}
}

/* --------------------------------------------
   | Return if window is a opened list window |
   -------------------------------------------- */
int is_listwindow(int hndl)
{
int i;

DEBUG();
for (i = 0; i < box_count; i++)
	if (box_manager[i].list_wind > -1 && box_manager[i].list_wind == hndl)
		return TRUE;
return FALSE;
}

/* --------------------------------------
   | Return box index for a list window |
   -------------------------------------- */
int window_box(int hndl)
{
int i;

DEBUG();
for (i = 0; i < 24; i++)
	if (box_manager[i].list_wind > -1 && box_manager[i].list_wind == hndl)
		return i;
return -1;
}

/* ----------------------------
   | Delete messages from box |
   ---------------------------- */
void delete_listmail(int box)
{
char buf[256];
int n, l, ret;
int wx, wy, ww, wh;

DEBUG();
if (mail_options.confirm_delete)
	{
	sprintf(buf, deletemsg, box_manager[box].list_marks, boxes[box].desc);
	if (form_alert(2, buf) != 1)
		return;
	}
	
base_path(buf);
strcat(buf, boxes[box].file);
strcat(buf, "\\");

l = (int)strlen(buf);

n = ffirst_sellist(box);
while (n > -1)
	{
	strcpy(buf + l, box_manager[box].index[n].file);
	
	ret = Fdelete(buf); 
	if (!ret || ret == -33)
		{
		box_manager[box].list_marked -= box_manager[box].index[n].body_len;
		box_manager[box].list_marks--;
		
		delete_index(box_manager[box].index[n].file, box);
		n = ffirst_sellist(box);
		}
	else	
		n = fnext_sellist(box);
	}
wind_get(box_manager[box].list_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);
redraw_listwindow(box, wx, wy, ww, wh);

save_box_index(box);
list_enable(box);
set_listinfo(box);
set_listslider(box);
}

/* ----------------------------
   | Drag mail to another box |
   ---------------------------- */
void drag_mail(int box, int page, int num)
{
int off_x, off_y, mousewind;
int last_x = evnt.x, last_y = evnt.y;
int wx, wy, ww, wh;
int cxy[4], sel_box;

DEBUG();
wind_update(BEG_MCTRL);

wind_get(ROOT, WF_WORKXYWH, &cxy[0], &cxy[1], &cxy[2], &cxy[3]);
cxy[2] += cxy[0] - 1;
cxy[3] += cxy[1] - 1;

wind_get(box_manager[box].list_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);
off_x = evnt.x - wx;
off_y = evnt.y - (wy + tx_height) - iheight;

drag_list(box, page, num, evnt.x - off_x, evnt.y - off_y, ww, cxy);
sel_box = box_move(evnt.x, evnt.y);
do
	{
  graf_mkstate( &evnt);
	which = evnt_multi(MU_BUTTON|MU_TIMER,
					  1, 1, 0,
						0, &empty,
						0, &empty,
						NULL,
						50L,
						&evnt,
						&k_return, &clicks);

	if (last_x != evnt.x || last_y != evnt.y)
		{
		drag_list(box, page, num, last_x - off_x, last_y - off_y, ww, cxy);

		mousewind = wind_find(evnt.x, evnt.y);
		if (mousewind == box_wind)
			sel_box = box_move(evnt.x, evnt.y);
		else
			if (mousewind == tree_wind)
				sel_box = tree_select(evnt.x, evnt.y);
			else
				if (is_listwindow(mousewind))
					sel_box = window_box(mousewind);
				else
					sel_box = -1;
				
		if (sel_box == -1 || sel_box == box)
			graf_mouse(BUSYBEE, 0L);
		else
			if (boxes[sel_box].type >= 0)
				graf_mouse(ARROW, 0L);
			
		drag_list(box, page, num, evnt.x - off_x, evnt.y - off_y, ww, cxy);
		last_x = evnt.x;
		last_y = evnt.y;
		}

	}while(! (which & MU_BUTTON));

graf_mouse(ARROW, 0L);
drag_list(box, page, num, last_x - off_x, last_y - off_y, ww, cxy);

wind_update(END_MCTRL);

if (sel_box > -1 && sel_box != box)
	if (boxes[sel_box].type >= 0)
		{
	 	move_mail(box, sel_box);
		box_manager[box].list_marked = 0;
		box_manager[box].list_marks = 0;
		
		redraw_listwindow(box, wx, wy, ww, wh);
		
		if (box_manager[sel_box].list_wind > -1) 
			{
			wind_get(box_manager[sel_box].list_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);
			redraw_listwindow(sel_box, wx, wy, ww, wh);
			}
		set_listinfo(sel_box);
		set_listinfo(box);
		}
}

/* ----------------------------
   | Reply to a selected mail |
   ---------------------------- */
void reply_mail(int box)
{
int i;
/*
if (!cfg_options.smtpserver[0])
	if (!provider_sel())
		return;
*/
DEBUG();
for (i = 0; i < box_manager[box].box_entries; i++)
	if (box_manager[box].index[i].sel & 1)
		{
		do_reply(box, &box_manager[box].index[i], NULL, NULL, 0, 0L, -1, -1);
		break;
		}
}

/* ---------------------------
   | Save to a selected mail |
   --------------------------- */
void save_mail(int box)
{
int i;

for (i = 0; i < box_manager[box].box_entries; i++)
	if (box_manager[box].index[i].sel & 1)
		{
		do_save(box, &box_manager[box].index[i]);
		break;
		}
}

/* -------------------------
   | Print a selected mail |
   ------------------------- */
void print_mail(int box)
{
int i;

DEBUG();
if (!mail_options.printmode)
	if (form_alert(1, printmsg) != 1)
		return;

for (i = 0; i < box_manager[box].box_entries; i++)
	if (box_manager[box].index[i].sel & 1)
		{
#ifdef do_print
		do_print(box, &box_manager[box].index[i], -1);
#endif
		break;
		}
}

/* ---------------------------
   | Forward a selected mail |
   --------------------------- */
void forward_mail(int box)
{
int i;
/*
if (!cfg_options.smtpserver[0])
	if (!provider_sel())
		return;
*/
DEBUG();
for (i = 0; i < box_manager[box].box_entries; i++)
	if (box_manager[box].index[i].sel & 1)
		{
		do_forward(box, &box_manager[box].index[i]);
		break;
		}
}

/* ----------------------------
   | Send selected mail again |
   ---------------------------- */
void send_again(int box)
{
int i;
int wx, wy, ww, wh;
char bufs[51 * 2 + MAXFILE * 2 + 1];

DEBUG();
base_path(bufs);
strcat(bufs, boxes[box].file);
strcat(bufs, "\\");

for (i = 0; i < box_manager[box].box_entries; i++)
	if (box_manager[box].index[i].sel & 1)
		{
		strcpy(strrchr(bufs, '\\') + 1, box_manager[box].index[i].file);
		if (move_onemail(box, box_number("QUEUE"), i))
			i--;
		}

wind_get(box_manager[box].list_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);
redraw_listwindow(box, wx, wy, ww, wh);

box = box_number("QUEUE");
if (box_manager[box].list_wind > -1) 
	{
	wind_get(box_manager[box].list_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);
	redraw_listwindow(box, wx, wy, ww, wh);
	}
}

/* -------------------------
   | Set sort order/column |
   ------------------------- */
void set_sorting(int box)
{
int wx, wy, ww, wh;
int col, t_xy[8], tw;
int col_pos[6], col_size[6], i;

DEBUG();
set_default_text();
vqt_extent(vdi_handle, "x", t_xy);
tw = (t_xy[4] - t_xy[0]);

wind_get(box_manager[box].list_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);
col = (evnt.x - wx) / tw + box_manager[box].list_left;

calc_column_positions(box, col_pos, col_size);
for (i = 0; i < 6; i++)
	if (col_size[i])
		if (col == col_pos[i] + col_size[i] + 2)
			{
			resize_column(box, i);
			return;
			}
		else
			if (col >= col_pos[i] && col <= col_pos[i] + col_size[i])
				if (box_manager[box].box_sort != i + 1)
					box_manager[box].box_sort	= i + 1;
				else
					box_manager[box].box_sort	= -(i + 1);
	
sort_box(box);
redraw_listwindow(box, wx, wy, ww, wh);
save_box_index(box);
}

/* -----------------------------------
   | Handle keystroke in mail window |
   ----------------------------------- */
void list_keybd(int idx)
{
int wx, wy, ww, wh;
int t_xy[8], tw, th;
int col_pos[6], col_size[6], hsize;
		
DEBUG();
set_default_text();
vqt_extent(vdi_handle, "x", t_xy);
tw = (t_xy[4] - t_xy[0]);
th = (t_xy[5] - t_xy[1]);

calc_column_positions(idx, col_pos, col_size);
hsize = col_pos[5] + col_size[5]/* + 2*/;

wind_get(box_manager[idx].list_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);

if (k_return == 0x5100 && !evnt.kstate) 	/* Page down */
	{
	k_return = '2';
	evnt.kstate = 1;
	}

if (k_return == 0x4900 && !evnt.kstate) 	/* Page up */
	{
	k_return = '8';
	evnt.kstate = 1;
	}

switch(k_return)
	{
	case 0x4800:			/* Up */
		if (evnt.kstate & 4)
			{
			if (box_manager[idx].list_page > 0) 
				{
				box_manager[idx].list_page -= (wh - iheight) / th - 1;
				if (box_manager[idx].list_page < 0) box_manager[idx].list_page = 0;
				redraw_listwindow(idx, wx, wy, ww, wh);
				set_listslider(idx);
				}
			}
		else
			if (box_manager[idx].list_page > 0) 
				{
				box_manager[idx].list_page--;
				blt_copy(NULL, wx, wy + tx_height + iheight, 
								 NULL, wx, wy + (tx_height << 1) + iheight, 
								 ww, wh - (tx_height << 1) - iheight, S_ONLY);
				redraw_listwindow(idx, wx, wy + tx_height + iheight, 
													ww, tx_height);
				set_listslider(idx);
				}
		break;
		
	case 0x5000:			/* Down */
		if (evnt.kstate & 4)
			{
			if (box_manager[idx].list_page + ((wh - iheight) / th - 1) < box_manager[idx].box_entries)
				{
				box_manager[idx].list_page += (wh - iheight) / th - 1;
				if (box_manager[idx].list_page + ((wh - iheight) / th - 1) >= box_manager[idx].box_entries) 
					box_manager[idx].list_page = box_manager[idx].box_entries - (wh - iheight) / th + 1;

				redraw_listwindow(idx, wx, wy, ww, wh);
				set_listslider(idx);
				}
			}
		else
			if (box_manager[idx].list_page + ((wh - iheight) / th - 1) < box_manager[idx].box_entries)
				{
				box_manager[idx].list_page++;
				blt_copy(NULL, wx, wy + (tx_height << 1) + iheight, 
								 NULL, wx, wy + tx_height + iheight, 
								 ww, wh - (tx_height << 1) - iheight, S_ONLY);
				redraw_listwindow(idx, 
													wx, wy + wh - tx_height - (wh % tx_height), 
													ww, tx_height + (wh % tx_height));
				set_listslider(idx);
				}
		break;
		
	case 0x7300:			/*  Control + Left */
		if (box_manager[idx].list_left > 0) 
			{
			box_manager[idx].list_left -= ww / tw;
			if (box_manager[idx].list_left < 0) box_manager[idx].list_left = 0;
			redraw_listwindow(idx, wx, wy, ww, wh);
			set_listslider(idx);
			}
		break;
		
	case 0x7400:			/*  Control + Right */
		if (box_manager[idx].list_left + (ww / tw) < hsize /*2 + 24 + 24  + 24 + 9 + 15*/)
			{
			box_manager[idx].list_left += ww / tw;
			if (box_manager[idx].list_left + (ww / tw) >= hsize /*2 + 24 + 24 + 24 + 9 + 15*/) 
				box_manager[idx].list_left = /*2 + 24 + 24 + 24 + 9 + 15 */ hsize - ww / tw;

			redraw_listwindow(idx, wx, wy, ww, wh);
			set_listslider(idx);
			}
		break;
		
	case 0x4b00:			/*	Left */
		if (box_manager[idx].list_left > 0)
			{
			box_manager[idx].list_left--;
			blt_copy(NULL, wx, wy, NULL, wx + tx_width, wy, ww - tx_width, wh, S_ONLY);
			redraw_listwindow(idx, wx, wy, tx_width, wh);
			set_listslider(idx);
			}
		break;
		
	case 0x4d00:			/*  Right */
		if (/*(2 + 24 + 24 + 24 + 9 + 15)*/hsize - box_manager[idx].list_left > ww / tw)
			{
			box_manager[idx].list_left++;
			blt_copy(NULL, wx + tx_width, wy, NULL, wx, wy, ww - tx_width, wh, S_ONLY);
			redraw_listwindow(idx, wx + ww - tx_width - (ww % tx_width), wy, tx_width + (ww % tx_width), wh);
			set_listslider(idx);
			}
		break;
	}
}

/* ------------------------------------
   | Get button number in mail window |
   ------------------------------------ */
int get_listwind_button(int box, int mousex, int mousey)
{
int i;
int wx, wy, ww, wh;

DEBUG();
if (box_manager[box].list_wind == -1)
	return -1;
	
wind_get(box_manager[box].list_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);

if (mousey >= wy && mousey < wy + iheight)
	for (i = 0; i < 8; i++)
		if (mousex >= wx + lbut_pos[i] && mousex < wx + lbut_pos[i] + isize)
			return i;

return -1;
}

/* ----------------------
   | Select mail button |
   ---------------------- */
void redraw_listbutton(int box, int x)
{
GRECT t1;
int xy[4];
int wx, wy, ww, wh;

DEBUG();
calc_butpos();

wind_update(BEG_UPDATE);
graf_mouse(M_OFF, 0L);

wind_get(box_manager[box].list_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);

wind_get(box_manager[box].list_wind, WF_FIRSTXYWH, &t1.g_x, &t1.g_y, &t1.g_w, &t1.g_h);
while(t1.g_w && t1.g_h)
	{
	xy[0] = t1.g_x;
	xy[1] = t1.g_y;
	xy[2] = t1.g_x + t1.g_w - 1;
	xy[3] = t1.g_y + t1.g_h - 1;
	vs_clip(vdi_handle, 1, xy);

	draw_smallbutton(box, x, wx + lbut_pos[x], wy);

	vs_clip(vdi_handle, 0, xy);
		
	wind_get(box_manager[box].list_wind, WF_NEXTXYWH, &t1.g_x, &t1.g_y, &t1.g_w, &t1.g_h);
	}

graf_mouse(M_ON, 0L);
wind_update(END_UPDATE);
}

/* ---------------------------
   | Redraw all list buttons |
   --------------------------- */
void redraw_all_listbuttons(int box)
{
int i;

DEBUG();
for (i = 0; i < 8; i++)
	redraw_listbutton(box, i);
}

/* ---------------------------
   | Redraw all list buttons |
   --------------------------- */
void redraw_one_selbuttons(int box)
{
DEBUG();
redraw_listbutton(box, 1);
redraw_listbutton(box, 2);
redraw_listbutton(box, 7);
}

/* ---------------------
   | Press mail button |
   --------------------- */
void press_listbutton(int box, int n)
{
DEBUG();
box_manager[box].lbut_selected[n] = TRUE;
redraw_listbutton(box, n);

wait_mouse_release();
	
box_manager[box].lbut_selected[n] = FALSE;
redraw_listbutton(box, n);
}

/* -----------------------
   | Mail button pressed |
   ----------------------- */
void list_button_action(int box)
{
int but;

DEBUG();
but = get_listwind_button(box, evnt.x, evnt.y);
if (box_manager[box].lbut_disabled[but])
	return;

switch(but)
	{
	case 0:														/* Open */
		press_listbutton(box, 0);
		open_listselects(box);
		break;
		
	case 1:														/* Edit */
		press_listbutton(box, 1);
		edit_listselects(box);
		break;

	case 2:														/* Reply */
		press_listbutton(box, 2);
		reply_mail(box);									
		break;
				
	case 3:														/* Forward */
		press_listbutton(box, 3);
		forward_mail(box);									
		break;

	case 4:														/* Save */
		press_listbutton(box, 4);
		save_mail(box);
		break;
		
	case 5:														/* Print  */
		press_listbutton(box, 5);
		print_mail(box);
		break;

	case 6:														/* Delete */
		press_listbutton(box, 6);
		delete_listmail(box);
		break;
		
/*	case 7:														/* Info !!! */
		press_listbutton(box, 7);
		break;*/
		
	case 7:														/* Close	*/
		press_listbutton(box, 7);
		close_listwindow(box);	
		break;
	}
}

/* -----------------------------
   | Check for column resizing |
   ----------------------------- */
void column_resize(int box, int mouse_x, int mouse_y)
{
int wx, wy, ww, wh;
int col, t_xy[8], tw;
int col_pos[6], col_size[6], i;

DEBUG();
set_default_text();
vqt_extent(vdi_handle, "x", t_xy);
tw = (t_xy[4] - t_xy[0]);

wind_get(box_manager[box].list_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);

if (mouse_y < wy + iheight || mouse_x < wx || mouse_x >= wx + ww || mouse_y >= wy + wh)
	{
	set_normalmouse();
	return;
	}

col = (mouse_x - wx) / tw + box_manager[box].list_left;

calc_column_positions(box, col_pos, col_size);
for (i = 0; i < 6; i++)
	if (col_size[i])
		if (col == col_pos[i] + col_size[i] + 2)
			{
			set_sizemouse();	
			return;
			}
set_normalmouse();
}

/* -----------------
   | Resize column |
   ----------------- */
void resize_column(int box, int col)
{
static int maxsizes[] = {63, 63, 63, 11, 20, 22};
int col_pos[6], col_size[6];
EVNTDATA gev;
int xy[4];
int wx, wy, ww, wh, changed, old_size;
unsigned pattern, opattern;
long last;

DEBUG();
calc_column_positions(box, col_pos, col_size);

wind_get(box_manager[box].list_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);

vswr_mode(vdi_handle, MD_XOR);

xy[1] = wy + iheight;
xy[3] = wy + wh - 1;

xy[0] = xy[2] = wx - box_manager[box].list_left * tx_width + (col_pos[col] + col_size[col] + 2) * tx_width + tx_width / 2;
old_size = col_size[col];

wind_update(BEG_MCTRL);
graf_mouse(M_OFF, 0L);

vsl_color(vdi_handle, 1);
vsl_type(vdi_handle, 7);
vsl_width(vdi_handle, 1);
pattern = 0xF0F0;
vsl_udsty(vdi_handle, pattern);

v_pline(vdi_handle, 2, xy);

last = clock();
changed = FALSE;

do
	{
	evnt_multi(MU_BUTTON|MU_TIMER,
						 1, 1, 1,
						 0, &empty,
						 0, &empty,
						 NULL,
						 50L,
						 &gev,
						 &k_return, &clicks);
					 
	graf_mkstate(&gev);

	if (gev.x < xy[2] - tx_width / 2)
		{
		if (col_size[col] > 1)
			{
			col_size[col]--;
			changed = TRUE;
			}
		}
	else
		if (gev.x > xy[2] + tx_width / 2)
			{
			if (col_size[col] < maxsizes[col])
				{
				col_size[col]++;
				changed = TRUE;
				}
			}
		
	if (clock() - last > CLK_TCK / 16 || changed)
		{	
		opattern = pattern;
		pattern = (pattern << 1) | (pattern >> 15);

		if (!changed)
			{
			vsl_udsty(vdi_handle, pattern);
			v_pline(vdi_handle, 2, xy);
			}

		vsl_udsty(vdi_handle, opattern);
		v_pline(vdi_handle, 2, xy);
		
		if (changed)
			{
			xy[0] = xy[2] = wx - box_manager[box].list_left * tx_width + (col_pos[col] + col_size[col] + 2) * tx_width + tx_width / 2;
			vsl_udsty(vdi_handle, pattern);
			v_pline(vdi_handle, 2, xy);
			changed = FALSE;
			}
			
		last = clock();
		}
	
	}while(gev.bstate & 1);

vsl_udsty(vdi_handle, pattern);
v_pline(vdi_handle, 2, xy);

vswr_mode(vdi_handle, MD_REPLACE);

graf_mouse(M_ON, 0L);
wind_update(END_MCTRL);

if (old_size != col_size[col])
	{
	box_manager[box].box_cols[col] = col_size[col];
	redraw_listwindow(box, wx, wy, ww, wh);
	set_listslider(box);
	save_box_index(box);
	}	
}

