#include "extern.h"

#define UNDO_NONE		-1
#define UNDO_DELETE 0
#define UNDO_INSERT 1
#define UNDO_REPLACE 2

static int c_line, c_col;
static int c_page, c_left, c_topleft, possible;
long mark_start, mark_end;
int but_pos[12], but_disabled[12], but_selected[12];
int but_no[12] = {4-1, 6-1, 20-1, 23-1, 26-1, 29-1, 10-1, 12-1, 14-1, 16-1, 18-1, 2-1};
static char *last_ptr = NULL, *last_mem = NULL;
static int last_line = -1;

typedef struct
					{
					char 	*text;
					long 	offset;
					long 	length;
					int 	mode;
					int 	c_line, c_col;
					int		c_page, c_left;
					}UNDO_DATA;

static UNDO_DATA undo_stack[10];
static int undo_cnt;

/* ---------------------------------------
   | Calculate horizontal button offsets |
   --------------------------------------- */
void calc_butpos(void)
{
int ispace, ox;

DEBUG();
isize = tool_palheader.width;
ispace = isize / 2;
	
if (smallfont)
	iheight = tool_palheader.height / 2;
else
	iheight = tool_palheader.height;

		 but_pos[0] = 2;
ox = but_pos[1] = 2  + isize + 4;
ox = but_pos[2] = ox + isize + ispace + 4;
ox = but_pos[3] = ox + isize + 4;
ox = but_pos[4] = ox + isize + 4;
ox = but_pos[5] = ox + isize + 4;
ox = but_pos[6] = ox + isize + ispace + 4;
ox = but_pos[7] = ox + isize + 4;
ox = but_pos[8] = ox + isize + ispace + 4;
ox = but_pos[9] = ox + isize + 4;
ox = but_pos[10] = ox + isize + ispace + 4;
	   but_pos[11] = ox + isize + ispace + 4;

calc_listbutpos();
calc_viewbutpos();
calc_popbutpos();
}

/* --------------------
	 | Set button state |
	 -------------------- */
void set_button_states(void)
{
DEBUG();
memset(but_selected, 0, sizeof(but_selected));
memset(but_disabled, 0, sizeof(but_disabled));

but_disabled[2] =
but_disabled[3] =
but_disabled[5] = (mark_start == -1);

but_disabled[4] = !check_scrap();

but_selected[6] = new_buffer.confirm_rcpt;
but_selected[7] = new_buffer.confirm_read;

but_selected[8] = new_buffer.priority == 1;
but_selected[9] = new_buffer.priority == 2;
}

/* -----------------------------
   | Select mail editor button |
   ----------------------------- */
void select_mbbutton(int no)
{
DEBUG();
but_selected[0] = 
but_selected[1] = 
but_selected[2] = 
but_selected[3] = 
but_selected[4] = 
but_selected[5] = 
but_selected[10] = 
but_selected[11] = FALSE;

if (no != -1 && no != 6 && no != 7 && no != 8 && no != 9)
	if (new_buffer.mime_allowed  || no != 1)
		but_selected[no] = TRUE;
}
   
/* -------------------------------------
   | Enable menu entries in pop window |
   ------------------------------------- */
void edit_enable(void)
{
DEBUG();
menu_ienable(menu_adr, M_EDITATT, new_buffer.mime_allowed);
menu_icheck(menu_adr, M_WRAP, new_buffer.word_wrap);
menu_ienable(menu_adr, M_WRAP, TRUE);

menu_ienable(menu_adr, M_CUT, mark_start != -1);
menu_ienable(menu_adr, M_COPY, mark_start != -1);
menu_ienable(menu_adr, M_DEL, mark_start != -1);
menu_ienable(menu_adr, M_PASTEFILE, c_line >= 0);

menu_ienable(menu_adr, M_SELALL, new_buffer.body_len > 0);

menu_ienable(menu_adr, M_SEARCH, 	TRUE);
menu_ienable(menu_adr, M_REPLACE, TRUE);

menu_ienable(menu_adr, M_UNDO, undo_cnt > 0);
}

/* -----------------------
   | Set new left border |
   ----------------------- */
void new_left(void)
{
int old_left = c_left;

DEBUG();
c_left = c_col - (c_col % (possible - 10));
c_col -= c_left;
if (c_left != old_left)
	{
	force_bodyredraw();
	set_mailslider();
	}
}

/* --------------
   | Set slider |
   -------------- */
void set_mailslider(void)
{
int xy[6], slid_size, slid_pos;
int old;
int last;

DEBUG();
if (no_refresh) return;

calc_bodyarea(xy);
xy[2] = xy[2] - xy[0] + 1;
xy[3] = xy[3] - xy[1] + 1;

possible = xy[3] / xy[5];
if (c_line >= 0)
	{
	cursor_off();

	old = c_page;
	while (c_line >= possible)
		{
		c_page++;
		c_line--;
		}
	
	if (old != c_page)
		if (old + 1 == c_page)
			{
		  blt_copy(NULL, xy[0], xy[1] + tx_height, NULL, xy[0], xy[1], xy[2], xy[3] - tx_height, S_ONLY);
			redraw_mailwindow(xy[0], xy[1] + xy[3] - tx_height, xy[2], tx_height);
			}
		else
			force_bodyredraw();

	cursor_on();
	}
	
if (possible >= new_buffer.body_lines)
	{
	slid_size = 1000;
	slid_pos = 0;
	}
else
	{
	slid_size = (int)(1000L * possible / (new_buffer.body_lines + 1));
	slid_pos = (int)(1000L * c_page / (new_buffer.body_lines - possible + 1));
	}

wind_get_int(mail_wind, WF_VSLSIZE, &last);
if (slid_size != last)
	wind_set_int(mail_wind, WF_VSLSIZE, slid_size);
	
wind_get_int(mail_wind, WF_VSLIDE, &last);
if (slid_pos != last)	
	wind_set_int(mail_wind, WF_VSLIDE, slid_pos);

possible = xy[2] / xy[4];
if (c_col >= 0)
	{
	old = c_left;
	while (c_col >= possible)
		{
		c_left += possible - 10;
		c_col -= possible - 10;
		}
	
	if (old != c_left)
		force_bodyredraw();
	}
	
if (possible >= new_buffer.max_length)
	{
	slid_size = 1000;
	slid_pos = 0;
	}
else
	{
	slid_size = (int)(1000L * possible / new_buffer.max_length);
	slid_pos = (int)(1000L * c_left / (new_buffer.max_length - possible));
	}

wind_get_int(mail_wind, WF_HSLSIZE, &last);
if (slid_size != last)
	wind_set_int(mail_wind, WF_HSLSIZE, slid_size);
	
wind_get_int(mail_wind, WF_HSLIDE, &last);
if (slid_pos != last)	
	wind_set_int(mail_wind, WF_HSLIDE, slid_pos);
}   
   
/* ---------------------------
   | Get length of body line |
   --------------------------- */
int body_linelength(char *ed)
{
long sz;
int ll;
char *a;

DEBUG();
if (!ed)
	return 0;
	
ll = 0;
sz = new_buffer.body_len - (ed - new_buffer.body);
a = ed;
while (*a != '\r' && sz > 0)
	{
	a++;
	sz--;
	ll++;
	}
return ll;
}

/* -------------------------
   | Clear body line cache |
   ------------------------- */
void clear_bodyline_cache(char *ptr)
{
DEBUG();
if (!ptr || last_ptr > ptr)
	{
	last_ptr = NULL;
	last_mem = NULL;
	last_line = -1;
	}
}

/* ---------------------------------
   | Get buffer pointer for line n |
   --------------------------------- */
char *get_body_buffer(int line)
{
char *ed;
int l;
long sz;

DEBUG();
if (last_mem == new_buffer.body && last_line == line)
	{
	return last_ptr;
	}
	
if (line >= 0)
	{
	ed = new_buffer.body;
	sz = new_buffer.body_len;
	
	l = line;
	while (l--)
		{
		while(*ed != '\r' && sz)
			{
			ed++;
			sz--;
			}
			
		if (sz)
			{
			ed++;
			sz--;
			}
		}
	}
else
	return NULL;

	/* Line cache */
last_mem = new_buffer.body;
last_ptr = ed;
last_line = line;

return ed;
}	

/* ------------------------------
   | Get pointer to edit buffer |
   ------------------------------ */
char *get_editbuffer(int *n, char ***ptr, int **max_len)
{
char *ed = NULL;

DEBUG();
if (c_line == -1) 
	{
	*ptr = &new_buffer.to;
	*max_len = &new_buffer.to_max;	
	ed = new_buffer.to;
	}
	
*n = -2;	
if (mail_options.from_flg) 
	{ 
	if (c_line == *n) 
		{
		*ptr = &new_buffer.from;
		*max_len = &new_buffer.from_max;	
		ed = new_buffer.from;
		}
	(*n)--; 
	}
if (mail_options.replyto_flg) 
	{ 
	if (c_line == *n) 
		{
		*ptr = &new_buffer.replyto;
		*max_len = &new_buffer.replyto_max;	
		ed = new_buffer.replyto;
		}
	(*n)--; 
	}
if (mail_options.cc_flg) 	
	{ 
	if (c_line == *n)
		{ 
		*ptr = &new_buffer.cc;
		*max_len = &new_buffer.cc_max;	
		ed = new_buffer.cc;
		}
	(*n)--; 
	}
if (mail_options.bcc_flg) 	
	{ 
	if (c_line == *n)
		{ 
		*ptr = &new_buffer.bcc;
		*max_len = &new_buffer.bcc_max;	
		ed = new_buffer.bcc;
		}
	(*n)--; 
	}
if (mail_options.sub_flg) 	
	{ 
	if (c_line == *n) 
		{
		*ptr = &new_buffer.subject;
		*max_len = &new_buffer.subj_max;	
		ed = new_buffer.subject;
		}
	(*n)--; 
	}

return ed;
}

/* ------------------------------
   | Calculate top of mail body |
   ------------------------------ */
void calc_bodyarea(int *xy)
{
int wx, wy, ww, wh;
int l;

DEBUG();
wind_get(mail_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);

l = 1;								/* To */
if (mail_options.from_flg)	l++;
if (mail_options.replyto_flg)	l++;
if (mail_options.cc_flg) 	l++;
if (mail_options.bcc_flg) 	l++;
if (mail_options.sub_flg) 	l++;
if (mail_options.idline_flg) 	l++;

xy[0] = wx;
xy[1] = wy + (tx_height + 3) * l + iheight + 3;
xy[2] = wx + ww - 1;
xy[3] = wy + wh - 1;
xy[4] = tx_width;
xy[5] = tx_height;
}

/* --------------------
   | Open mail window |
   -------------------- */
void open_mailwindow(void)
{
GRECT wrec;

DEBUG();
wind_get_grect(ROOT, WF_WORKXYWH, &wrec);

mail_wind = wind_create(NAME|CLOSER|FULLER|MOVER|SIZER|UPARROW|DNARROW|
												VSLIDE|LFARROW|RTARROW|HSLIDE, &wrec);
wind_set_string(mail_wind, WF_NAME, mail_title);

wind_open(mail_wind, &wrec);
register_window(mail_wind);
c_line = -1;
c_col = 0;
c_page = 0;
c_left = 0;
c_topleft = 0;
undo_cnt = 0;
mark_start = mark_end = -1;
menu_ienable(menu_adr, M_NEWML, FALSE);
set_mailslider();

set_button_states();
edit_enable();
}

/* ---------------------
   | Close mail window |
   --------------------- */
int close_mailwindow(void)
{
int i, j;
	
DEBUG();
if (new_buffer.changed)
	if (form_alert(2, changed) == 2)
		return FALSE;

for (i = 0; i < undo_cnt; i++)
	if (undo_stack[i].mode == UNDO_INSERT || undo_stack[i].mode == UNDO_REPLACE)
		{
		free(undo_stack[i].text);
		undo_stack[i].mode = UNDO_NONE;
		}
undo_cnt = 0;

clear_buffer(&new_buffer);		

if (new_buffer.attach_count)
	{
	for (i = 0; i < new_buffer.attach_count; i++)
		{
		for (j = 0; j < epart_count; j++)
			if (new_buffer.attachments[i] == edit_parts[j].name)
				break;
				
		if (j == epart_count)
			free(new_buffer.attachments[i]);
		}
	free(new_buffer.attachments);
	free(new_buffer.att_encoding);
	new_buffer.attach_count = 0;
	}
	
if (edit_parts)
	{
	free(edit_parts);
	edit_parts = NULL;
	epart_count = 0;
	}

wind_close(mail_wind);
unregister_window(mail_wind);
wind_delete(mail_wind);
mail_wind = -1;
menu_ienable(menu_adr, M_NEWML, TRUE);
enabler();

return TRUE;
}

/* -----------------------------
   | Redraw top of mail window |
   ----------------------------- */
void redraw_mailtop(int *clip)
{
int xy[4];
int wx, wy, ww, wh;
int l, n;
int th = tx_height + 3;

DEBUG();
wind_get(mail_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);

l = 1;								/* To */
if (mail_options.from_flg)	l++;
if (mail_options.replyto_flg)	l++;
if (mail_options.cc_flg) 	l++;
if (mail_options.bcc_flg) 	l++;
if (mail_options.sub_flg) 	l++;
if (mail_options.idline_flg) 	l++;

wy += iheight;

xy[0] = wx;
xy[1] = wy;
xy[2] = wx + ww - 1;
xy[3] = wy + th * l + 2;

if (colours > 4)
	{
	vsf_interior(vdi_handle, FIS_SOLID);
	vsf_color(vdi_handle, 8);
	}
else
	vsf_interior(vdi_handle, FIS_HOLLOW);
v_bar(vdi_handle, xy);

xy[1] = xy[3];
vsl_type(vdi_handle, 1);
vsl_color(vdi_handle, 1);
vsl_width(vdi_handle, 1);
v_pline(vdi_handle, 2, xy);
xy[1] = xy[3] = wy;
v_pline(vdi_handle, 2, xy);

wy += 3;
draw_label		(wx + tx_width *  2, wy 		   ,h_to);
draw_editfield(wx + tx_width * 12, wy 		   , 59, 
							 new_buffer.to + ((c_line == -1) ? c_topleft : 0), 
							 (c_line == -1) ? mark_start : -32767, mark_end);

n = 1;
if (mail_options.from_flg)
	{
	draw_label		(wx + tx_width *  2, wy + th * n, h_from);
	draw_editfield(wx + tx_width * 12, wy + th * n++, 59, 
								 new_buffer.from + ((c_line == -n - 1) ? c_topleft : 0), 
							 	 (c_line == -n - 1) ? mark_start - c_topleft : -32767, mark_end - c_topleft);
	}

if (mail_options.replyto_flg)
	{
	draw_label		(wx + tx_width *  2, wy + th * n, h_replyto);
	draw_editfield(wx + tx_width * 12, wy + th * n++, 59, 
								 new_buffer.replyto + ((c_line == -n - 1) ? c_topleft : 0), 
							 	 (c_line == -n - 1) ? mark_start - c_topleft : -32767, mark_end - c_topleft);
	}
	
if (mail_options.cc_flg)
	{
	draw_label		(wx + tx_width *  2, wy + th * n, h_cc);
	draw_editfield(wx + tx_width * 12, wy + th * n++, 59, 
								 new_buffer.cc + ((c_line == -n - 1) ? c_topleft : 0), 
							 	 (c_line == -n - 1) ? mark_start - c_topleft : -32767, mark_end - c_topleft);
	}

if (mail_options.bcc_flg)
	{
	draw_label		(wx + tx_width *  2, wy + th * n, h_bcc);
	draw_editfield(wx + tx_width * 12, wy + th * n++, 59, 
								 new_buffer.bcc + ((c_line == -n - 1) ? c_topleft : 0), 
							 	 (c_line == -n - 1) ? mark_start - c_topleft : -32767, mark_end - c_topleft);
	}

if (mail_options.sub_flg)
	{	
	draw_label		(wx + tx_width *  2, wy + th * n, h_subject);
	draw_editfield(wx + tx_width * 12, wy + th * n++, 59, 
								 new_buffer.subject + ((c_line == -n - 1) ? c_topleft : 0), 
							 	 (c_line == -n - 1) ? mark_start - c_topleft : -32767, mark_end - c_topleft);
	}

if (mail_options.idline_flg)
	{
	GRECT wrec, crec;
	
	wrec.g_x = wx;	wrec.g_y = wy;
	wrec.g_w = ww;  wrec.g_h = wh;
	
	crec.g_x = clip[0]; 
	crec.g_y = clip[1];
	crec.g_w = clip[2] - clip[0] + 1;
	crec.g_h = clip[3] - clip[1] + 1;
	
	if (rc_intersect(&wrec, &crec))
		{
		draw_label(wx + tx_width *  2, wy + th * n, h_identity);
		editorselect[0].ob_x = wx + tx_width * 12;
		editorselect[0].ob_y = wy + th * n;
		strcpy(editorselect[SELECTTEXT].ob_spec.tedinfo->te_ptext, new_buffer.identity);
		dlg_draw(editorselect, ROOT, MAX_DEPTH, &crec);
	
		draw_label(wx + tx_width *  37, wy + th * n, h_signature);
		editorselect[0].ob_x = wx + tx_width * 48;
		strcpy(editorselect[SELECTTEXT].ob_spec.tedinfo->te_ptext, new_buffer.signature);
		dlg_draw(editorselect, ROOT, MAX_DEPTH, &crec);
		}
	}
}

/* --------------------
   | Redraw mail body |
   -------------------- */
void redraw_mailbody(void)
{
int xy[6];
char *buf, *lput;
unsigned char *mem, *memx, sc, ec;
long mem_len;
long pg;
int hg, i, mw, cpos, xpos, soff, eoff, reply_flg;

DEBUG();
calc_bodyarea(xy);

vsf_interior(vdi_handle, FIS_HOLLOW);
vr_recfl(vdi_handle, xy);

mem = (unsigned char *)new_buffer.body;
mem_len = new_buffer.body_len;

pg = c_page;
while(pg--)
	{
	while(mem_len && *mem != '\n' && *mem != '\r')
		{
		mem++;
		mem_len--;
		}
	
	if (mem_len)
		{
		if (mem_len > 1 && *mem != mem[1] && (mem[1] == '\r' || mem[1] == '\n'))
			{
			mem++;
			mem_len--;
			}
		
		mem++;
		mem_len--;
		}
	}

set_default_text();

vsf_color(vdi_handle, 1);
vsf_interior(vdi_handle, FIS_SOLID);
vswr_mode(vdi_handle, MD_TRANS);
hg = (xy[3] + xy[5] - 1) / xy[5];
mw = (xy[2] + xy[4] - 1 - 3) / xy[4];
buf = (char *)malloc(mw + 1);
for (i = 0; i < hg && mem_len; i++)
	{
	xpos = cpos = 0;
	lput = buf;
	memx = mem;
	soff = eoff = -1;
	
	reply_flg = (*mem == '>');
	
	while(mem_len && *mem != '\n' && *mem != '\r')
		{
		if (mem == (unsigned char *)new_buffer.body + mark_start) soff = cpos;
		if (mem == (unsigned char *)new_buffer.body + mark_end) 	eoff = cpos;
		
		if (*mem != '\t')
			{
			if (xpos >= c_left && cpos < mw)
				{
				*lput++ = *mem;
				cpos++;
				}
			mem++;
			xpos++;
			}
		else
			{
			do
				{
				if (xpos >= c_left && cpos < mw)
					{
					*lput++ = ' ';
					cpos++;
					}
				xpos++;
				}while(xpos % 8);
			mem++;
			}
			
		mem_len--;
		}

	if (cpos)
		{
		buf[cpos] = 0;
		
		if (mark_start != -1 &&
				memx < (unsigned char *)new_buffer.body + mark_end &&
				mem > (unsigned char *)new_buffer.body + mark_start)
			{
			vst_color(vdi_handle, mail_options.text_colour);
			if (soff == -1 && eoff == -1)
				{
				int ext[8], fxy[4];
				
				vst_color(vdi_handle, 0);
				vqt_extent(vdi_handle, buf, ext);
				fxy[0] = xy[0] + 3;
				fxy[1] = xy[1];
				fxy[2] = abs(ext[2] - ext[6]) - 1 + fxy[0];
				fxy[3] = abs(ext[3] - ext[7]) - 1 + fxy[1];
				vr_recfl(vdi_handle, fxy);
				v_gtext(vdi_handle, xy[0] + 3, xy[1], buf);
				vst_color(vdi_handle, 1);
				}
			else
				{
				int ext[8], fxy[4];

				if (soff > -1)
					{
					sc = buf[soff];
					buf[soff] = 0;
					v_gtext(vdi_handle, xy[0] + 3, xy[1], buf);
					buf[soff] = sc;
					}
				else
					soff = 0;
				
				if (eoff > -1)
					{
					ec = buf[eoff];
					buf[eoff] = 0;
					}
					
				vst_color(vdi_handle, 0);
				vqt_extent(vdi_handle, buf + soff, ext);
				fxy[0] = xy[0] + 3 + soff * tx_width;
				fxy[1] = xy[1];
				fxy[2] = abs(ext[2] - ext[6]) - 1 + fxy[0];
				fxy[3] = abs(ext[3] - ext[7]) - 1 + fxy[1];
				vr_recfl(vdi_handle, fxy);
				v_gtext(vdi_handle, xy[0] + 3 + soff * tx_width, xy[1], buf + soff);
				vst_color(vdi_handle, 1);
				
				if (eoff > -1)
					{
					buf[eoff] = ec;
					v_gtext(vdi_handle, xy[0] + 3 + eoff * tx_width, xy[1], buf + eoff);
					}
				}
			}		
		else
			{
			if (colours > 4)
				if (reply_flg)
					vst_color(vdi_handle, mail_options.quoted_colour);
				else
					vst_color(vdi_handle, mail_options.text_colour);
			v_gtext(vdi_handle, xy[0] + 3, xy[1], buf);
			}
		}

	if (mem_len)
		{
		if (mem_len > 1 && *mem != mem[1] && (mem[1] == '\r' || mem[1] == '\n')) 
			{
			mem++;
			mem_len--;
			}

		mem++;
		mem_len--;
		}
		
	xy[1] += xy[5];
	}
free(buf);
vswr_mode(vdi_handle, MD_REPLACE);
}

/* -------------------------
   | Draw a toolbar button |
   ------------------------- */
void draw_button(int no, int x, int y)
{
int bnum;

DEBUG();
bnum = but_no[no]; 
if (but_disabled[no])
	bnum += 2;
else
	if (but_selected[no])
		bnum++;
		
blt_copy(mw_toolbar, 0, bnum * iheight, NULL, x, y, isize, iheight, S_ONLY);
}

/* ----------------------------------------
   | Redraw toolbar of mail editor window |
   ---------------------------------------- */
void redraw_mailbar(void)
{
int wx, wy, ww, wh;
int x, w;

DEBUG();
wind_get(mail_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);

calc_butpos();

x = wx;
w = ww;
while (w > 0)
	{
	blt_copy(mw_toolbar, 0, 0 * iheight, NULL, x, wy, isize, iheight, S_ONLY);
	x += isize;
	w -= isize;
	}	

draw_button(0, wx + but_pos[0], wy);

if (new_buffer.mime_allowed)
	{
	if (new_buffer.attach_count > 0)
		but_no[1] = 8-1;
	else
		but_no[1] = 6-1;
	draw_button(1, wx + but_pos[1], wy);
	}
	
draw_button(2, wx + but_pos[2], wy);
draw_button(3, wx + but_pos[3], wy);
draw_button(5, wx + but_pos[5], wy);

draw_button(4, wx + but_pos[4], wy);

draw_button(6, wx + but_pos[6], wy);
draw_button(7, wx + but_pos[7], wy);

draw_button(8, wx + but_pos[8], wy);
draw_button(9, wx + but_pos[9], wy);

draw_button(10, wx + but_pos[10], wy);

draw_button(11, wx + but_pos[11], wy);
}

/* ----------------------
   | Redraw mail window |
   ---------------------- */
void redraw_mailwindow(int rx, int ry, int rw, int rh)
{
GRECT t1, t2;
int xy[4];
int wx, wy, ww, wh;

DEBUG();
if (no_refresh) return;

t2.g_x = rx;
t2.g_y = ry;
t2.g_w = rw;
t2.g_h = rh;

wind_update(BEG_UPDATE);
graf_mouse(M_OFF, 0L);

wind_get(mail_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);

wind_get(mail_wind, WF_FIRSTXYWH, &t1.g_x, &t1.g_y, &t1.g_w, &t1.g_h);
while(t1.g_w && t1.g_h)
	{
	if (rc_intersect(&t2, &t1))
		{
		xy[0] = t1.g_x;
		xy[1] = t1.g_y;
		xy[2] = t1.g_x + t1.g_w - 1;
		xy[3] = t1.g_y + t1.g_h - 1;
		vs_clip(vdi_handle, 1, xy);

		redraw_mailtop(xy);
		redraw_mailbar();
		redraw_mailbody();

		vs_clip(vdi_handle, 0, xy);
		}
		
	wind_get(mail_wind, WF_NEXTXYWH, &t1.g_x, &t1.g_y, &t1.g_w, &t1.g_h);
	}

graf_mouse(M_ON, 0L);
wind_update(END_UPDATE);
}

/* --------------------------
   | Message on mail window |
   -------------------------- */
void mail_window_message(int *msg)
{
int xy[6];

DEBUG();
calc_bodyarea(xy);
xy[2] = xy[2] - xy[0] + 1;
xy[3] = xy[3] - xy[1] + 1;

switch(msg[0])
	{
	case WM_REDRAW:
		cursor_off();
		redraw_mailwindow(msg[4], msg[5], msg[6], msg[7]);
		cursor_on();
		break;
		
	case WM_CLOSED:
		close_mailwindow();
		break;

	case WM_ARROWED:
		{
		cursor_off();
		switch(msg[4])
			{
			case WA_UPPAGE:
			  c_page -= xy[3] / tx_height;
			  if (c_page < 0) c_page = 0;
				redraw_mailwindow(xy[0], xy[1], xy[2], xy[3]);
				set_mailslider();
				break;
				
			case WA_DNPAGE:
			  c_page += xy[3] / tx_height;
			  if (c_page > new_buffer.body_lines + 1 - xy[3] / tx_height) 
			  	c_page = new_buffer.body_lines + 1 - xy[3] / tx_height;
				redraw_mailwindow(xy[0], xy[1], xy[2], xy[3]);
				set_mailslider();
				break;
				
			case WA_UPLINE:
				if (c_page > 0)
					{
				  c_page--;
				  blt_copy(NULL, xy[0], xy[1], NULL, xy[0], xy[1] + tx_height, xy[2], xy[3] - tx_height, S_ONLY);
					redraw_mailwindow(xy[0], xy[1], xy[2], tx_height);
					set_mailslider();
					}
				break;

			case WA_DNLINE:
			  if (c_page < new_buffer.body_lines + 1 - xy[3] / tx_height) 
			  	{
				  c_page++;
				  blt_copy(NULL, xy[0], xy[1] + tx_height, NULL, xy[0], xy[1], xy[2], xy[3] - tx_height, S_ONLY);
					redraw_mailwindow(xy[0], xy[1] + xy[3] - tx_height, xy[2], tx_height);
					set_mailslider();
					}
				break;
				
			case WA_LFPAGE:
				if (c_left > 0)
					{
				  c_left -= xy[2] / tx_width;
				  if (c_left < 0) c_left = 0;
					redraw_mailwindow(xy[0], xy[1], xy[2], xy[3]);
					set_mailslider();
					}
				break;
				
			case WA_RTPAGE:
				{
				if (c_left < new_buffer.max_length - (xy[2] - 3) / xy[4])
					{
				  c_left += xy[2] / tx_width;
					if (c_left > new_buffer.max_length - (xy[2] - 3) / xy[4])
						c_left = new_buffer.max_length - (xy[2] - 3) / xy[4];
					redraw_mailwindow(xy[0], xy[1], xy[2], xy[3]);
					set_mailslider();
					}
				break;
				}
				
			case WA_LFLINE:
				if (c_left > 0)
					{
				  c_left--;
				  blt_copy(NULL, xy[0] + 3, xy[1], NULL, xy[0] + 3 + tx_width, xy[1], xy[2] - tx_width - 3, xy[3], S_ONLY);
					redraw_mailwindow(xy[0] + 3, xy[1], tx_width, xy[3]);
					set_mailslider();
					}
				break;
				
			case WA_RTLINE:
				if (c_left < new_buffer.max_length - (xy[2] - 3) / xy[4])
					{
					c_left++;
				  blt_copy(NULL, xy[0] + 3 + tx_width, xy[1], NULL, xy[0] + 3, xy[1], xy[2] - tx_width - 3, xy[3], S_ONLY);
					redraw_mailwindow(xy[0] + xy[2] - tx_width, xy[1], tx_width, xy[3]);
					set_mailslider();
					}
				break;
			}
		cursor_on();
		}
		break;

	case WM_HSLID:
		{
		cursor_off();
	  c_left = (int)((long)msg[4] * (new_buffer.max_length - xy[2] / xy[4]) / 1000);
		redraw_mailwindow(xy[0], xy[1], xy[2], xy[3]);
		set_mailslider();
		cursor_on();
		break;
		}
		
	case WM_VSLID:
		{
		cursor_off();
	  c_page = (int)((long)msg[4] * (new_buffer.body_lines + 1 - xy[3] / xy[5]) / 1000);
		redraw_mailwindow(xy[0], xy[1], xy[2], xy[3]);
		set_mailslider();
		cursor_on();
		break;
		}
	}			
}

/* --------------------
   | Redraw mail body |
   -------------------- */
void force_bodyredraw(void)   
{
int xy[6];

DEBUG();
if (no_refresh) return;

calc_bodyarea(xy);
cursor_off();
redraw_mailwindow(xy[0], xy[1], xy[2] - xy[0], xy[3] - xy[1]);
cursor_on();
}

/* ----------------------------
   | Redraw whole mail window |
   ---------------------------- */
void redraw_wholemail(void)
{
int wx, wy, ww, wh;
char *ed, **ptr;
int n, *maxl;

if (mail_wind <= 0)
	return;

if (c_line < 0)
	{
	ed = get_editbuffer(&n, &ptr, &maxl);
	if (c_line < n + 1)
		{
		c_line = n + 1;
		ed = get_editbuffer(&n, &ptr, &maxl);
		if (ed)
			{
			c_col = (int)strlen(ed);
			if (c_col > 58)
				{
				c_topleft = (c_col / 30) * 30;
				c_col -= c_topleft;
				}
			else
				c_topleft = 0;
			}
		}
	else
		if (ed)
			if (c_col > strlen(ed))
				{
				c_col = (int)strlen(ed);
				if (c_col > 58)
					{
					c_topleft = (c_col / 30) * 30;
					c_col -= c_topleft;
					}
				else
					c_topleft = 0;
				}
	}
	
wind_get(mail_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);
redraw_mailwindow(wx, wy, ww, wh);
}

/* ----------------------------
   | Get mail cursor position |
   ---------------------------- */
void get_mailcursor(int *xy)
{
int t_xy[8];
int wx, wy, ww, wh;
int l;
int th, tw;

DEBUG();
wind_get(mail_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);
set_default_text();
vqt_extent(vdi_handle, "x", t_xy);
tw = (t_xy[4] - t_xy[0]);
th = (t_xy[5] - t_xy[1]) + 3;

if (c_line < 0)
	{
	xy[0] = wx + tw * 12 + c_col * tw;
	xy[1] = wy + iheight + 2 + th	* (-c_line - 1);
	}
else
	{
	l = 1;								/* To */
	if (mail_options.from_flg)	l++;
	if (mail_options.replyto_flg)	l++;
	if (mail_options.cc_flg) 	l++;
	if (mail_options.bcc_flg) 	l++;
	if (mail_options.sub_flg) 	l++;
	if (mail_options.idline_flg) 	l++;
	
	xy[0] = wx + tw * c_col + 3;
	xy[1] = wy + th * l + iheight + 3 + (th - 3) * c_line;
	}
xy[2] = tw;
xy[3] = th - 3;
}

/* --------------------------
   | Get mail line position |
   -------------------------- */
void get_mailline(int line, int *xy)
{
int wx, wy, ww, wh;
int l;
int th;

DEBUG();
wind_get(mail_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);
th = tx_height + 3;

if (line < 0)
	{
	xy[0] = wx + tx_width * 12;
	xy[1] = wy + iheight + 3 + th	* (-line - 1);
	}
else
	{
	l = 1;								/* To */
	if (mail_options.from_flg) l++;
	if (mail_options.replyto_flg) l++;
	if (mail_options.cc_flg) 	l++;
	if (mail_options.bcc_flg) 	l++;
	if (mail_options.sub_flg) 	l++;
	if (mail_options.idline_flg) 	l++;
	
	xy[0] = wx + 3;
	xy[1] = wy + th * l + iheight + 3 + (th - 3) * line;
	}
xy[2] = tx_width;
xy[3] = tx_height;
}

/* ----------------------
   | Redraw mail window |
   ---------------------- */
void redraw_mailedit(char *ed, GRECT *t2)
{
GRECT t1;
int xy[4];

DEBUG();
if (no_refresh) return;

wind_update(BEG_UPDATE);
graf_mouse(M_OFF, 0L);

wind_get(mail_wind, WF_FIRSTXYWH, &t1.g_x, &t1.g_y, &t1.g_w, &t1.g_h);
while(t1.g_w && t1.g_h)
	{
	if (rc_intersect(t2, &t1))
		{
		xy[0] = t1.g_x;
		xy[1] = t1.g_y;
		xy[2] = t1.g_x + t1.g_w - 1;
		xy[3] = t1.g_y + t1.g_h - 1;
		vs_clip(vdi_handle, 1, xy);
		draw_editfield(t2->g_x, t2->g_y, 59, ed, mark_start != -1 ? mark_start - c_topleft : -32767, mark_end - c_topleft);
		vs_clip(vdi_handle, 0, xy);
		}
		
	wind_get(mail_wind, WF_NEXTXYWH, &t1.g_x, &t1.g_y, &t1.g_w, &t1.g_h);
	}

graf_mouse(M_ON, 0L);
wind_update(END_UPDATE);
}

/* ----------------------
   | Redraw mail window |
   ---------------------- */
void redraw_bodytext(GRECT *t2)
{
GRECT t1;
int xy[4];

if (no_refresh) return;

wind_update(BEG_UPDATE);
graf_mouse(M_OFF, 0L);

set_default_text();
vsf_interior(vdi_handle, FIS_HOLLOW);
wind_get(mail_wind, WF_FIRSTXYWH, &t1.g_x, &t1.g_y, &t1.g_w, &t1.g_h);
while(t1.g_w && t1.g_h)
	{
	if (rc_intersect(t2, &t1))
		{
		xy[0] = t1.g_x;
		xy[1] = t1.g_y;
		xy[2] = t1.g_x + t1.g_w - 1;
		xy[3] = t1.g_y + t1.g_h - 1;
		vs_clip(vdi_handle, 1, xy);
		redraw_mailbody();
		vs_clip(vdi_handle, 0, xy);
		}
		
	wind_get(mail_wind, WF_NEXTXYWH, &t1.g_x, &t1.g_y, &t1.g_w, &t1.g_h);
	}

graf_mouse(M_ON, 0L);
wind_update(END_UPDATE);
}

/* --------------------------
   | Word wrap current line |
   -------------------------- */
int wrap(void)
{
char *ed;
int len, wrapped, add_empty, line, was_wrapped, wrap_offset;

DEBUG();
if (new_buffer.word_wrap)
	{
	add_empty = FALSE;
	line = c_line + c_page;
	was_wrapped = FALSE;
	wrap_offset = -1;
	
	do
		{
		ed = get_body_buffer(line);
		len = body_linelength(ed);
	
		wrapped = FALSE;
		if (len > new_buffer.editwidth)
			{
			int pos;
			
			pos = new_buffer.editwidth - 1;

			while(pos > 0 && isspace(((unsigned char *)ed)[pos]))
				pos--;
			
			while(pos > 0 && !isspace(((unsigned char *)ed)[pos]))
				pos--;

			if (pos)
				{
				if (line < new_buffer.body_lines)	
					{
					char *ed2 = get_body_buffer(line + 1);
					if (ed2[0] == '\r')
						add_empty = TRUE;
					}

				if (ed[pos] != ' ')
					{
					ed += pos;
					clear_bodyline_cache(ed);
					ins_char(&new_buffer.body, &new_buffer.body_len, &new_buffer.body_lines, &ed, ' '); /* Space added to avoid line counting */
					ed = get_body_buffer(line);	/* May be reallocated */
					}							
				ed[pos] = '\r';
				clear_bodyline_cache(ed);

				if (ed[len] == '\r' && ed + len < new_buffer.body + new_buffer.body_len - 1 && ed[len + 1] != '>')
					ed[len] = ' ';
				else
					new_buffer.body_lines++;
					
				if (was_wrapped)
					if (wrap_offset != -1)
						{
						c_line++;
						c_col = wrap_offset;
						c_left = 0;
						wrap_offset = -1;
						}

				if (line == c_line + c_page && c_col + c_left >= pos)
					wrap_offset = c_col + c_left - pos - 1;
				was_wrapped = TRUE;
				wrapped = TRUE;
				line++;
				}
			}
			
		}while (wrapped && !add_empty);

	if (add_empty)
		{
		ed = get_body_buffer(line);
		ed += body_linelength(ed);
		clear_bodyline_cache(ed);
		ins_char(&new_buffer.body, &new_buffer.body_len, &new_buffer.body_lines, &ed, '\r');
		ed = get_body_buffer(line);	/* May be reallocated */
		if (ed + body_linelength(ed) < new_buffer.body + new_buffer.body_len - 1)
			force_bodyredraw();
		}

	if (was_wrapped)
		{
		if (wrap_offset != -1)
			{
			c_line++;
			c_col = wrap_offset;
			c_left = 0;
			}
		new_left();
		force_bodyredraw();
		return TRUE;
		}
	}
return FALSE;
}

/* -------------------------
   | Auto complete address |
   ------------------------- */
void auto_complete(char *ed, int *max_len, char **ptr)
{
IDENTITY conf;

DEBUG();
if (getIdentity(new_buffer.identity, &conf) && conf.address_completion)
	{
	char *ptr1 = ed + c_topleft + c_col;
	
	while(ptr1 > ed && (isalnum(ptr1[-1]) || ptr1[-1] == '.' || ptr1[-1] == '_' || ptr1[-1] == '@')) 
		ptr1--;

	if (ptr1)
		{
		int fnd, bl;
		char buf[512];
		
		char *ptr2 = ptr1;
		while(*ptr2 && !isspace(*ptr2) && *ptr2 != ',')
			ptr2++;

		memcpy(buf, ptr1, ptr2 - ptr1);
		buf[ptr2 - ptr1] = 0;

		fnd = FALSE;
		if (buf[0])
			{
			if (conf.address_completion & 1)
				fnd = find_matchingrecent(buf);

			if (!fnd && (conf.address_completion & 2))
				fnd = find_matchingaddress(buf);
			}
			
		bl = (int)strlen(buf);
		if (fnd && bl != ptr2 - ptr1)
			{
			if (strlen(ed) + bl - (ptr2 - ptr1) + 2 > *max_len)
				{
				int offset1 = ptr1 - ed;
				int offset2 = ptr2 - ed;
				
				*max_len += 60;
				ed = *ptr = (char *)realloc(*ptr, *max_len);
				
				ptr1 = ed + offset1;
				ptr2 = ed + offset2;
				}

			mark_start = ptr2 - ed;
			mark_end = ptr1 + bl - ed;
									
			new_buffer.changed = TRUE;
			memmove(ptr1 + bl - (ptr2 - ptr1), ptr1, *max_len - (bl - (ptr2 - ptr1)) );
			ed[*max_len - 1] = 0;
			memcpy(ptr1, buf, bl);
			
			conf.address_completion = 0;
			}
		}
	}
}
			
/* -----------------------------------
   | Handle keystroke in mail window |
   ----------------------------------- */
void mail_keybd(void)
{
int n, xy[6], *max_len;
char *ed, **ptr;

DEBUG();
calc_bodyarea(xy);
xy[2] = xy[2] - xy[0] + 1;
xy[3] = xy[3] - xy[1] + 1;

ed = get_editbuffer(&n, &ptr, &max_len);

if (k_return == 0x5100 && !evnt.kstate) 	/* Page down */
	{
	k_return = '2';
	evnt.kstate = 1;
	}

if (k_return == 0x4900 && !evnt.kstate) 	/* Page up */
	{
	k_return = '8';
	evnt.kstate = 1;
	}
/*
if (k_return == 0x4700 && !evnt.kstate)	/* POS1 */
	{
	k_return = '4';
	evnt.kstate = 1;
	}
	*/
	
if (k_return == 0x4F00)		/* End */
	if (!evnt.kstate)
		{
		k_return = '6';
		evnt.kstate = 1;
		}
	else
		if (evnt.kstate == 4)
			{
			k_return = '7';
			evnt.kstate = 1;
			}
				
if (evnt.kstate & 3)													/* Shift */
	switch(k_return & 0xFF)
		{
		case 0x7F:														/* Shift+Delete: Delete line */
			if (c_line >= 0)
				{
				ed = get_body_buffer(c_line + c_page);
				if (ed && ed < new_buffer.body + new_buffer.body_len)
					{
					int i;
					
					unmark();
				
					i = body_linelength(ed);
					if (ed + i < new_buffer.body + new_buffer.body_len)
						{
						i++;
						new_buffer.body_lines--;
						}
					clear_bodyline_cache(ed);
					
					register_undo_insert(ed, i);
					memmove(ed, ed + i, new_buffer.body_len - i);
					new_buffer.body_len -= i;
					if (!new_buffer.body_len)
						free(new_buffer.body);
/*					while (i--)
						del_char(&new_buffer.body, &new_buffer.body_len, &new_buffer.body_lines, &ed);*/

					cursor_off();
					if (c_line + c_page > new_buffer.body_lines)
						{
						c_line = new_buffer.body_lines - c_page;
					  if (c_page > new_buffer.body_lines + 1 - xy[3] / tx_height) 
					  	{
					  	c_page = new_buffer.body_lines + 1 - xy[3] / tx_height;
					  	if (c_page < 0) c_page = 0;
					  	}
						ed = get_body_buffer(c_line + c_page);
						}
						
					c_col = body_linelength(ed);
					if (body_linelength(ed) < c_left + c_col)
						{
						c_col = body_linelength(ed);
						new_left();
						}
					if (!no_refresh) 
						{
						force_bodyredraw();
						cursor_on();
						set_mailslider();
						}
					}
				}
			return;
			
		case '6':																				/* Shift+Right: EOL */
			if (c_line < 0)
				{
				if (c_topleft + c_col < strlen(ed))
					{
					unmark();
					cursor_off();
			
					c_col = (int)strlen(ed);
					if (c_col > 58)
						{
						c_topleft = (c_col / 30) * 30;
						c_col -= c_topleft;
						}
					else
						c_topleft = 0;
	
					get_mailline(c_line, xy);		
					xy[2] *= 59;
					redraw_mailedit(ed, (GRECT *)xy);		
	
					if (!no_refresh) cursor_on();
					}
				}
			else
				{
				ed = get_body_buffer(c_line + c_page);
				if (c_left + c_col < body_linelength(ed))
					{
					unmark();
					cursor_off();
					c_col = body_linelength(ed);
					new_left();
					if (!no_refresh) cursor_on();
					}
				}
			return;
			
		case '4':																		/* Shift+Left: SOL */
			if (c_line < 0)
				{
				if (c_col > 0)
					{
					unmark();
					cursor_off();
					c_col = 0;
					if (c_topleft > 0)
						{
						c_topleft = 0;
						get_mailline(c_line, xy);		
						xy[2] *= 59;
						redraw_mailedit(ed, (GRECT *)xy);		
						}
					if (!no_refresh) cursor_on();
					}
				}
			else
				if (c_left + c_col > 0)
					{
					unmark();
					cursor_off();
					c_col = 0;
					new_left();
					if (!no_refresh) cursor_on();
					}
			return;
			
		case '8':																				/* Shift+Up: Page up */
			if (c_page > 0)
				{
				unmark();
				cursor_off();
			  c_page -= xy[3] / tx_height;
			  if (c_page < 0) c_page = 0;
				redraw_mailwindow(xy[0], xy[1], xy[2], xy[3]);
				set_mailslider();
				if (!no_refresh) cursor_on();
				}
			return;
			
		case '2':																					/* Shift+Down:Page down */
		  if (c_page < new_buffer.body_lines + 1 - xy[3] / tx_height)
				{
				unmark();
				cursor_off();
			  c_page += xy[3] / tx_height;
			  if (c_page > new_buffer.body_lines + 1 - xy[3] / tx_height) 
			  	c_page = new_buffer.body_lines + 1 - xy[3] / tx_height;
				redraw_mailwindow(xy[0], xy[1], xy[2], xy[3]);
				set_mailslider();
				if (!no_refresh) cursor_on();
				}
			return;

		case '7':																						/* Shift + POS1: End */
			if (c_page < new_buffer.body_lines + 1 - xy[3] / tx_height)
				{
				unmark();
				cursor_off();
		  	c_page = new_buffer.body_lines + 1 - xy[3] / tx_height;
		  	c_line = new_buffer.body_lines - c_page;
		  	c_col = 0;
		  	c_left = 0;
				redraw_mailwindow(xy[0], xy[1], xy[2], xy[3]);
				set_mailslider();
				}
			else
				if (c_page + c_line < new_buffer.body_lines)
					{
					unmark();
					cursor_off();
			  	c_line = new_buffer.body_lines - c_page;
			  	c_col = 0;
			  	c_left = 0;
					}
			return;
		}

if (ed)
	{
	if ((k_return & 0xFF) >= ' ' && ((char)k_return != 0x7F))
		{
		if (mark_start != -1)
			{
			memmove(ed + mark_start, ed + mark_end, *max_len - mark_end);
			mark_start = -1;
			}
			
		if (strlen(ed) + 2 > *max_len)
			{
			*max_len += 60;
			ed = *ptr = (char *)realloc(*ptr, *max_len);
			}
		
		new_buffer.changed = TRUE;
		memmove(ed + c_col + c_topleft + 1, ed + c_col + c_topleft, 
						*max_len - (c_col + c_topleft) - 1);
		ed[*max_len - 1] = 0;
		
		ed[c_topleft + c_col] = (char)k_return;

		if (n + 1 != c_line)
			auto_complete(ed, max_len, ptr);
			
		cursor_off();
		get_mailline(c_line, xy);		
		xy[2] *= 59;

		if (c_col + c_topleft < strlen(ed)) 
			{
			c_col++;
			if (c_col > 58)
				{
				c_topleft += 30;
				c_col -= 30;
				}
			}

		redraw_mailedit(ed, (GRECT *)xy);		
		if (!no_refresh) cursor_on();
		}
	}
else
	if ((k_return & 0xFF) >= ' ' && ((char)k_return != 0x7F))
		{
		if (mark_start != -1)	
			del_edit();

		cursor_off();

		wrap();			
		ed = get_body_buffer(c_line + c_page);
		ed += c_col + c_left;
		clear_bodyline_cache(ed);
		ins_char(&new_buffer.body, &new_buffer.body_len, &new_buffer.body_lines, &ed, k_return & 0xFF);
		ed = get_body_buffer(c_line + c_page);	/* May be reallocated */
		register_undo_delete(ed + c_col + c_left, 1);

		get_mailline(c_line, xy);		
		
		xy[0] += c_col * xy[2];
		xy[2] *= body_linelength(ed);
		redraw_bodytext((GRECT *)xy);		
		
		c_col++;
		if (c_left + c_col > new_buffer.max_length)
			new_buffer.max_length = c_left + c_col;
		if (!no_refresh) cursor_on();
		}

switch(k_return)
	{
	case 0x4700:		/* Pos 1 */
		if (c_page > 0)
			{
			unmark();
			cursor_off();
		  c_page = 0;
		  c_col = 0;
		  c_left = 0;
			c_line = 0;
			redraw_mailwindow(xy[0], xy[1], xy[2], xy[3]);
			set_mailslider();
			}
		else
			if (c_line > 0 || c_col + c_left > 0)
				{
				unmark();
				cursor_off();
			  c_col = 0;
			  c_left = 0;
				c_line = 0;
				}
		break;

	case 0x7300:			/* Control + Left */	
		if (c_line >= 0)
			{
			int flg;
			
			unmark();
			cursor_off();

			ed = get_body_buffer(c_line + c_page);
			for (flg = 0; flg <= TRUE; flg++)
				do
					{
					if (c_left + c_col > 0)	
						{
						c_col--;
						if (c_col < 0)
							{
							c_left -= possible - 10;
							c_col += possible - 10;
							force_bodyredraw();
							cursor_off();
							}
						}
					else
						if (c_line + c_page > 0)	/* Skip over SOL */
							{
							if (c_line)
								c_line--;
							else
								{
								c_page--;		
								if (!no_refresh)
									{
								  blt_copy(NULL, xy[0], xy[1], NULL, xy[0], xy[1] + tx_height, xy[2], xy[3] - tx_height, S_ONLY);
									redraw_mailwindow(xy[0], xy[1], xy[2], tx_height);
									}
								}
	
							ed = get_body_buffer(c_line + c_page);
							c_col = body_linelength(ed);
							new_left();
							set_mailslider();
							cursor_off();
							}
						else
							break;
							
					}while((c_line + c_page > 0 && c_left + c_col == 0 && flg)
								 || misalnum(((unsigned char *)ed)[c_col + c_left - flg]) == flg);

			if (!no_refresh) cursor_on();
			}
		break;
		
	case 0x4b00:			/*	Left */
		if (c_line < 0)
			{
			if (c_col + c_topleft > 0)	
				{
				unmark();
				cursor_off();
				c_col--;
				if (c_col < 1 && c_topleft)
					{
					c_col += 30;
					c_topleft -= 30;
					get_mailline(c_line, xy);		
					xy[2] *= 59;
					redraw_mailedit(ed, (GRECT *)xy);		
					}
				if (!no_refresh) cursor_on();
				}
			}
		else
			{
			if (c_left + c_col > 0)	
				{
				unmark();
				cursor_off();
				c_col--;
				if (c_col < 0)
					{
					c_left -= possible - 10;
					c_col += possible - 10;
					force_bodyredraw();
					}
				if (!no_refresh) cursor_on();
				}
			else
				if (c_line + c_page > 0)	/* Skip over SOL */
					{
					unmark();
					cursor_off();
					
					if (c_line)
						c_line--;
					else
						{
						c_page--;		
						if (!no_refresh)
							{
						  blt_copy(NULL, xy[0], xy[1], NULL, xy[0], xy[1] + tx_height, xy[2], xy[3] - tx_height, S_ONLY);
							redraw_mailwindow(xy[0], xy[1], xy[2], tx_height);
							}
						}

					ed = get_body_buffer(c_line + c_page);
					c_col = body_linelength(ed);
					new_left();
					set_mailslider();
					if (!no_refresh) cursor_on();
					}
			}
		break;
		
	case 0x7400:
		if (c_line >= 0)
			{
			int flg;
			
			unmark();
			cursor_off();

			ed = get_body_buffer(c_line + c_page);
			for (flg = TRUE; flg >= FALSE; flg--)
				do
					{
					if (c_left + c_col < body_linelength(ed))
						{
						c_col++;
						}
					else										/* Skip over EOL */
						{
						if (c_line + c_page < new_buffer.body_lines)
							{
							c_line++;
							c_col = 0;
							ed = get_body_buffer(c_line + c_page);
							new_left();
							}
						else
							break;
						}

					}while((c_line + c_page < new_buffer.body_lines && c_left + c_col == body_linelength(ed) && flg)
								 || misalnum(((unsigned char *)ed)[c_col + c_left]) == flg);

			if (!no_refresh) cursor_on();
			}
		break;

	case 0x4d00:			/*  Right */
		if (c_line < 0)
			{
			if (c_col < strlen(ed))	
				{
				unmark();
				cursor_off();
				c_col++;

				if (c_col > 58)
					{
					c_topleft += 30;
					c_col -= 30;

					get_mailline(c_line, xy);		
					xy[2] *= 59;
					redraw_mailedit(ed, (GRECT *)xy);		
					}
					
				if (!no_refresh) cursor_on();
				}
			}
		else									
			{
			unmark();
			cursor_off();
			ed = get_body_buffer(c_line + c_page);

			if (c_left + c_col < body_linelength(ed))
				{
				c_col++;
				}
			else										/* Skip over EOL */
				{
				if (c_line + c_page < new_buffer.body_lines)
					{
					c_line++;
					c_col = 0;
					ed = get_body_buffer(c_line + c_page);
					while(c_col + c_left < body_linelength(ed) && !misalnum(((unsigned char *)ed)[c_col + c_left]))
						c_col++;
					new_left();
					}
				}
			if (!no_refresh) cursor_on();
			}
		break;

	case 0x4800:			/* Up */
		unmark();
		cursor_off();
		if (c_line < 0 && c_topleft > 0)
			{
			c_topleft = c_col = 0;
			get_mailline(c_line, xy);		
			xy[2] *= 59;
			redraw_mailedit(ed, (GRECT *)xy);		
			}
			
		if (c_line + c_page > 0)
			{
			if (c_line)
				c_line--;
			else
				{
				c_page--;		
				if (!no_refresh)
					{
				  blt_copy(NULL, xy[0], xy[1], NULL, xy[0], xy[1] + tx_height, xy[2], xy[3] - tx_height, S_ONLY);
					redraw_mailwindow(xy[0], xy[1], xy[2], tx_height);
					}
				}
			}
		else
			if (!c_line)
				c_line = n + 1;
			else
				if (c_line < -1)
					c_line++;

		if (c_line < 0)
			{
			ed = get_editbuffer(&n, &ptr, &max_len);
			if (ed)
				{
				c_col = (int)strlen(ed);
				if (c_col > 58)
					{
					c_topleft = (c_col / 30) * 30;
					c_col -= c_topleft;
					}
				else
					c_topleft = 0;

				get_mailline(c_line, xy);		
				xy[2] *= 59;
				redraw_mailedit(ed, (GRECT *)xy);		
				}
			}
		else
			{
			ed = get_body_buffer(c_line + c_page);
			if (body_linelength(ed) < c_left + c_col)
				{
				c_col = body_linelength(ed);
				new_left();
				}
			set_mailslider();
			}
			
		if (!no_refresh) cursor_on();
		break;

	case 0x5000:			/* Down */
		unmark();
		cursor_off();
		if (c_line < 0 && c_topleft > 0)
			{
			c_topleft = c_col = 0;
			get_mailline(c_line, xy);		
			xy[2] *= 59;
			redraw_mailedit(ed, (GRECT *)xy);		
			}

		if (c_line == n + 1)
			c_line = 0;
		else
			if (c_line < 0)
				c_line--;
			else
				if (c_line + c_page < new_buffer.body_lines)
					c_line++;
					
		if (c_line < 0)
			{
			ed = get_editbuffer(&n, &ptr, &max_len);
			if (ed)
				{
				c_col = (int)strlen(ed);
				if (c_col > 58)
					{
					c_topleft = (c_col / 30) * 30;
					c_col -= c_topleft;
					}
				else
					c_topleft = 0;

				get_mailline(c_line, xy);		
				xy[2] *= 59;
				redraw_mailedit(ed, (GRECT *)xy);		
				}
			}
		else
			{
			ed = get_body_buffer(c_line + c_page);
			if (body_linelength(ed) < c_left + c_col)
				{
				c_col = body_linelength(ed);
				new_left();
				}
			set_mailslider();
			}
			
		if (!no_refresh) cursor_on();
		break;
		
	default:
		switch(k_return & 0xFF)
			{
			case 0x19:				/* Control - Y */
				if (c_line >= 0)
					{
					ed = get_body_buffer(c_line + c_page);
					if (ed && ed < new_buffer.body + new_buffer.body_len)
						{
						int i;
						
						unmark();
						i = body_linelength(ed);
						if (ed + i < new_buffer.body + new_buffer.body_len)
							{
							i++;
							new_buffer.body_lines--;
							}
						clear_bodyline_cache(ed);
		
						register_undo_insert(ed, i);
						if (ed + i < new_buffer.body + new_buffer.body_len)
							memmove(ed, ed + i, new_buffer.body + new_buffer.body_len - ed - i);
						new_buffer.body_len -= i;
						if (!new_buffer.body_len)
							free(new_buffer.body);
/*
						while (i--)
							del_char(&new_buffer.body, &new_buffer.body_len, &new_buffer.body_lines, &ed);
	*/
						cursor_off();
						if (c_line + c_page > new_buffer.body_lines)
							{
							c_line = new_buffer.body_lines - c_page;
					  	if (c_page > new_buffer.body_lines + 1 - xy[3] / tx_height) 
					  		{
						  	c_page = new_buffer.body_lines + 1 - xy[3] / tx_height;
						  	if (c_page < 0) c_page = 0;
						  	}							
							ed = get_body_buffer(c_line + c_page);
					  	}
						i = body_linelength(ed);
						if (i < c_left + c_col)
							{
							c_col = body_linelength(ed);
							new_left();
							}

						force_bodyredraw();
						if (!no_refresh) cursor_on();
						set_mailslider();
						}
					}
				break;
				
			case 0x7F:											/* Delete */
				if (c_line < 0)
					{
					if (ed && ed[c_col])
						{
						if (mark_start != -1)
							{
							memmove(ed + mark_start, ed + mark_end, *max_len - mark_end);
							mark_start = -1;
							}
						else
							{							
							new_buffer.changed = TRUE;
							memmove(ed + c_col + c_topleft, ed + c_col + c_topleft + 1, 
											strlen(ed) - c_col - c_topleft);
							}
											
						cursor_off();
						get_mailline(c_line, xy);		
						xy[2] *= 59;
						redraw_mailedit(ed, (GRECT *)xy);		
			
						if (!no_refresh) cursor_on();
						}
					}
				else
					{
					if (mark_start != -1)
						{
						del_edit();
						return;
						}
				
					ed = get_body_buffer(c_line + c_page);
					if (ed && ed + c_left + c_col < new_buffer.body + new_buffer.body_len)
						{
						int red = FALSE;
						
						ed += c_left + c_col;
						if (*ed == '\r')
							red = TRUE;
							
						clear_bodyline_cache(ed);
						del_char(&new_buffer.body, &new_buffer.body_len, &new_buffer.body_lines, &ed);
	
						if (c_line + c_page > new_buffer.body_lines)
							{
							c_line = new_buffer.body_lines - c_page;
						  if (c_page > new_buffer.body_lines + 1 - xy[3] / tx_height) 
						  	{
						  	c_page = new_buffer.body_lines + 1 - xy[3] / tx_height;
					  		if (c_page < 0) c_page = 0;
					  		}							
							}
							
						cursor_off();
						wrap();
						
						ed = get_body_buffer(c_line + c_page);
						if (body_linelength(ed) < c_left + c_col)
							{
							c_col = body_linelength(ed);
							new_left();
							}

						get_mailline(c_line, xy);		
						xy[0] += c_col * xy[2];
						xy[2] *= body_linelength(ed) + 1;
						if (red)
							force_bodyredraw();
						else
							redraw_bodytext((GRECT *)xy);		
						if (!no_refresh) cursor_on();
						set_mailslider();
						}
					}
				break;
				
			case 8:															/* Backspace */
				if (c_line < 0)
					{
					if (c_topleft + c_col > 0 && ed)
						{
						if (mark_start != -1)
							{
							memmove(ed + mark_start, ed + mark_end, *max_len - mark_end);
							mark_start = -1;
							}
							
						new_buffer.changed = TRUE;
						memmove(ed + c_topleft + c_col - 1, ed + c_topleft + c_col, strlen(ed) - c_col - c_topleft + 1);
				
						cursor_off();
			
						c_col--;
						if (c_col < 1 && c_topleft)
							{
							c_topleft -= 30;
							c_col += 30;
							}
						
						if (n + 1 != c_line)
							auto_complete(ed, max_len, ptr);
						
						get_mailline(c_line, xy);		
						xy[2] *= 59;
						redraw_mailedit(ed, (GRECT *)xy);		

						if (!no_refresh) cursor_on();
						}
					}
				else
					{
					unmark();
					cursor_off();
					if (c_line + c_page > 0 && !(c_left + c_col))
						{
						if (c_line)
							c_line--;
						else
							c_page--;
						ed = get_body_buffer(c_line + c_page);
						c_col = body_linelength(ed) + 1;
						new_left();
						}
					else									
						ed = get_body_buffer(c_line + c_page);
						
					if (ed && c_left + c_col > 0)
						{
						int red = FALSE;
						
						c_col--;
						ed += c_left + c_col;
						if (*ed == '\r')
							red = TRUE;
							
						clear_bodyline_cache(ed);
						del_char(&new_buffer.body, &new_buffer.body_len, &new_buffer.body_lines, &ed);

						if (c_line + c_page > new_buffer.body_lines)
							{
							c_line = new_buffer.body_lines - c_page;
						  if (c_page > new_buffer.body_lines + 1 - xy[3] / tx_height) 
						  	{
						  	c_page = new_buffer.body_lines + 1 - xy[3] / tx_height;
						  	if (c_page < 0) c_page = 0;
					  		}							
							ed = get_body_buffer(c_line + c_page);
							}

						ed = get_body_buffer(c_line + c_page);
						if (body_linelength(ed) < c_left + c_col)
							{
							c_col = body_linelength(ed);
							new_left();
							}

						get_mailline(c_line, xy);		
						xy[0] += c_col * xy[2];
						xy[2] *= body_linelength(ed) + 1;
						if (red)
							force_bodyredraw();
						else
							redraw_bodytext((GRECT *)xy);		
						set_mailslider();
						}
					if (!no_refresh) cursor_on();
					}
				break;

			case 9:																			/* Tab */
				if (c_line < 0)
					{
					unmark();
					cursor_off();
					if (c_line == n + 1)
						{
						c_line = 0;
						ed = get_body_buffer(c_line + c_page);
						if (body_linelength(ed) < c_left + c_col)
							{
							c_col = body_linelength(ed);
							new_left();
							}
						}
					else
						if (c_line < 0)
							c_line--;

					if (c_line < 0)
						{
						ed = get_editbuffer(&n, &ptr, &max_len);
						if (ed)
							{
							c_col = (int)strlen(ed);
							if (c_col > 58)
								{
								c_topleft = (c_col / 30) * 30;
								c_col -= c_topleft;
								}
							else
								c_topleft = 0;

							get_mailline(c_line, xy);		
							xy[2] *= 59;
							redraw_mailedit(ed, (GRECT *)xy);		
							}
						}
					if (!no_refresh) cursor_on();
					}
				else
					{
					unmark();
					cursor_off();
					
					wrap();
					
					ed = get_body_buffer(c_line + c_page);
					if (body_linelength(ed) < c_left + c_col)
						{
						c_col = body_linelength(ed);
						new_left();
						}
					ed += c_left + c_col;
					do
						{
						clear_bodyline_cache(ed);
						ins_char(&new_buffer.body, &new_buffer.body_len, &new_buffer.body_lines, &ed, ' ');
						ed = get_body_buffer(c_line + c_page); /* May be reallocated */

						get_mailline(c_line, xy);		
		
						xy[0] += c_col * xy[2];
						xy[2] *= body_linelength(ed);
						redraw_bodytext((GRECT *)xy);		
		
						c_col++;
						ed++;
						if (c_left + c_col > new_buffer.max_length)
							new_buffer.max_length = c_left + c_col;
						}while((c_left + c_col) & 7);
					if (!no_refresh) cursor_on();
					}
				break;
							
			case 27:											/* Escape */
				if (ed)
					{
					unmark();
					new_buffer.changed = TRUE;
					ed[0] = 0;

					cursor_off();
					get_mailline(c_line, xy);		
					xy[2] *= 59;
					c_topleft = c_col = 0;
					redraw_mailedit(ed, (GRECT *)xy);		
		
					if (!no_refresh) cursor_on();
					}
				break;
					
			case 13:											/* Return */
				{
				int me = mark_end;
				
				unmark();
				cursor_off();
				
				if (c_line < 0 && me > -1)
					{
					c_col = (int)strlen(ed);
					if (c_col < c_topleft || c_col - c_topleft > 58)
						{
						c_topleft = (c_col / 30) * 30;
						c_col -= c_topleft;
						}
					else
						c_topleft = 0;
	
					get_mailline(c_line, xy);		
					xy[2] *= 59;
					redraw_mailedit(ed, (GRECT *)xy);		
					}
				else
					{
					if (c_line < 0 && c_topleft > 0)
						{
						c_topleft = c_col = 0;
						get_mailline(c_line, xy);		
						xy[2] *= 59;
						redraw_mailedit(ed, (GRECT *)xy);		
						}
	
					if (c_line == n + 1)
						c_line = 0;
					else
						if (c_line < 0)
							c_line--;
						else
							{
							if (c_line >= 0)
								{
								if (mark_start != -1)	
									del_edit();
								
								wrap();
									
								ed = get_body_buffer(c_line + c_page);
								ed += c_left + c_col;
								clear_bodyline_cache(ed);
								ins_char(&new_buffer.body, &new_buffer.body_len, &new_buffer.body_lines, &ed, k_return & 0xFF);
	
								ed = get_body_buffer(c_line + c_page); /* May be reallocated */
								register_undo_delete(ed + c_col + c_left, 1);
								
								if (ed + body_linelength(ed) < new_buffer.body + new_buffer.body_len - 1)
									{
									int cxy[4];
									
									get_mailline(c_line, cxy);		

									if (xy[1] + xy[3] - cxy[1] - cxy[3] * 2 > 0)
									  blt_copy(NULL, cxy[0], cxy[1] + cxy[3], 
									  				 NULL, cxy[0], cxy[1] + cxy[3] * 2, 
									  				 xy[2] - 3, xy[1] + xy[3] - cxy[1] - cxy[3] * 2, S_ONLY);

									cxy[2] = xy[2];
									cxy[3] = cxy[3] * 2;
									redraw_bodytext((GRECT *)cxy);		
									
/*									force_bodyredraw();*/
									}
								}
							cursor_off();
							c_line++;
	
							set_mailslider();
							}
					}
						
				cursor_off();						
				if (c_line < 0)
					{
					ed = get_editbuffer(&n, &ptr, &max_len);
					if (ed)
						{
						c_col = (int)strlen(ed);
						if (c_col > 58)
							{
							c_topleft = (c_col / 30) * 30;
							c_col -= c_topleft;
							}
						else
							c_topleft = 0;

						get_mailline(c_line, xy);		
						xy[2] *= 59;
						redraw_mailedit(ed, (GRECT *)xy);		
						}
					}
				else
					{
					c_col = 0;
					new_left();
					}
								
				if (!no_refresh) cursor_on();
				break;
				}
			}
		break;
	}
	
set_mailslider();
}

/* --------------------------------
   | Redraw and set top edit line |
   -------------------------------- */
void redraw_topedit(int lin, char *ed)
{
int xy[4];

DEBUG();
c_col = (int)strlen(ed);
if (c_col > 58)
	{
	c_topleft = (c_col / 30) * 30;
	c_col -= c_topleft;
	}
else
	c_topleft = 0;

get_mailline(lin, xy);		
xy[2] *= 59;
redraw_mailedit(ed, (GRECT *)xy);		
}

/* ------------------------
   | Click on mail window |
   ------------------------ */
void mail_button(void)
{
int n, i;
int xy[6], tw, *max_len;
char *ed, **ptr;
int wx, wy, ww, wh;

DEBUG();
wind_get(mail_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);

if (evnt.bstate & 2)
	{
	i = -1;
	if (mail_options.from_flg) i--;
	if (mail_options.replyto_flg) i--;
	if (mail_options.bcc_flg)  i--;
	if (mail_options.cc_flg)		i--;
	
	for (; i <= -1; i++)
		{
		get_mailline(i, xy);
		xy[2] *= 59;
		if (xy[0] <= evnt.x && evnt.x < xy[2] + xy[0] &&
				xy[1] <= evnt.y && evnt.y < xy[3] + xy[1])
			{
			c_line = i;
			ed = get_editbuffer(&n, &ptr, &max_len);
			recent_select(i, ptr, max_len);

			return;
			}
		}
		
	editor_popup();
	return;
	}

if (!(evnt.bstate & 1)) return;

if (evnt.y >= wy && evnt.y < wy + iheight)
	{
	mail_button_action();
	return;
	}

if (mail_options.idline_flg)
	{
	int n;
	int th = tx_height + 3;
	
	n = 1;
	if (mail_options.from_flg) 		n++;
	if (mail_options.replyto_flg) n++;
	if (mail_options.cc_flg)			n++;
	if (mail_options.bcc_flg)			n++;
	if (mail_options.sub_flg)			n++;

	if (evnt.y >= wy + iheight + th * n && evnt.y <= wy + iheight + th * n + editorselect[0].ob_height)
		{
		if (evnt.x >= wx + tx_width * 12 && evnt.x < wx + tx_width * 12 + editorselect[0].ob_width)
			{
			IDENTITY identity;
			int slen;
			
			if (select_identity(wx + tx_width * 12, wy + iheight + th * n + editorselect[0].ob_height, &identity))
			  {
				strcpy(new_buffer.identity, identity.name);
				strcpy(new_buffer.signature, identity.signature);
				
				new_buffer.changed = TRUE;
				new_buffer.mime_allowed = identity.mime_allowed;
				new_buffer.word_wrap		= identity.word_wrap;
				new_buffer.editwidth    = identity.editwidth;
	
					/* Get priority from identity */
				if (identity.priority == -1)
					{
					if (identity.last_priority != -1)
						new_buffer.priority = identity.last_priority;
					}
				else
					new_buffer.priority = identity.priority;
					
				but_selected[8] = new_buffer.priority == 1;
				but_selected[9] = new_buffer.priority == 2;
				redraw_mbbutton(1);
				redraw_mbbutton(8);
				redraw_mbbutton(9);
	
					/* Get confirm receipt from identity */
				if (identity.confirm_rcpt == -1)
					{
					if (identity.last_rcpt != -1)
						new_buffer.confirm_rcpt = identity.last_rcpt;
					}
				else
					new_buffer.confirm_rcpt = identity.confirm_rcpt;
				but_selected[6] = new_buffer.confirm_rcpt;
				redraw_mbbutton(6);
					
					/* Get confirm read from identity */
				if (identity.confirm_read == -1)
					{
					if (identity.last_read != -1)
						new_buffer.confirm_read = identity.last_read;
					}
				else
					new_buffer.confirm_read = identity.confirm_read;
				but_selected[7] = new_buffer.confirm_read;
				redraw_mbbutton(7);
	
				if (identity.organization)
					strcpy(new_buffer.organization, identity.organization);
	
				slen = (int)strlen(identity.username) + 6;
				if (!identity.use_providerdata)
					{
					slen += (int)strlen(identity.email);
					slen += (int)strlen(identity.email2);
					}
				else
					{
					slen += (int)strlen(cfg_options.email);
					slen += (int)strlen(cfg_options.email2);
					}
				
				if (slen + 1 > new_buffer.from_max)
					{
					while(new_buffer.from_max < slen + 1)
						new_buffer.from_max += 60;
					new_buffer.from = (char *)realloc(new_buffer.from, new_buffer.from_max);
					}
				new_buffer.from[new_buffer.from_max - 1] = 0;
	
				if (identity.username[0])
					{
					new_buffer.from[0] = '"';
					strcpy(new_buffer.from + 1, identity.username);
					strcat(new_buffer.from, "\" <");
					}
				else
					new_buffer.from[0] = 0;
					
				if (!identity.use_providerdata)
					{
					strcat(new_buffer.from, identity.email);
					strcat(new_buffer.from, identity.email2);
					}
				else
					{
					strcat(new_buffer.from, cfg_options.email);
					strcat(new_buffer.from, cfg_options.email2);
					}
	
				if (identity.username[0])
					strcat(new_buffer.from, ">");
	
				if (identity.reply_to1[0] || identity.reply_to2[0])
					{				
					slen = (int)strlen(identity.reply_to1);
					slen += (int)strlen(identity.reply_to2);
					}
					
				if (slen + 1 > new_buffer.replyto_max)
					{
					while(new_buffer.replyto_max < slen + 1)
						new_buffer.replyto_max += 60;
					new_buffer.replyto = (char *)realloc(new_buffer.replyto, new_buffer.replyto_max);
					}
				new_buffer.replyto[new_buffer.replyto_max - 1] = 0;
	
				if (identity.reply_to1[0] || identity.reply_to2[0])
					{				
					strcpy(new_buffer.replyto, identity.reply_to1);
					strcat(new_buffer.replyto, identity.reply_to2);
					}
				else
					strcpy(new_buffer.replyto, new_buffer.from);
	
				calc_bodyarea(xy);
				redraw_mailwindow(wx, wy, xy[2] - wx, xy[1] - wy);
				edit_enable();
				}
			}
		else	
			if (evnt.x >= wx + tx_width * 48 && evnt.x < wx + tx_width * 48 + editorselect[0].ob_width)
				{
				select_signature(wx + tx_width * 48, wy + iheight + th * n + editorselect[0].ob_height, 
												 editorselect[0].ob_width,
												 new_buffer.signature);
				calc_bodyarea(xy);
				redraw_mailwindow(wx, wy, xy[2] - wx, xy[1] - wy);
				}
		}
	}
	
get_editbuffer(&n, &ptr, &max_len);
for (i = n + 1; i <= new_buffer.body_lines; i++)
	{
	get_mailline(i, xy);
	tw = xy[2];
	
	if (i < 0)
		xy[2] *= 59;
	else
		xy[2] = ww - (xy[0] - wx);
				
	if ((xy[0] <= evnt.x && evnt.x < xy[2] + xy[0] &&
			 xy[1] <= evnt.y && evnt.y < xy[3] + xy[1]) ||
			(i == new_buffer.body_lines && evnt.y > xy[3] + xy[1]))
		{
		if (c_line != i && mark_start != -1)
			if ((c_line < 0 && i >= 0) || i < 0)
				unmark();
				
		cursor_off();
		c_line = i;
		c_col = (evnt.x - xy[0]) / tw;
		
		if (c_line < 0)
			{
			ed = get_editbuffer(&n, &ptr, &max_len);
			if (ed)
					{
					c_col = (int)strlen(ed);
					if (c_col > 58)
						{
						c_topleft = (c_col / 30) * 30;
						c_col -= c_topleft;
						}
					else
						c_topleft = 0;
					}
			}
		else
			{
			ed = get_body_buffer(c_line + c_page);
			if (body_linelength(ed) < c_left + c_col)
				{
				c_col = body_linelength(ed);
				new_left();
				}
			}
			
		cursor_on();
		if (clicks == 1)
			{
			if (c_line >= 0)
				mark_text();
			}
		else
			{
			mark_end = mark_start = get_mark();
			if (mark_start != -1)
				{
				while(mark_start > 0  && misalnum(((unsigned char *)new_buffer.body)[mark_start - 1]))
					mark_start--;
				
				while(mark_end < new_buffer.body_len && misalnum(((unsigned char *)new_buffer.body)[mark_end]))
					mark_end++;
				
				if (mark_start != mark_end)
					redraw_mailwindow(xy[0], xy[1], xy[2], xy[3]);
				else
					unmark();
				}
			}

		edit_enable();
/*		ed = get_body_buffer(c_line + c_page);
		if (body_linelength(ed) < c_left + c_col)
			{
			c_col = body_linelength(ed);
			new_left();
			}*/
		break;
		}
	}
}

/* ----------------------
   | Select mail button |
   ---------------------- */
void redraw_mbbutton(int n)
{
GRECT t1;
int xy[4];
int wx, wy, ww, wh;

DEBUG();
calc_butpos();

wind_update(BEG_UPDATE);
graf_mouse(M_OFF, 0L);

wind_get(mail_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);

wind_get(mail_wind, WF_FIRSTXYWH, &t1.g_x, &t1.g_y, &t1.g_w, &t1.g_h);
while(t1.g_w && t1.g_h)
	{
	xy[0] = t1.g_x;
	xy[1] = t1.g_y;
	xy[2] = t1.g_x + t1.g_w - 1;
	xy[3] = t1.g_y + t1.g_h - 1;
	vs_clip(vdi_handle, 1, xy);

	if (new_buffer.mime_allowed || n != 1)
		draw_button(n, wx + but_pos[n], wy);

	vs_clip(vdi_handle, 0, xy);
		
	wind_get(mail_wind, WF_NEXTXYWH, &t1.g_x, &t1.g_y, &t1.g_w, &t1.g_h);
	}

graf_mouse(M_ON, 0L);
wind_update(END_UPDATE);
}

/* ---------------------
   | Press mail button |
   --------------------- */
void press_mbbutton(int n)
{
DEBUG();
but_selected[n] = 1;
redraw_mbbutton(n);

wait_mouse_release();
	
but_selected[n] = 0;
redraw_mbbutton(n);
}

/* ------------------------------------
   | Get button number in mail window |
   ------------------------------------ */
int get_mailwind_button(int mousex, int mousey)
{
int i;
int wx, wy, ww, wh;

DEBUG();
if (mail_wind == -1)
	return -1;
	
wind_get(mail_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);

if (mousey >= wy && mousey < wy + iheight)
	for (i = 0; i < 12; i++)
		if (mousex >= wx + but_pos[i] && mousex < wx + but_pos[i] + isize)
			return i;

return -1;
}

/* -----------------------
   | Mail button pressed |
   ----------------------- */
void mail_button_action(void)
{
char *file;
char bufs[51 * 2 + MAXFILE * 2 + 1];

DEBUG();
switch(get_mailwind_button(evnt.x, evnt.y))
	{
	case 0:
		{
		int has_identity;
		IDENTITY *setid;

		if (new_buffer.identity[0])
			{
			has_identity = getIdentityIndex(new_buffer.identity);
			setid = getIdentityPtr(has_identity);
			}
		else
			has_identity = -1;

		press_mbbutton(0);

		if (!new_buffer.to[0])
			{
			form_alert(1, noaddress_text);
			return;
			}
			
		if (!new_buffer.subject[0])
			{
			if (form_alert(2, nosubject_text) == 2)
				return;
			}

		if (has_identity != -1)
			{			
			setid->last_rcpt 			= new_buffer.confirm_rcpt;
			setid->last_read 			= new_buffer.confirm_read;
			setid->last_priority  = new_buffer.priority;
			setIdentityChange();
			}
			
		file = gen_mail();
		if (file != NULL)
			{
			if ((!edit_mode || forward_mode) && has_identity != -1 && setid->send_immediately)
				{
				if (get_connected() != 2 && !check_connection(2, "\0", FALSE))
					store_mail(file, box_number("QUEUE"), &new_buffer, FALSE);
				else
					{
					MAIL_MEM copy_new;
					int ret;
					
					memcpy(&copy_new, &new_buffer, sizeof(MAIL_MEM));
					
					base_path(bufs);
					strcat(bufs, file);
					open_idsmtp(has_identity);
					ret = mail_send(bufs);
					close_smtp();
					
					memcpy(&new_buffer, &copy_new, sizeof(MAIL_MEM));
					
					if (!ret)
						store_mail(file, box_number("QUEUE"), &new_buffer, FALSE);
					else
						{
						int box = box_number("SENT");
						store_mail(file, box, &new_buffer, mail_options.remove_attaches);
						}
					}
				}
			else
				if (!edit_mode || forward_mode)
					store_mail(file, box_number("QUEUE"), &new_buffer, FALSE);
				else
					change_mail(file, edit_file, box_number("QUEUE"), &new_buffer);
			new_buffer.changed = FALSE;		
			close_mailwindow();
			}
		break;
		}
		
	case 1:
		if (new_buffer.mime_allowed)
			{
			press_mbbutton(2);
			attach_file();
			}
		break;

	case 2:
		if (!but_disabled[2])		cut_edit();
		break;
		
	case 3:
		if (!but_disabled[3])		copy_edit();
		break;
		
	case 4:
		if (!but_disabled[4])		paste_edit();
		break;
		
	case 5:
		if (!but_disabled[5])		del_edit();
		break;
		
	case 6:
		new_buffer.confirm_rcpt ^= 1;
		but_selected[6] = new_buffer.confirm_rcpt;
		redraw_mbbutton(6);
		wait_mouse_release();
		break;
				
	case 7:
		new_buffer.confirm_read ^= 1;
		but_selected[7] = new_buffer.confirm_read;
		redraw_mbbutton(7);
		wait_mouse_release();
		break;

	case 8:
		if (new_buffer.priority == 1)
			new_buffer.priority = 0;
		else
			{
			if (new_buffer.priority == 2)
				{
				new_buffer.priority = 1;
				but_selected[9] = 0;
				redraw_mbbutton(9);
				}
			else
				new_buffer.priority = 1;
			}
		but_selected[8] = new_buffer.priority == 1;
		redraw_mbbutton(8);
		wait_mouse_release();
		break;
		
	case 9:
		if (new_buffer.priority == 2)
			new_buffer.priority = 0;
		else
			{
			if (new_buffer.priority == 1)
				{
				new_buffer.priority = 2;
				but_selected[8] = 0;
				redraw_mbbutton(8);
				}
			else
				new_buffer.priority = 2;
			}
		but_selected[9] = new_buffer.priority == 2;
		redraw_mbbutton(9);
		wait_mouse_release();
		break;

	case 10:
		address_book();
		break;
		
	case 11:
		press_mbbutton(1);
		close_mailwindow();
		break;
	}
}

/* ----------------------
   | Mark text by mouse |
   ---------------------- */
void mark_text(void)
{
long mark, start_mark;
int red, xy[6];
int old_mx, old_my;
int old_ln, new_ln, x_start, x_width;

DEBUG();
graf_mkstate(&evnt);
if ((evnt.bstate & 1) || (evnt.kstate & 3))
	{
	cursor_off();
	calc_bodyarea(xy);
	xy[2] = xy[2] - xy[0] + 1;
	xy[3] = xy[3] - xy[1] + 1;
	
	mark = get_mark();
	if (mark != -1L)
		{
		if (evnt.kstate & 3)
			{
			if (mark < mark_start)
				mark_start = mark;
			else
				{
				mark_end = mark + 1;
				if (mark_end > new_buffer.body_len) mark_end = new_buffer.body_len;
				}
			redraw_mailwindow(xy[0], xy[1], xy[2], xy[3]);
			}
		else
			{
			start_mark = mark_start = mark;
			mark_end   = mark + 1;
			if (mark_end > new_buffer.body_len) mark_end = new_buffer.body_len;
			redraw_mailwindow(xy[0], xy[1], xy[2], xy[3]);
			
			old_mx = evnt.x;
			old_my = evnt.y;
			do
				{
				graf_mkstate(&evnt);
	
				if (evnt.x < xy[0] + xy[4] / 2 && c_left > 0)
					{
					old_mx += xy[4];
					c_left--;
					if (!no_refresh)
						{
					  blt_copy(NULL, xy[0] + 3, xy[1], NULL, xy[0] + 3 + xy[4], xy[1], xy[2] - xy[4] - 3, xy[3], S_ONLY);
						redraw_mailwindow(xy[0] + 3, xy[1], xy[4], xy[3]);
						set_mailslider();
						}
					}
				else
					if (evnt.x > xy[0] + xy[2] - xy[4] / 2 && 
							c_left < c_col - (xy[2] - 3) / xy[4])
						{
						old_mx -= xy[4];
						c_left++;
						if (!no_refresh)
							{
						  blt_copy(NULL, xy[0] + 3 + xy[4], xy[1], NULL, xy[0] + 3, xy[1], xy[2] - xy[4] - 3, xy[3], S_ONLY);
							redraw_mailwindow(xy[0] + xy[2] - xy[4], xy[1], xy[4], xy[3]);
							set_mailslider();
							}
						}
	
				if (evnt.y < xy[1] + xy[5] / 2 && c_page > 0)
					{
					old_my += xy[5];
					evnt.y = xy[1];
				  c_page--;
					if (!no_refresh)
						{
					  blt_copy(NULL, xy[0], xy[1], NULL, xy[0], xy[1] + xy[5], xy[2], xy[3] - xy[5], S_ONLY);
						redraw_mailwindow(xy[0], xy[1], xy[2], xy[5]);
						set_mailslider();
						}
					}
				else
					if (evnt.y > xy[1] + xy[3] - xy[5] / 2 && 
							c_page < new_buffer.body_lines + 1 - xy[3] / xy[5]) 
						{
						old_my -= xy[5];
					  c_page++;
						if (!no_refresh)
							{
						  blt_copy(NULL, xy[0], xy[1] + xy[5], NULL, xy[0], xy[1], xy[2], xy[3] - xy[5], S_ONLY);
							redraw_mailwindow(xy[0], xy[1] + xy[3] - xy[5], xy[2], xy[5]);
							set_mailslider();
							}
						}
	
				mark = get_mark();
				red = FALSE;
				if (mark != -1)
					{
					if (mark <= start_mark)
						{
						if (mark_start != mark)
							{
							mark_start = mark;
							mark_end = start_mark + 1;
							if (mark_end > new_buffer.body_len) mark_end = new_buffer.body_len;
							red = TRUE;
							}
						}
					else
						{
						if (mark + 1 != mark_end)
							{
							mark_start = start_mark;
							mark_end = mark + 1;
							if (mark_end > new_buffer.body_len) mark_end = new_buffer.body_len;
							red = TRUE;
							}
						}
	
					if (red)
						{
						old_ln = (old_my - xy[1]) / xy[5];
						new_ln = (evnt.y - xy[1]) / xy[5];
		
						if (old_ln > new_ln)
							{
							x_start = 0;
							x_width = xy[2] - 3;
								
							old_ln++;	
							redraw_mailwindow(xy[0] + x_start + 3, 
																xy[1] + new_ln * xy[5],
															  x_width, 
															  (old_ln - new_ln) * xy[5]);
							}
						else
							{
							if (old_ln == new_ln)
								{
								if (old_mx < evnt.x)
									{
									x_start = (old_mx - xy[0] - 3) / xy[4];
									x_start *= xy[4];
									x_width = (evnt.x - old_mx + xy[4] - 1) / xy[4] + 1;
									x_width *= xy[4];
									}
								else
									{
									x_start = (evnt.x - xy[0] - 3) / xy[4];
									x_start *= xy[4];
									x_width = (old_mx - evnt.x + xy[4] - 1) / xy[4] + 1;
									x_width *= xy[4];
									}
								}
							else
								{
								x_start = 0;
								x_width = xy[2] - 3;
								}
							
							new_ln++;	
							redraw_mailwindow(xy[0] + x_start + 3, 
																xy[1] + old_ln * xy[5],
															  x_width, 
															  (new_ln - old_ln) * xy[5]);
							}
						}
					}
	
				old_mx = evnt.x;
				old_my = evnt.y;
				}while(evnt.bstate & 1);
				
			if (mark_start == mark_end)
				mark_start = mark_end = -1L;
			}
		}

	red = but_disabled[2];
	
	but_disabled[2] =
	but_disabled[3] =
	but_disabled[5] = mark_start == -1;
	
	if (red != but_disabled[2])
		{
		redraw_mbbutton(2);
		redraw_mbbutton(3);
		redraw_mbbutton(5);
		}

	cursor_on();
	}
else
	unmark();
}

/* -----------------------
   | Unmark current mark |
   ----------------------- */
void unmark(void)
{
DEBUG();
if (mark_start != -1)
	if (c_line >= 0)
		{
		int xy[6];
	
		cursor_off();
		calc_bodyarea(xy);
		xy[2] = xy[2] - xy[0] + 1;
		xy[3] = xy[3] - xy[1] + 1;
	
		mark_start = mark_end = -1;
	
		but_disabled[2] =
		but_disabled[3] =
		but_disabled[5] = TRUE;
		
		redraw_mailwindow(xy[0], xy[1], xy[2], xy[3]);
		cursor_on();
		}
	else
		{
		char **ptr;
		int *max_len, n, xy[4];
		char *ed;
		
		ed = get_editbuffer(&n, &ptr, &max_len);
		cursor_off();
			
		mark_start = mark_end = -1;

		get_mailline(c_line, xy);		
		xy[2] *= 59;
		redraw_mailedit(ed, (GRECT *)xy);		
	
		cursor_on();
		}
}
		
/* ------------------
   | Calculate mark |
   ------------------ */
long get_mark(void)
{
int xy[6];
unsigned char *mem;
long mem_len, pg;
int xpos, mpos;
	
DEBUG();
calc_bodyarea(xy);
xy[2] = xy[2] - xy[0] + 1;
xy[3] = xy[3] - xy[1] + 1;
	
mem = (unsigned char *)new_buffer.body;
mem_len = new_buffer.body_len;
pg = c_page + (evnt.y - xy[1]) / xy[5];
	
if (pg < 0) return -1L;
	
while(pg--)
	{
	while(mem_len && *mem != '\n' && *mem != '\r')
		{
		mem++;
		mem_len--;
		}
	
	if (mem_len)
		{
		if (mem_len > 1 && *mem != mem[1] && (mem[1] == '\r' || mem[1] == '\n'))
			{
			mem++;
			mem_len--;
			}
	
		mem++;
		mem_len--;
		}
	}

mpos = c_left + ((evnt.x - xy[0] - 3 + xy[4] / 2) / xy[4]);
if (mpos <= 0 && mem > (unsigned char *)new_buffer.body)
	return mem - (unsigned char *)new_buffer.body - 1;
	
xpos = 0;
while(mem_len && *mem != '\n' && *mem != '\r')
	{
	if (*mem != '\t')
		{
		xpos++;
		if (xpos == mpos) return mem - (unsigned char *)new_buffer.body;
		mem++;
		}
	else
		{
		do
			{
			xpos++;
			if (xpos == mpos) return mem - (unsigned char *)new_buffer.body;
			}while(xpos & 7);
		mem++;
		}
		
	mem_len--;
	}
	
return mem - (unsigned char *)new_buffer.body;
}

/* -----------------------------------
   | select all inside editor window |
   ----------------------------------- */
void select_all_edit(void)
{
DEBUG();
if (new_buffer.body_len > 0)
	{
	mark_start = 0;
	mark_end = new_buffer.body_len;
	edit_enable();
	force_bodyredraw();
	}
}

/* ---------------------------
   | Paste address into mail |
   --------------------------- */
void paste_mailadr(char *buffer)
{
DEBUG();
if (c_line < 0)
	{
	char *ed, **ptr;
	int n, *max_len, dori, d, xy[6];
	
	dori = d = (int)strlen(buffer);
	ed = get_editbuffer(&n, &ptr, &max_len);
	while (strlen(ed) + dori + 2 + 1 > *max_len)
		{
		*max_len += 60;
		ed = *ptr = (char *)realloc(*ptr, *max_len);
		}
		
	new_buffer.changed = TRUE;
	if (ed[0])
		d += 2;

	memmove(ed + c_col + c_topleft + d, ed + c_col + c_topleft, 
				  *max_len - (c_col + c_topleft + d) - 1);
	ed[*max_len - 1] = 0;
	
	if (d > dori && c_col + c_topleft > 0)
		{
		int c;
		
		c = c_col + c_topleft - 1;
		while (c > 0 && isspace(ed[c]))
			c--;
			
		if (c > 0 && ed[c] != ',')
			{		
			memcpy(ed + c_col + c_topleft, ", ", 2);
			c_col += 2;
			d -= 2;
			}
		}

	memcpy(ed + c_col + c_topleft, buffer, dori);
	c_col += dori;

	if (d > dori)
		{
		memcpy(ed + c_col + c_topleft, ", ", 2);
		c_col += 2;
		}
		
	cursor_off();
	get_mailline(c_line, xy);		
	xy[2] *= 59;

/*	if (c_col + c_topleft < strlen(ed)) 
		{
		c_col++;*/
		while (c_col > 58)
			{
			c_topleft += 30;
			c_col -= 30;
			}
/*		}*/

	redraw_mailedit(ed, (GRECT *)xy);		
	if (!no_refresh) cursor_on();	
	}
else
	{
	char c, oc;
	int was_space = FALSE;

	no_refresh = TRUE;
	oc = 0;
	while(*buffer)
		{
		c = *(buffer++);
		if (c == '\r' || c == '\n')
			{
			if (c_line < 0)
				break;
					
			if (c != oc && (oc == '\r' || oc == '\n'))
				{
				oc = 0;
				continue;
				}
			evnt.kstate = 0;
				
			if (!new_buffer.word_wrap || was_space == FALSE)
				{
				k_return = new_buffer.word_wrap ? ' ' : '\r';
				mail_keybd();
				}
			}
		else
			{
			was_space = isspace(c);
			evnt.kstate = 0;
			k_return = c;
			mail_keybd();
			}
		oc = c;
		}
		
	evnt.kstate = 0;
	k_return = ' ';
	mail_keybd();
		
	no_refresh = FALSE;
	force_bodyredraw();
	set_mailslider();
	}
}

/* ---------------------------------
   | Check for filled paste buffer |
   --------------------------------- */
void check_editpaste(void)
{
int scrp = check_scrap();
DEBUG();
menu_ienable(menu_adr, M_PASTE, scrp);
if (but_disabled[4] != !scrp)
	{
	but_disabled[4] = !scrp;
	redraw_mbbutton(4);
	}
}

/* -------------------------
   | Copy from mail editor |
   ------------------------- */
int copy_edit(void)
{
char scrap[256];
long fh, size;

DEBUG();
if (scrp_read(scrap))
	{
	strcat(scrap, "scrap.txt");

	fh = Fcreate(scrap, 0);
	if (fh > 0)
		{
		size = mark_end - mark_start;
		if (mark_start + size > new_buffer.body_len)
			size--;
		
		if (Fwrite((int)fh, size, new_buffer.body + mark_start) != size)
			{
			form_alert(1, scrap_error);
			Fclose((int)fh);
			return FALSE;
			}
		Fclose((int)fh);
		
		check_editpaste();
			
		return TRUE;
		}
	else
		form_alert(1, scrap_error);
	}
return FALSE;
}

/* ---------------------------------
   | Search line defined by marker |
   --------------------------------- */
void find_line(long ptr, int *line, int *col)
{
char *ed;
int l, c;

DEBUG();
ed = new_buffer.body;
l = 0; c = 0;
while (ptr--)
	{
	if (*ed == '\r')
		{
		l++;
		c = 0;
		}
	else
		c++;
	
	ed++;
	}
*line = l;
*col = c;	
}

/* ---------------------------
   | Delete from mail editor |
   --------------------------- */
void del_edit(void)
{
char *ed;
int xy[6], l, c;
long cptr;

DEBUG();
calc_bodyarea(xy);
xy[2] -= xy[0];
xy[3] -= xy[1];

ed = get_body_buffer(c_line + c_page) + c_left + c_col;
cptr = ed - new_buffer.body;

ed = new_buffer.body + mark_start;
register_undo_insert(ed, mark_end - mark_start);

while(mark_start < mark_end && mark_start != -1 && new_buffer.body_len)
	{
	if (mark_start < cptr)
		cptr--;
		
	clear_bodyline_cache(ed);
	del_char(&new_buffer.body, &new_buffer.body_len, 
					 &new_buffer.body_lines, &ed);
	}

find_line(cptr, &l, &c);
if (l > c_page)
	{
	c_page = l - c_line;
	if (c_page < 0) c_page = 0;
	c_line = l - c_page;
	}
else
	c_line = l - c_page;

if (c > c_left)
	c_col = c - c_left;
else
	{
	c_left = c - (c % (possible - 10));
	c_col = c - c_left;
	}
		
wrap();
	
ed = get_body_buffer(c_line + c_page);
if (body_linelength(ed) < c_left + c_col)
	{
	c_col = body_linelength(ed);
	c_left = c_col - (c_col % (possible - 10));
	c_col -= c_left;
	}
force_bodyredraw();
set_mailslider();
}

/* ------------------------
   | Cut from mail editor |
   ------------------------ */
void cut_edit(void)
{
DEBUG();
if (copy_edit())
	del_edit();
}

/* ----------------------------
   | Insert content from file |
   ---------------------------- */
void paste_fromfile(char *file)
{
long fh;
int xy[4], incnt, i;
char c, oc, *inbuf;
int was_space = FALSE;

no_refresh = TRUE;
fh = Fopen(file, FO_READ);
if (fh > 0)
	{
	inbuf = (char *)malloc(1024);
	oc = 0;
	while( (incnt = (int)Fread((int)fh, 1024, inbuf)) > 0)
		{
		for (i = 0; i < incnt; i++)
			{
			c = inbuf[i];
			if (c == '\r' || c == '\n')
				{
				if (c_line < 0)
					break;
					
				if (c != oc && (oc == '\r' || oc == '\n'))
					{
					oc = 0;
					continue;
					}
				evnt.kstate = 0;
				
				if (!new_buffer.word_wrap || was_space == FALSE)
					{
					k_return = new_buffer.word_wrap ? ' ' : '\r';
					mail_keybd();
					}
				}
			else
				{
				was_space = isspace(c);
				evnt.kstate = 0;
				k_return = c;
				mail_keybd();
				}
			oc = c;
			}
		}
	
	free(inbuf);
	Fclose((int)fh);
	}
no_refresh = FALSE;

if (c_line >= 0)
	force_bodyredraw();
else
	{		
	char *ed, **ptr;
	int n, *maxl;

	ed = get_editbuffer(&n, &ptr, &maxl);
	get_mailline(c_line, xy);		
	xy[2] *= 59;
	redraw_mailedit(ed, (GRECT *)xy);		
	}
set_mailslider();
}

/* ---------------------
   | Paste into editor |
   --------------------- */
void paste_edit(void)
{
char scrap[256];

if (scrp_read(scrap))
	{
	strcat(scrap, "scrap.txt");
	paste_fromfile(scrap);
	}
}

/* ----------------
   | Paste a file |
   ---------------- */
void paste_file(void)
{
char buf[256];

if (text_fileselect(buf, menu_adr[M_PASTEFILE].ob_spec.free_string))
	{
	paste_fromfile(buf);
	}
}

/* ----------------------
	 | Mark find position |
	 ---------------------- */
void mark_findpos(int column, int line, int l, int find_mode)
{
int xy[6];

calc_bodyarea(xy);
xy[2] -= xy[0];
xy[3] -= xy[1];

if (!no_refresh)
	{
	unmark();
	cursor_off();
	}
	
if (line > c_page && line < c_page + xy[3] / tx_height)
	c_line = line - c_page;
else
	{
	c_page = line;
	c_line = 0;
	if (c_page + xy[3] / tx_height > new_buffer.body_lines)
		{
  	c_page = new_buffer.body_lines + 1 - xy[3] / tx_height;
  	if (c_page < 0) c_page = 0;
  	c_line = line - c_page;
		}
	}
	
c_col = column;
if (!l)
	{
	mark_start = mark_end = -1;
	}
else
	{
	mark_start = get_body_buffer(line) + column - new_buffer.body;
	mark_end = mark_start + l;
	}
	
if (!no_refresh)
	{
	new_left();

	redraw_mailwindow(xy[0], xy[1], xy[2], xy[3]);
	set_mailslider();
	cursor_on();
	
	if (find_mode)
		open_find(mail_wind);
	else
		open_replace(mail_wind);
	}
}

/* ---------------------------
	 | Search in editor window |
	 --------------------------- */
void search_in_editor(char *ptr, int sensitive, int use_expr, int backwards, int find_mode)
{
char *ed;
int step, ll, l, ln, offset;

if (c_line < 0)
	{
	if (backwards)
		ln = new_buffer.body_lines;
	else
		ln = 0;
	}
else
	{
	ln = c_line + c_page;
	offset = c_left + c_col;
	
	if (!ln && !offset && backwards)
		{
		ln = new_buffer.body_lines;
		ed = get_body_buffer(ln);
		ll = body_linelength(ed);
		offset = ll + 1;
		}
	else
		{
		ed = get_body_buffer(ln);
		ll = body_linelength(ed);
		if (ln == new_buffer.body_lines && offset == ll && !backwards)
			{
			ln = 0;
			offset = -1;
			}
		}
	}

ed = get_body_buffer(ln);
ll = body_linelength(ed);
l = (int)strlen(ptr);
step = backwards ? -1 : 1;

if (c_line < 0)
	if (backwards)
		offset = ll;
	else
		offset = 0;
else		
	offset += step;

for (;;)
	{
	if (offset == -1 || offset == ll)
		{
		ln += step;
		
		ed = get_body_buffer(ln);
		ll = body_linelength(ed);
		
		if (backwards)
			offset = ll;
		else
			offset = 0;
			
		if (!ed || ed >= new_buffer.body + new_buffer.body_len)
			break;
		}

	if (ed + offset < new_buffer.body + new_buffer.body_len)	
		if (use_expr)
			{
			int len;
			
			if ((len = matchpattern2((unsigned char *)(ed + offset), 
															 (unsigned char *)(new_buffer.body + new_buffer.body_len), 
															 (unsigned char *)ptr, sensitive)) > 0)
				{
				mark_findpos(offset, ln, len, find_mode);
				return;
				}
			}
		else
			if (sensitive)
				{
				if (!strncmp(ed + offset, ptr, l))
					{
					mark_findpos(offset, ln, l, find_mode);
					return;
					}
				}
			else
				{
				if (!strnicmp(ed + offset, ptr, l))
					{
					mark_findpos(offset, ln, l, find_mode);
					return;
					}
				}	

	offset += step;
	}
	
if (backwards)
	mark_findpos(0, 0, 0, find_mode);
else
	mark_findpos(ll, new_buffer.body_lines, 0, find_mode);
}

/* ---------------------
   | Replace in editor |
   --------------------- */
int replace_editor(char *set, int ask)
{
if (mark_start == -1) 
	return FALSE;
else
	{
	char c, oc = 0, *ed;
	int was_space = FALSE;

	if (ask)
		{	
		int ret = replace_ask();
		if (ret == DONT_REPLACE)
			return TRUE;
		else
			if (ret == CANCEL_REPLACE)
				return FALSE;
		}
			
	ed = get_body_buffer(c_line + c_page);
	ed += c_col + c_left;
	
	while(*set)
		{
		c = *(set++);
		if (c == '\r' || c == '\n')
			{
			if (c_line < 0)
				break;
					
			if (c != oc && (oc == '\r' || oc == '\n'))
				{
				oc = 0;
				continue;
				}
			evnt.kstate = 0;
				
			if (!new_buffer.word_wrap || was_space == FALSE)
				{
				k_return = new_buffer.word_wrap ? ' ' : '\r';
				mail_keybd();
				}
			}
		else
			{
			was_space = isspace(c);
			evnt.kstate = 0;
			k_return = c;
			mail_keybd();
			}
		oc = c;
		}
	
	return TRUE;
	}
}

/* ----------------------------
   | Register undoable insert |
   ---------------------------- */
void register_undo_insert(char *ed, long i)
{
register_undo(ed, i, UNDO_INSERT);
}

/* ----------------------------
   | Register undoable remove |
   ---------------------------- */
void register_undo_delete(char *ed, long i)
{
register_undo(ed, i, UNDO_DELETE);
}

/* ----------------------------
   | Register undoable remove |
   ---------------------------- */
void register_undo_replace(char *ed, long i)
{
register_undo(ed, i, UNDO_REPLACE);
}

/* ---------------------------
   | Register an undo action |
   --------------------------- */
void register_undo(char *ed, long i, int mode)
{
if (i > 0)
	{	
	long offset = ed - new_buffer.body;

	if (mode == UNDO_DELETE && undo_cnt > 0 && 
			undo_stack[undo_cnt - 1].mode == UNDO_DELETE && 
			undo_stack[undo_cnt - 1].offset + undo_stack[undo_cnt - 1].length == offset)
		{
		undo_stack[undo_cnt - 1].length += i;
		return;
		}
		
	if (undo_cnt == 10)
		{
		if (undo_stack[0].mode == UNDO_INSERT || undo_stack[0].mode == UNDO_REPLACE)
			free(undo_stack[0].text);
		memmove(undo_stack, undo_stack + 1, sizeof(UNDO_DATA) * 9);
		undo_cnt--;
		}
		
	if (mode == UNDO_INSERT)
		{
		undo_stack[undo_cnt].text = (char *)malloc(i + 1);
		memcpy(undo_stack[undo_cnt].text, ed, i);
		undo_stack[undo_cnt].text[i] = 0;
		}
	
	undo_stack[undo_cnt].offset = offset;
	undo_stack[undo_cnt].length = i;
	undo_stack[undo_cnt].mode = mode;
 	undo_stack[undo_cnt].c_line = c_line;
 	undo_stack[undo_cnt].c_col = c_col;
	undo_stack[undo_cnt].c_page = c_page;
	undo_stack[undo_cnt].c_left = c_left;
	undo_cnt++;
	
	edit_enable();
	}
}

/* --------------------
   | Undo last action |
   -------------------- */
void undo_edit(void)
{
if (undo_cnt > 0)
	{
	UNDO_DATA *undo = undo_stack + (undo_cnt - 1);
	switch(undo->mode)
		{
		case UNDO_INSERT:
			{
			clear_bodyline_cache(new_buffer.body + undo->offset);
			if (new_buffer.body_len != 0)
				{
				new_buffer.body = (char *)realloc(new_buffer.body, 
																					new_buffer.body_len + undo->length);
	
				memmove(new_buffer.body + undo->offset + undo->length, 
								new_buffer.body + undo->offset,
								new_buffer.body_len - undo->offset);
				}
			else
				new_buffer.body = (char *)malloc(undo->length);
			
			memcpy(new_buffer.body + undo->offset, undo->text, undo->length);
			new_buffer.body_len += undo->length;
	
			cursor_off();
		 	c_line = undo->c_line;
		 	c_col = undo->c_col;
			c_page = undo->c_page;
			c_left = undo->c_left;
			cursor_on();
	
			force_bodyredraw();
			free(undo->text);
			break;
			}
			
		case UNDO_DELETE:
			{
			cursor_off();
			clear_bodyline_cache(new_buffer.body + undo->offset);
			
			if (undo->offset + undo->length < new_buffer.body_len)
				memmove(new_buffer.body + undo->offset, 
								new_buffer.body + undo->offset + undo->length,
								new_buffer.body_len - undo->offset - undo->length);
			
			new_buffer.body_len -= undo->length;
			if (!new_buffer.body_len)
				free(new_buffer.body);
	
		 	c_line = undo->c_line;
		 	c_col = undo->c_col;
			c_page = undo->c_page;
			c_left = undo->c_left;
			cursor_on();
	
			force_bodyredraw();
			break;
			}
		
		case UNDO_REPLACE:
			{
			long l;
			
			clear_bodyline_cache(new_buffer.body + undo->offset);
			
			if (undo->offset + undo->length < new_buffer.body_len)
				memmove(new_buffer.body + undo->offset, 
								new_buffer.body + undo->offset + undo->length,
								new_buffer.body_len - undo->offset - undo->length);
			
			new_buffer.body_len -= undo->length;
			if (!new_buffer.body_len)
				free(new_buffer.body);
	
			l = strlen(undo->text);
			if (new_buffer.body_len != 0)
				{
				new_buffer.body = (char *)realloc(new_buffer.body, 
																					new_buffer.body_len + l);
	
				memmove(new_buffer.body + undo->offset + l, 
								new_buffer.body + undo->offset,
								new_buffer.body_len - undo->offset);
				}
			else
				new_buffer.body = (char *)malloc(l);
			
			memcpy(new_buffer.body + undo->offset, undo->text, l);
			new_buffer.body_len += l;
	
			cursor_off();
		 	c_line = undo->c_line;
		 	c_col = undo->c_col;
			c_page = undo->c_page;
			c_left = undo->c_left;
			cursor_on();
	
			force_bodyredraw();
			
			free(undo->text);
			break;
			}
		}
	
	undo_cnt--;
	}
}
