#include "extern.h"
#include <errno.h>

static char mailbox_opt[256];
static int f_fsel[20];

static char text_path[256];
static int path_initialized = FALSE;

/* -------------------------
   | Create mail base path |
   ------------------------- */
void base_path(char *buf)
{
char *sx;
int l;

DEBUG();
strcpy(buf, mail_options.maildir);

l = (int)strlen(buf);
if (buf[l - 1] != '\\')
	buf[l++] = '\\';
strcpy(buf + l, mail_options.mailfile);

sx = strchr(buf + l, '.');
if (sx)
	*sx = 0;
strcat(sx, "\\");
}

/* -------------------------------
   | Create mailbox if necessary |
   ------------------------------- */
void create_mailbox(char *box)
{
char buf[256 + 64], *c;
long f;
DTA my_dta;

DEBUG();
Fsetdta(&my_dta);

strcpy(buf, box);

f = Fopen(buf,	FO_READ);
if (f > 0)
	{
	form_alert(1, boxexists_msg);
	return;
	}
	
f = Fcreate(buf, 0);
if (f > 0) 
	{
	long version = VERSION_ID;
	
	Fwrite((int)f, 12, "DrACONISMAIL");
	Fwrite((int)f,  4, &version);
	Fwrite((int)f,  9, "BOXICONS");
	Fwrite((int)f,  8, "\377\377\377\377\377\377\377\377");		/* box_wd 		*/
	Fwrite((int)f, 20, "Mail server\0........");							/* Old stuff	*/
	Fwrite((int)f,  2, "\0\0");																/* Boxtop			*/
	Fwrite((int)f,  2, "\0\0");																/* pop_sort  		*/
	Fwrite((int)f, 20, "\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377\377");
	Fwrite((int)f,  8, "\377\377\377\377\377\377\377\377");		/* pop_wd  		*/

	Fwrite((int)f,  8, "\377\377\377\377\377\377\377\377");		/* tree_wd		*/
	Fwrite((int)f,  2, "\0\7");																/* box_count	*/
	
	Fwrite((int)f, 11, "\377\376\0........");
	Fwrite((int)f, strlen(idfolder_label), idfolder_label);
	Fwrite((int)f, 21 - strlen(idfolder_label), "\0....................");
	Fwrite((int)f, 32, "\377\376\377\377\0\1\0\0\0\0\0.....................");

	Fwrite((int)f, 11, "\377\377\0........");
	Fwrite((int)f, strlen(idfolder_entry), idfolder_entry);
	Fwrite((int)f, 21 - strlen(idfolder_entry), "\0....................");
	Fwrite((int)f, 32, "\0\3\0\0\0\0\0\1\0\0\0.....................");

	Fwrite((int)f, 11, "\377\376\0........");
	Fwrite((int)f, 21, "default\0.............");
	Fwrite((int)f, 32, "\377\376\377\377\0\1\0\0\0\0\0.....................");
	
	Fwrite((int)f, 11, "\0\3QUEUE\0...");
	Fwrite((int)f, 21, header_tree[OUTLABEL].ob_spec.free_string);
	Fwrite((int)f, 32, "\0\4\0\1\0\0\0\1\0\0\0.....................");

	Fwrite((int)f, 11, "\0\0IN\0......");
	Fwrite((int)f, 21, header_tree[IN_LABEL].ob_spec.free_string);
	Fwrite((int)f, 32, "\0\1\0\2\0\0\0\1\0\0\0.....................");

	Fwrite((int)f, 11, "\0\1SENT\0....");
	Fwrite((int)f, 21, header_tree[SENTLABL].ob_spec.free_string);
	Fwrite((int)f, 32, "\0\2\0\3\0\0\0\1\0\0\0.....................");

	Fwrite((int)f, 11, "\0\1SENTERR\0.");
	Fwrite((int)f, 21, header_tree[SERRLABL].ob_spec.free_string);
	Fwrite((int)f, 32, "\0\2\0\4\0\0\0\1\0\0\0.....................");
	}

if (f > 0)
	Fclose((int)f);	
else
	{
	form_alert(1, boxfail_msg);
	return;
	}

*strrchr(buf, '.') = 0; Dcreate(buf);
strcat(buf, "\\");
c = buf + strlen(buf);

strcpy(c, "SENT"); 			Dcreate(buf);
strcpy(c, "SENTERR"); 	Dcreate(buf);
strcpy(c, "IN"); 				Dcreate(buf);
strcpy(c, "QUEUE");			Dcreate(buf);
}

/* --------------------------
   | Create new mail folder |
   -------------------------- */
void create_new_folder(int box, int type, char *new_desc, char *identity, int icon)
{
char buf[51 * 2 + MAXFILE * 2 + 1], *sx;
int l, i, s, cp, level;
struct stat stt;

DEBUG();
if (type != -2 && type != -1)
	{
	base_path(buf);
	
	l = (int)strlen(buf);
	sx = buf + l;
	
	for (i = 0, cp = 0; cp < 8 && new_desc[i]; i++)
		if (new_desc[i] != ' ')
			{
			buf[l++] = new_desc[i];
			cp++;
			}
	buf[l] = 0;
	
	s = stat(buf, &stt);
	if (!s)
		{
		while (i++ < 8)
			buf[l++] = '0';
		buf[l] = 0;
		}
		
	while (!s)
		{
		i = -1;
		do
			{
			if (!isdigit(buf[l + i])) buf[l + i] = '0';
			buf[l + i]++;
			if (buf[l + i] == '9' + 1)
				{
				buf[l + i] = '0';
				i--;
				if (i == -8) return;
				}
			else
				break;
			}while(TRUE);
		s = stat(buf, &stt);
		}
	
	Dcreate(buf);
	}

i = box;
if (boxes[box].type == -2 && boxes[box].expanded)
	{
	level = boxes[i++].level;
	while (i < box_count && boxes[i].level > level)
		i++;
	level++;
	}
else
	level = boxes[box].level;

boxes = (BOX_INFO *)realloc(boxes, sizeof(BOX_INFO) * (box_count + 1));
box_manager = (BOX_MANAGER *)realloc(box_manager, sizeof(BOX_MANAGER) * (box_count + 1));

if (i < box_count)
	{
	memmove(boxes + i + 1, boxes + i, sizeof(BOX_INFO) * (box_count - i));
	memmove(box_manager + i + 1, box_manager + i, sizeof(BOX_MANAGER) * (box_count - i));
	}
move_filterfolders(i, 1);
			
boxes[i].type = type;
memset(box_manager[i].box_coords, -1, sizeof(box_manager->box_coords));
memset(box_manager[i].box_cols, -1, sizeof(box_manager->box_cols));
box_manager[i].box_total = 0L;
box_manager[i].box_sort = 0;	
box_manager[i].box_entries = 0;

box_manager[i].index = NULL;
box_manager[i].index_changed = FALSE;
box_manager[i].list_wind = -1;

boxes[i].fav_index = -1;
boxes[i].expanded = FALSE;
boxes[i].level = level;
boxes[i].icon = icon;
if (type != -2)
	strcpy(boxes[i].file, sx);
strcpy(boxes[i].desc, new_desc);
strcpy(boxes[i].identity, identity);
box_count++;

redraw_treewind(-1, -1, -1, -1);
}

/* ----------------------
   | Delete mail folder |
   ---------------------- */
int delete_folder(char *box)
{
DTA myDta;
char buf[51 * 2 + MAXFILE * 2 + 1], *sx;
int s, f;

DEBUG();
base_path(buf);

strcat(buf, box);
sx = buf + strlen(buf);
strcat(buf, "\\*.*");

f = TRUE;
Fsetdta(&myDta);
s = Fsfirst(buf, 0xFF);
while(!s)
	{
	if (myDta.d_fname[0] != '.')
		{
		strcpy(sx + 1, myDta.d_fname);
		if (!Fdelete(buf))
			delete_index(myDta.d_fname, box_number(box));
		else
			f = FALSE;
		}
				
	s = Fsnext();
	}

if (f)
	{
	int err;
	
	*sx = 0;
	err = Ddelete(buf);
	return err == 0 || err == -34;
	}
return FALSE;
}

/* --------------------
   | Load box options |   
   -------------------- */
void load_box_options(char *box)
{
long f, version;
char id[15];
int i;

DEBUG();
box_count = 0;

strcpy(mailbox_opt, box);
f = Fopen(box,	FO_READ);
if (f > 0)
	{
	Fread((int)f, 12, id);
	
	if (!strncmp(id, "DrACONISMAIL", 12) || !strncmp(id, "DrACONIS MAI", 12))
		{
		Fread((int)f, 4, &version);
		if (version != 'LBOX')
			{
			Fread((int)f, sizeof(iconbfile), iconbfile);
			}

		box_count = 0;
		if (version < VERSION_ID)
			{
			char *cnvalert;
			
			rsrc_gaddr(R_STRING, OLD_BOX, &cnvalert);
			if (form_alert(2, cnvalert) != 1)
				{
				mailbox_opt[0] = 0;
				Fclose((int)f);	
				return;
				}
			}

		Fread((int)f, sizeof(box_wd), box_wd);
		Fread((int)f, sizeof(pbox_text), pbox_text);
		Fread((int)f, sizeof(box_top), &box_top);
			
		if (version != 'LBOX')
			{
			if (version == VERSION_ID17)
				{
				box_wd[0] = -1;
				tree_wd[0] = -1;
				pop_wd[0] = -1;
				pop_sort = 0;

				memset(pop_cols, -1, sizeof(pop_cols));
				
				boxes = (BOX_INFO *)malloc(sizeof(BOX_INFO) * 23);
				box_manager = (BOX_MANAGER *)malloc(sizeof(BOX_MANAGER) * 23);

				boxes[box_count].type 			= -2;
				boxes[box_count].file[0] 		= 0;
				strcpy(boxes[box_count].desc, idfolder_label);
				boxes[box_count].icon 			= -2;
				boxes[box_count].fav_index 	= -1;
				boxes[box_count].expanded 	= 1;
				boxes[box_count].level 			= 0;
				boxes[box_count].identity[0] = 0;
				boxes[box_count].auto_apply = FALSE;
				box_count++;
				
				boxes[box_count].type 			= -1;
				boxes[box_count].file[0] 		= 0;
				strcpy(boxes[box_count].desc, idfolder_entry);
				boxes[box_count].icon 			= 3;
				boxes[box_count].fav_index 	= 0;
				boxes[box_count].expanded 	= 0;
				boxes[box_count].level 			= 1;
				boxes[box_count].identity[0] = 0;
				boxes[box_count].auto_apply = FALSE;
				box_count++;

				boxes[box_count].type 			= -2;
				boxes[box_count].file[0] 		= 0;
				strcpy(boxes[box_count].desc, "default");	/* !!!! */
				boxes[box_count].icon 			= -2;
				boxes[box_count].fav_index 	= -1;
				boxes[box_count].expanded 	= 1;
				boxes[box_count].level 			= 0;
				boxes[box_count].identity[0] = 0;
				boxes[box_count].auto_apply = FALSE;
				box_count++;

				while(Fread((int)f, sizeof(BOX_INFO) - 30, boxes + box_count) == sizeof(BOX_INFO) - 30)
					{
					boxes[box_count].level = 1;
					boxes[box_count].expanded = 0;
					boxes[box_count].fav_index = box_count - 2;
					boxes[box_count].identity[0] = 0;
					boxes[box_count].auto_apply = FALSE;
					box_count++;
					}
				}
			else
				{
				Fread((int)f, sizeof(pop_sort), &pop_sort);
				Fread((int)f, sizeof(pop_cols), pop_cols);
				Fread((int)f, sizeof(pop_wd), pop_wd);
				
				Fread((int)f, sizeof(tree_wd), tree_wd);
				Fread((int)f, sizeof(box_count), &box_count);

				boxes = (BOX_INFO *)malloc(sizeof(BOX_INFO) * box_count);
				box_manager = (BOX_MANAGER *)malloc(sizeof(BOX_MANAGER) * box_count);
				
				Fread((int)f, sizeof(BOX_INFO) * box_count, boxes);
				}
			}
		else
			{
			box_wd[0] = -1;
			tree_wd[0] = -1;
			pop_wd[0] = -1;
			pop_sort = 0;

			memset(pop_cols, -1, sizeof(pop_cols));
			
			boxes = (BOX_INFO *)malloc(sizeof(BOX_INFO) * 23);
			box_manager = (BOX_MANAGER *)malloc(sizeof(BOX_MANAGER) * 23);

			boxes[box_count].type 			= -2;
			boxes[box_count].file[0] 		= 0;
			strcpy(boxes[box_count].desc, idfolder_label);
			boxes[box_count].icon 			= -2;
			boxes[box_count].fav_index 	= -1;
			boxes[box_count].expanded 	= 1;
			boxes[box_count].level 			= 0;
			boxes[box_count].identity[0] = 0;
			boxes[box_count].auto_apply = FALSE;
			box_count++;

			boxes[box_count].type 			= -1;
			boxes[box_count].file[0] 		= 0;
			strcpy(boxes[box_count].desc, idfolder_entry);
			boxes[box_count].icon 			= 3;
			boxes[box_count].fav_index 	= 0;
			boxes[box_count].expanded 	= 0;
			boxes[box_count].level 			= 1;
			boxes[box_count].identity[0] = 0;
			boxes[box_count].auto_apply = FALSE;
			box_count++;

			boxes[box_count].type 			= -2;
			boxes[box_count].file[0] 		= 0;
			strcpy(boxes[box_count].desc, "default");	/* !!!! */
			boxes[box_count].icon 			= -2;
			boxes[box_count].fav_index 	= -1;
			boxes[box_count].expanded 	= 1;
			boxes[box_count].level 			= 0;
			boxes[box_count].identity[0] = 0;
			boxes[box_count].auto_apply = FALSE;
			box_count++;

			while(Fread((int)f, sizeof(BOX_INFO) - 32, boxes + box_count) == sizeof(BOX_INFO) - 32)
				{
				if (!box_count)
					boxes[box_count].icon = 4;
				else
					boxes[box_count].icon = boxes[box_count].type + 1;
				
				boxes[box_count].level = 1;
				boxes[box_count].expanded = 0;
				boxes[box_count].fav_index = box_count - 2;
				boxes[box_count].identity[0] = 0;
				boxes[box_count].auto_apply = FALSE;
				box_count++;
				}
			}

		if (version != VERSION_ID20)
			{
			Fclose((int)f);
			save_box_options();
			f = 0;
			}
		}
	else
		{
		mailbox_opt[0] = 0;
		form_alert(1, inval_box);
		}
				
	if (f) Fclose((int)f);	
	}
else
	{
	box_wd[0] = -1;
	tree_wd[0] = -1;
	}

for (i = 0; i < box_count; i++)
	{
	box_manager[i].box_entries = 0;
	box_manager[i].list_wind = -1;
	}
}
  
/* --------------------
   | Save box options |   
   -------------------- */
void save_box_options(void)
{
long f, version;

DEBUG();
if (!mailbox_opt[0]) return;

if (tree_wind > -1)
	wind_get(tree_wind, WF_CURRXYWH, &tree_wd[0], &tree_wd[1], &tree_wd[2], &tree_wd[3]);
if (box_wind > -1)
	wind_get(box_wind, WF_CURRXYWH, &box_wd[0], &box_wd[1], &box_wd[2], &box_wd[3]);

f = Fcreate(mailbox_opt, 0);
if (f > -1L)
	{
	Fwrite((int)f, 12, "DrACONISMAIL");
	
	version = VERSION_ID;
	Fwrite((int)f, 4, &version);
	Fwrite((int)f, sizeof(iconbfile), iconbfile);
	
	Fwrite((int)f, sizeof(box_wd), box_wd);
	Fwrite((int)f, sizeof(pbox_text), pbox_text);
	Fwrite((int)f, sizeof(box_top), &box_top);

	Fwrite((int)f, sizeof(pop_sort), &pop_sort);
	Fwrite((int)f, sizeof(pop_cols), pop_cols);
	Fwrite((int)f, sizeof(pop_wd), pop_wd);

	Fwrite((int)f, sizeof(tree_wd), tree_wd);
	Fwrite((int)f, sizeof(box_count), &box_count);
	Fwrite((int)f, box_count * sizeof(BOX_INFO), boxes);
	Fclose((int)f);	
	}
}

/* -----------------------
   | Load box index file |
   ----------------------- */
void load_box_index(int box)
{
int i;
long fl, l;
char zw[256];

DEBUG();
base_path(zw);

strcat(zw, boxes[box].file);
strcat(zw, "\\INDEX");

box_manager[box].box_sort = 0;	
memset(box_manager[box].box_coords, -1, sizeof(box_manager->box_coords));
memset(box_manager[box].box_cols, -1, sizeof(box_manager->box_cols));

fl = Fopen(zw, FO_READ);
if (fl > 0)
	{
	char id[9];
	long version;
	int sub = 0;

	if (Fread((int)fl, 4, id) == 4)
		{
		id[4] = 0;
		if (!strcmp(id, "MBox"))
			{
			Fread((int)fl, 4, &version);
			if (version == '1.0b')
				version = 0x00010000L;
			
			sub = 8;
			if (version >= VERSION_ID17)
				{
				Fread((int)fl, sizeof(box_manager->box_coords), box_manager[box].box_coords);
				sub += (int)sizeof(box_manager->box_coords);
				}
				
			Fread((int)fl, sizeof(box_manager->box_sort), &box_manager[box].box_sort);
			Fread((int)fl, sizeof(box_manager->box_cols), box_manager[box].box_cols);
			sub += (int)sizeof(box_manager->box_sort) + (int)sizeof(box_manager->box_cols);
			}
		}

	if (box_manager[box].box_entries) 
		free(box_manager[box].index);
	
	if (version >= VERSION_ID20)
		{
		l = Fseek(0, (int)fl, 2) - sub;
		Fseek(sub, (int)fl, 0);
		
		if (l)
			{
			box_manager[box].index = malloc(l);
			Fread((int)fl, l, box_manager[box].index);
			}
		}
	else
		{
		int cnt;
		
		l = Fseek(0, (int)fl, 2) - sub;
		Fseek(sub, (int)fl, 0);
		cnt = l / (sizeof(MAIL_INFO) - 22 - 2 - 2);
		l = cnt * sizeof(MAIL_INFO);
		
		if (l)
			{
			int i;
			
			box_manager[box].index = malloc(l);
			
			for (i = 0; i < cnt; i++)
				{
				Fread((int)fl, sizeof(MAIL_INFO) - 22 - 2 - 2, box_manager[box].index + i);
				box_manager[box].index[i].identity[0] = 0;
				box_manager[box].index[i].color = -1;
				box_manager[box].index[i].readonly = FALSE;
				}
			}
		}
		
	Fclose((int)fl);
	box_manager[box].box_entries = (int)(l / sizeof(MAIL_INFO));
	
	box_manager[box].box_total = 0;
	for (i = 0; i < box_manager[box].box_entries; i++)
		box_manager[box].box_total += box_manager[box].index[i].body_len;
	}
else
	{
	if (box_manager[box].box_entries) free(box_manager[box].index);
	box_manager[box].box_entries = 0;
	box_manager[box].box_total = 0;
	}
}

/* -----------------------
   | Load box index file |
   ----------------------- */
void save_box_index(int box)
{
long fl;
char zw[256];

DEBUG();
base_path(zw);

strcat(zw, boxes[box].file);
strcat(zw, "\\INDEX");

fl = Fcreate(zw, 0);
if (fl > 0)
	{
	long version = VERSION_ID;
	
	Fwrite((int)fl, 4, "MBox");
	Fwrite((int)fl, 4, &version);

	Fwrite((int)fl, sizeof(box_manager->box_coords), &box_manager[box].box_coords);	/* Since: 1.7 */

	Fwrite((int)fl, sizeof(box_manager[box].box_sort), &box_manager[box].box_sort);
	Fwrite((int)fl, sizeof(box_manager[box].box_cols), &box_manager[box].box_cols);
	if (box_manager[box].box_entries)
		Fwrite((int)fl, box_manager[box].box_entries * sizeof(MAIL_INFO), box_manager[box].index);
	Fclose((int)fl);
	
	box_manager[box].index_changed = FALSE;
	}
}

/* ---------------------------
   | Build special file name |
   --------------------------- */
void build_file(char *fn)
{
static time_t last = 0;
time_t tval;

DEBUG();
tval = time(NULL);
if (tval <= last)
	tval = ++last;
else
	last = tval;

while (tval)
	{
	*fn = tval % 36;
	*fn += '0';
	if (*fn > '9')
		*fn += 7;
		
	fn++;
	tval /= 36;
	}
*fn = 0;
}

/* ----------------------
   | Find next selected |
   ---------------------- */
int fnext_sellist(int box)
{
DEBUG();
while(f_fsel[box] < box_manager[box].box_entries && !(box_manager[box].index[f_fsel[box]].sel & 1))
	f_fsel[box]++;

if (f_fsel[box] == box_manager[box].box_entries)
	return -1;
else
	return f_fsel[box]++;
}
   
/* -----------------------
   | Find first selected |
   ----------------------- */
int ffirst_sellist(int box)
{
DEBUG();
f_fsel[box] = 0;
return fnext_sellist(box);
}

/* ----------------
   | Delete index |
   ---------------- */
void delete_index(char *del_file, int box)
{
int i;

DEBUG();
for (i = 0; i < box_manager[box].box_entries; i++)
	if (!stricmp(box_manager[box].index[i].file, del_file))
		{
		box_manager[box].box_total -= box_manager[box].index[i].body_len;
		
		if (box_manager[box].box_entries - i - 1 > 0)
			memcpy(box_manager[box].index + i, 
						 box_manager[box].index + i + 1, 
						 sizeof(MAIL_INFO) * (box_manager[box].box_entries - i - 1));
			
		box_manager[box].box_entries--;
		if (!box_manager[box].box_entries)
			free(box_manager[box].index);
		else
			box_manager[box].index = (MAIL_INFO *)realloc(box_manager[box].index, 
														sizeof(MAIL_INFO) * box_manager[box].box_entries);
			
		if (i < f_fsel[box])
			f_fsel[box]--;
		}
}

/* --------------
   | Free index |
   -------------- */
void free_index(int box)
{
DEBUG();
if (box_manager[box].box_entries)
	{
	free(box_manager[box].index);
	box_manager[box].box_entries = 0;
	box_manager[box].box_total = 0;
	}
}

/* ----------------
   | Change index |
   ---------------- */
void change_index(int box, char *file, char *ofile, MAIL_MEM *buffer)
{
int i;
MAIL_INFO *new;
struct tm *mytime;
time_t mtime;

DEBUG();
for (i = 0; i < box_manager[box].box_entries; i++)
	if (!strcmp(box_manager[box].index[i].file, ofile))
		break;
		
if (i == box_manager[box].box_entries)
	{
	add_index(box, file, buffer);
	return;
	}

new = box_manager[box].index + i;
box_manager[box].box_total -= new->body_len;

if (&new_buffer == buffer)
	new->sel = 0;
else
	new->sel = 2;

if (buffer->has_attachments > 0)
	new->sel |= 8;
if (buffer->priority == 1)
	new->sel |= 16;
if (buffer->priority == 2)
	new->sel |= 32;
	
mtime = time(NULL);

strcpy(new->file,			file);
strcpy(new->from, 		buffer->from);
strcpy(new->to, 			buffer->to);
strcpy(new->subject, 	buffer->subject);
strcpy(new->identity, buffer->identity);
new->body_len 			= buffer->body_len;

mytime = localtime(&mtime);

if (buffer->date[0])
	strcpy(new->date,	buffer->date);
else
	{
	new->date[0] = 2;
	if (mytime->tm_year < 200)
		mytime->tm_year += 1900;

	sprintf(new->date + 1, "%2d %03s %04d,%02d:%02d", 
					mytime->tm_mday, m_desc[mytime->tm_mon], 
					mytime->tm_year, mytime->tm_hour, mytime->tm_min);
	}
	
box_manager[box].box_total += buffer->body_len;
}

/* -------------------------------
   | Store mail in specified box |
   ------------------------------- */
int change_mail(char *file, char *ofile, int box, MAIL_MEM *buffer)
{
char bufs[51 * 2 + MAXFILE * 2 + 1];
char bufd[51 * 2 + MAXFILE * 2 + 1], *s;

DEBUG();
change_index(box, file, ofile, buffer);
save_box_index(box);

base_path(bufs);

strcpy(bufd, bufs);
strcat(bufs, file);

strcat(bufd, boxes[box].file);

strcat(bufd, "\\");
s = bufd + strlen(bufd);

strcpy(s, ofile);
Fdelete(bufd);

strcpy(s, file);
return !Frename(0, bufs, bufd);
}

/* -----------------
   | Add new index |
   ----------------- */
void add_index(int box, char *file, MAIL_MEM *buffer)
{
MAIL_INFO *new;
struct tm *mytime;
time_t mtime;

DEBUG();
if (!box_manager[box].box_entries)
	box_manager[box].index = (MAIL_INFO *)malloc(sizeof(MAIL_INFO));
else
	box_manager[box].index = (MAIL_INFO *)realloc(box_manager[box].index, 
						sizeof(MAIL_INFO) * (box_manager[box].box_entries + 1));

new = box_manager[box].index + box_manager[box].box_entries;

if (&new_buffer == buffer)
	new->sel = 0;
else
	new->sel = 2;

if (buffer->has_attachments > 0)
	new->sel |= 8;
if (buffer->priority == 1)
	new->sel |= 16;
if (buffer->priority == 2)
	new->sel |= 32;
		
strcpy(new->file,			file);
strcpy(new->from, 		buffer->from);
strcpy(new->to, 			buffer->to);
strcpy(new->subject, 	buffer->subject);
strcpy(new->identity, buffer->identity);
new->color					= -1;
new->body_len 			= buffer->body_len;

if (buffer->date[0])
	strcpy(new->date,	buffer->date);
else
	{
	mtime = time(NULL);
	mytime = localtime(&mtime);
	if (mytime->tm_year < 200) mytime->tm_year += 1900;

	new->date[0] = 2;
	sprintf(new->date + 1, "%2d %03s %04d,%02d:%02d", 
					mytime->tm_mday, m_desc[mytime->tm_mon], 
					mytime->tm_year, mytime->tm_hour, mytime->tm_min);
	}
	
box_manager[box].box_total += buffer->body_len;
box_manager[box].box_entries++;
}

/* -------------------------------
   | Store mail in specified box |
   ------------------------------- */
int store_mail(char *file, int box, MAIL_MEM *buffer, int remove)
{
char bufs[51 * 2 + MAXFILE * 2 + 1];
char bufd[51 * 2 + MAXFILE * 2 + 1];
int ret;

DEBUG();
base_path(bufs);

strcpy(bufd, bufs);
strcat(bufs, file);

strcat(bufd, boxes[box].file);

strcat(bufd, "\\");
strcat(bufd, file);

ret = !Frename(0, bufs, bufd);

if (ret)
	{
	add_index(box, file, buffer);
	if (remove)
		remove_attaches(box, box_manager[box].box_entries - 1);
	sort_box(box);
	save_box_index(box);
	}

return ret;
}

/* --------------------
   | Create mail file |
   -------------------- */
int create_file(char *file)
{
char buf[51 * 2 + MAXFILE * 2 + 1];
long f;

DEBUG();
base_path(buf);
strcat(buf, file);
f = Fcreate(buf, 0);

if (f > 0)
	return (int)f;
else
	{
	form_alert(1, filec_error);
	return 0;
	}
}

/* --------------------
   | Create mail file |
   -------------------- */
int create_incoming(void)
{
DEBUG();
return create_file("INCOMING.EML");
}

/* --------------------
   | Create mail file |
   -------------------- */
int create_temp(char *of)
{
DEBUG();
build_file(of);
strcat(of, ".tmp");

return create_file(of);
}

/* --------------------
   | Create mail file |
   -------------------- */
int create_outgoing(char *of)
{
DEBUG();
build_file(of);
strcat(of, ".eml");

return create_file(of);
}

/* ---------------
   | Open a file |
   --------------- */
int open_file(char *file, char *box)
{
char buf[51 * 2 + MAXFILE * 2 + 1];
long f;

DEBUG();
base_path(buf);
if (box)
	{
	strcat(buf, box);
	strcat(buf, "\\");
	}
		
strcat(buf, file);
f = Fopen(buf, FO_READ);

if (f > 0)
	return (int)f;
else
	return 0;
}

/* ---------------
   | Open a file |
   --------------- */
int rwopen_file(char *file, char *box)
{
char buf[51 * 2 + MAXFILE * 2 + 1];
long f;

DEBUG();
base_path(buf);
if (box)
	{
	strcat(buf, box);
	strcat(buf, "\\");
	}
		
strcat(buf, file);
f = Fopen(buf, FO_RW);

if (f > 0)
	return (int)f;
else
	return 0;
}

/* ---------------
   | Open a file |
   --------------- */
int wcreate_file(char *file, char *box)
{
char buf[51 * 2 + MAXFILE * 2 + 1];
long f;

DEBUG();
base_path(buf);
if (box)
	{
	strcat(buf, box);
	strcat(buf, "\\");
	}
		
strcat(buf, file);
f = Fcreate(buf, FO_RW);

if (f > 0)
	return (int)f;
else
	return 0;
}

/* -----------------
   | Delete a file |
   ----------------- */
int delete_file(char *file)
{
char buf[51 * 2 + MAXFILE * 2 + 1];
int ret;

DEBUG();
base_path(buf);
strcat(buf, file);

ret = Fdelete(buf);
if (!ret || ret == -33)
	return TRUE;
else
	return FALSE;
}

/* -------------------------------
   | Store mail in specified box |
   ------------------------------- */
int store_incoming(char *file)
{
MAIL_MEM inc;
int ret;

DEBUG();
memset(&inc, 0, sizeof(inc));

quick_mailcheck(file, &inc);
ret = store_mail(file, box_number("IN"), &inc, FALSE);
clear_buffer(&inc);

return ret;
}

/* -------------------------------------
   | Move mail from one box to another |
   ------------------------------------- */
void move_mail(int src_box, int des_box)
{
char bufs[51 * 2 + MAXFILE * 2 + 1];
char bufd[51 * 2 + MAXFILE * 2 + 1];
int i;

DEBUG();
base_path(bufs);
strcpy(bufd, bufs);

strcat(bufs, boxes[src_box].file);
strcat(bufs, "\\");

strcat(bufd, boxes[des_box].file);
strcat(bufd, "\\");

for (i = 0; i < box_manager[src_box].box_entries; i++)
	if (box_manager[src_box].index[i].sel & 1)
		{
		box_manager[src_box].index[i].sel ^= 1;

		strcpy(strrchr(bufs, '\\') + 1, box_manager[src_box].index[i].file);
		strcpy(strrchr(bufd, '\\') + 1, box_manager[src_box].index[i].file);
		
		if (!Frename(0, bufs, bufd))
			{
			box_manager[src_box].box_total -= box_manager[src_box].index[i].body_len;
			box_manager[des_box].box_total += box_manager[src_box].index[i].body_len;

			if (box_manager[des_box].box_entries)
				box_manager[des_box].index = 
							(MAIL_INFO *)realloc(box_manager[des_box].index, 
																	(box_manager[des_box].box_entries + 1) * 
																				sizeof(MAIL_INFO));
			else
				box_manager[des_box].index = (MAIL_INFO *)malloc(sizeof(MAIL_INFO));
				
			memcpy(&box_manager[des_box].index[box_manager[des_box].box_entries++], &box_manager[src_box].index[i], sizeof(MAIL_INFO));
			memmove(&box_manager[src_box].index[i], &box_manager[src_box].index[i + 1], sizeof(MAIL_INFO) * (box_manager[src_box].box_entries - i - 1));
			box_manager[src_box].box_entries--;
			i--;
			}
		}

if (!box_manager[src_box].box_entries)
	free(box_manager[src_box].index);
else
	box_manager[src_box].index = (MAIL_INFO *)realloc(box_manager[src_box].index, 
																box_manager[src_box].box_entries * sizeof(MAIL_INFO));

sort_box(des_box);			
save_box_index(src_box);
save_box_index(des_box);
}

/* -------------------------------------
   | Move mail from one box to another |
   ------------------------------------- */
int move_onemail(int src_box, int des_box, int no)
{
char bufs[51 * 2 + MAXFILE * 2 + 1];
char bufd[51 * 2 + MAXFILE * 2 + 1];

DEBUG();
base_path(bufs);
strcpy(bufd, bufs);

strcat(bufs, boxes[src_box].file);
strcat(bufs, "\\");

strcat(bufd, boxes[des_box].file);
strcat(bufd, "\\");

strcpy(strrchr(bufs, '\\') + 1, box_manager[src_box].index[no].file);
strcpy(strrchr(bufd, '\\') + 1, box_manager[src_box].index[no].file);
		
if (!Frename(0, bufs, bufd))
	{
	box_manager[src_box].box_total -= box_manager[src_box].index[no].body_len;
	box_manager[des_box].box_total += box_manager[src_box].index[no].body_len;

	if (box_manager[des_box].box_entries)
		box_manager[des_box].index = (MAIL_INFO *)realloc(box_manager[des_box].index, 
																		(box_manager[des_box].box_entries + 1) * 
																		sizeof(MAIL_INFO));
	else
		box_manager[des_box].index = (MAIL_INFO *)malloc(sizeof(MAIL_INFO));
				
	memcpy(&box_manager[des_box].index[box_manager[des_box].box_entries++], &box_manager[src_box].index[no], sizeof(MAIL_INFO));
	memmove(&box_manager[src_box].index[no], &box_manager[src_box].index[no + 1], sizeof(MAIL_INFO) * (box_manager[src_box].box_entries - no - 1));
	box_manager[src_box].box_entries--;
	}
else
	return FALSE;
	
if (!box_manager[src_box].box_entries)
	free(box_manager[src_box].index);
else
	box_manager[src_box].index = (MAIL_INFO *)realloc(box_manager[src_box].index, 
																box_manager[src_box].box_entries * sizeof(MAIL_INFO));

sort_box(des_box);			
save_box_index(src_box);
save_box_index(des_box);
return TRUE;
}

/* -------------------------------------
   | Move mail from one box to another |
   ------------------------------------- */
int copy_onemail(int src_box, int des_box, int no)
{
char bufs[51 * 2 + MAXFILE * 2 + 1];
char bufd[51 * 2 + MAXFILE * 2 + 1];

DEBUG();
base_path(bufs);
strcpy(bufd, bufs);

strcat(bufs, boxes[src_box].file);
strcat(bufs, "\\");

strcat(bufd, boxes[des_box].file);
strcat(bufd, "\\");

strcat(bufs, box_manager[src_box].index[no].file);

build_file(strchr(bufd, 0));
strcat(bufd, ".eml");

if (CopyFile2File(bufd, bufs))
	{
	box_manager[des_box].box_total += box_manager[src_box].index[no].body_len;

	if (box_manager[des_box].box_entries)
		box_manager[des_box].index = (MAIL_INFO *)realloc(box_manager[des_box].index, 
																		(box_manager[des_box].box_entries + 1) * 
																		sizeof(MAIL_INFO));
	else
		box_manager[des_box].index = (MAIL_INFO *)malloc(sizeof(MAIL_INFO));
				
	memcpy(&box_manager[des_box].index[box_manager[des_box].box_entries], &box_manager[src_box].index[no], sizeof(MAIL_INFO));
	strcpy(box_manager[des_box].index[box_manager[des_box].box_entries++].file, strrchr(bufd, '\\') + 1);
	}
else
	return FALSE;
	
sort_box(des_box);			
save_box_index(des_box);
return TRUE;
}

/* -----------------
   | Select a file |
   ----------------- */
int fileselect(char *buf, char *title, char *extension)
{
int 	ex_button, ret;
char 	text_file[64];

DEBUG();
if (!path_initialized)
	{
	text_path[0] = Dgetdrv() + 'A';
	strcat(text_path, ":\\*");
	strcat(text_path, extension);
	
	path_initialized = TRUE;
	}

text_file[0] = 0;	
if (aes_version >= 0x104)
	ret = fsel_exinput(text_path, text_file, &ex_button, title);
else
	ret = fsel_input(text_path, text_file, &ex_button);

if (ret && ex_button)
	{
	strcpy(buf, text_path);
	if (strchr(buf, '\\'))
		strrchr(buf, '\\')[1] = 0;
	strcat(buf, text_file);
	return TRUE;
	}
	
return FALSE;
}

/* ----------------------
   | Select a text file |
   ---------------------- */
int text_fileselect(char *buf, char *title)
{
DEBUG();
return fileselect(buf, title, ".TXT");
}

/* ------------------
   | Save mail body |
   ------------------ */
void do_save(int box, MAIL_INFO *entry)
{
char 	*save_mem, *x;
long 	save_blen, *save_ptr, save_fh;
int 	save_width;
int 	save_lines, i, len;
char 	buf[256];

DEBUG();
if (!get_body("Save mail",
							boxes[box].file, entry, 
							&save_mem, &save_blen, &save_ptr,
					 		&save_width, &save_lines, TRUE))
	return;

if (text_fileselect(buf, menu_adr[SAVE_MSG].ob_spec.free_string))
	{
	save_fh = Fcreate(buf, 0);
	if (save_fh > 0)
		{
		i = 0;
		while(i < save_lines)
			{
			x = save_ptr[i] + save_mem;
			if (i < save_lines - 1)
				len = (int)(save_ptr[i + 1] - save_ptr[i]);
			else
				len = (int)(save_blen - save_ptr[i]);
				
			if (*x == 1 || *x == 3) 
				{
				x++;
				len--;
				}

			if (len && (x[len - 1] == '\r' || x[len - 1] == '\n'))
				{
				len--;
				if (len && (x[len - 1] == '\r' || x[len - 1] == '\n') &&
						x[len - 1] != x[len])
					len--;
				}
								
			Fwrite((int)save_fh, len, x);
			Fwrite((int)save_fh, 2, "\r\n");
			
			i++;
			}
		Fclose((int)save_fh);
		}
	}
free(save_ptr);
}

/* ------------------
   | Save mail body |
   ------------------ */
char *save_message(int box, MAIL_INFO *entry)
{
static char tmp[256];
int f, in;
FILE_MAIL_MEM header;

DEBUG();
ClearError();

f = create_temp(tmp);
if (f > 0)
	{
	in = open_file(entry->file, boxes[box].file);
	if (in)
		{
		Fread(in, sizeof(header), &header);

		if (header.magic != 0x4104)
			{
			memmove(&header.confirm_read, &header.magic, sizeof(header) - (21+21+6));
			Fseek(-(21+21+6L), f, 1);
			header.replyto_len = 0;
			header.identity[0] = 0;
			header.signature[0] = 0;
			}
		else
			if (header.version == SVERSION_ID17)
				{
				Fseek(-(21+21L), f, 1);
				header.identity[0] = 0;
				header.signature[0] = 0;
				}

		WriteStringLF(f, "Content-type: message/rfc822");
		WriteStringLF(f, "Content-transfer-encoding: text/plain");
		WriteStringLF(f, "\0");
		
		Fseek(header.body_pos, in, 0);
		CopyPart(f, in, header.body_len);
		
		Fclose(in);
		}
	Fclose(f);
	}
return tmp;
}
