/*
 * Copyright (c) Draconis Internet Package Project
 * Jens Heitmann <jh_draconis@users.sourceforge.net>
 * 
 * This software is licenced under the GNU Public License.
 * Please see COPYING for further information.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 * or have a look to http://www.gnu.org.
 * 
 * Author: Jens Heitmann
 * Version-Date: 2007-07-15
 * 
 */
 
#include "extern.h"
#include "md5glbal.h"
#include "md5.h"

/* -------------------------------------------
   | Prints a message digest in hexadecimal. |
   ------------------------------------------- */
void MDPrint(unsigned char *digest, char *dest)
{
unsigned int i;

DEBUG();
for (i = 0; i < 16; i++)
	{
	*dest++ = hexchar[digest[i] >> 4];
	*dest++ = hexchar[digest[i] & 0xF];
 	}
*dest = 0;
}

/* -------------------------------------------
   | Digests a string and prints the result. |
 	 ------------------------------------------- */
void MDString(char *string, char *dest)
{
MD5_CTX context;
unsigned char digest[16];
unsigned int len = (int)strlen(string);

DEBUG();
MD5Init(&context);
MD5Update(&context, (unsigned char *)string, len);
MD5Final(digest, &context);

MDPrint(digest, dest);
}

