																				/* ASSERT.C
																				   -------- */
void logfunc(char *file, long line);

																			/* File: ABOOK.C
																			   ------------- */
int find_matchingaddress(char *set);
int cdecl abook_obj(PARMBLK *paramblock);
void address_book(void);
void set_abookdialog(void);
void save_addresses(void);
void load_addresses(void);
char **get_group_address(char *name);

																			/* File: ABOUT.C
																			   ------------- */
void about_info(void);

																			/* File: ANSI.C
																			   ------------ */
void convert_to_ansi(unsigned char *p, long len);
void convert_from_ansi(unsigned char *p, long len);

																			/* File: ATTACH.C
																			   -------------- */
void attach_file(void);
void save_attach(char *name, int msg, char *boundary, long endpos, char *type, char *predefined);
void remove_attaches(int box, int idx);

																			/* File: AUDIO.C
																			   ------------- */
void init_audio(void);
void play_one(void);
void load_audio(char *audio);

																			/* File: BOX_IO.C
																			   -------------- */
int select_desktop_box(int mx, int my);
void folder_background(char *new, char *desc);
void scan_mailbox(char *box);
void new_box(void);
void open_box(void);
void close_box(void);
void folder_properties(int box);
void rename_folder(int box);
void delete_one(int box);
int box_number(char *box);

																			/* File: BOXWIND.C
																			   --------------- */
int number_of_favorites(void);
void update_boxinfo(void);
void redraw_boxwind(int wx, int wy, int ww, int wh);
void open_boxwind(void);
void close_boxwind(void);
void box_window_message(int *msg);
void box_button(void);
int box_move(int mouse_x, int mouse_y);

																			/* File: BUBBLE.C
																			   -------------- */
void bubble_info(int mouse_x, int mouse_y);
void show_bubble_info(int wind, char *info);
int bubble_free(char *ptr);
																			   
																			/* File: CONFIG.C
																			   -------------- */
void get_bootdrive(void);
void read_installdir(void);
void scan_provider(void);
void start_config(void);
int load_config(char *f_load);

																			/* File: CONFIRM.C
																			   --------------- */
void load_confirm(void);
void gen_confirmation(char *mailbody, long body_len, char *addr, char *idname);

																			/* File: CRYPT.C
																			   ------------- */
void crypt(char *p);

																			/* File: CURSOR.C
																			   -------------- */
void cursor_control(void);
void cursor_off(void);
void cursor_on(void);

																				/* DBGALLOC.C
																					 ---------- */
void  *dbg_malloc(char *file, long line, size_t size );
void  dbg_free(char *file, long line,  void *ptr );
void  *dbg_realloc(char *file, long line,  void *block, size_t newsize );

																			/* File: DESKTOP.C
																			   --------------- */
void desktop_button(void);

																			/* File: DIALOG.C
																			   -------------- */
void set_scrollselect(OBJECT *tree, int obj);
void BindTab(OBJECT *tree1, int obj1, int new_obj);
int CombineDialogs(OBJECT **newtree, OBJECT *tree1, OBJECT *tree2);
void SetTabPage(OBJECT *tree, int tabobj, int page, int obj, int num, int *pages);

																			/* File: DRAG.C
																			   ------------ */
void drag_list(int box, int page, int num, int win_x, int win_y, int win_w, int *cxy);

																			/* File: DRAW.C
																			   ------------ */
void blt_copy(void *from, int xf, int yf, void *to, int xt, int yt, int w, int h, int cpy_mode);
void set_default_text(void);
void draw_label(int x, int y, char *label);
void draw_editfield(int x, int y, int len, char *field, int mark_start, int mark_end);

																			/* File: ERROR.C
																				 ------------- */
void store_error(char *prefix, int code, char *string);
void show_error(int smtperror);

																			/* File: EDIT_FWD.C
																			   ---------------- */
void restore_header(int f, FILE_MAIL_MEM *header, MAIL_MEM *new_buffer);
void edit_mail(int box, MAIL_INFO *entry);
void do_forward(int box, MAIL_INFO *entry);
void simple_forward(int box, MAIL_INFO *entry, char *address, char *setidentity);
int fwd_do(void);
void fwd_paste(char *buffer);

																			/* File: EXTERNAL.C
																			   ---------------- */
void edit_externals(void);
void load_externals(void);
void save_externals(void);
int  has_external(char *file, int only_non_av);
void exec_external(char *file, char *tmp);
void free_avserver(void);

																			/* File: FILTER.C
																				 -------------- */
void edit_filters(int box);
void move_filterfolders(int from_index, int diff);
void remove_folder_rules(char *folder);
void load_filter(void);
void save_filter(void);
void apply_filter(int box);
void apply_filter_to_msg(int box, MAIL_INFO *mail);

																			/* File: FILTERAC.C
																				 ---------------- */
int fcompare_false(int box, MAIL_INFO *mail, FILTER_DEF *fdef, int idx);
int fcompare_true(int box, MAIL_INFO *mail, FILTER_DEF *fdef, int idx);
int fcompare_from(int box, MAIL_INFO *mail, FILTER_DEF *fdef, int idx);
int fcompare_subject(int box, MAIL_INFO *mail, FILTER_DEF *fdef, int idx);
int fcompare_text(int box, MAIL_INFO *mail, FILTER_DEF *fdef, int idx);
int fcompare_to(int box, MAIL_INFO *mail, FILTER_DEF *fdef, int idx);
int fcompare_cc(int box, MAIL_INFO *mail, FILTER_DEF *fdef, int idx);
int fcompare_to_and_cc(int box, MAIL_INFO *mail, FILTER_DEF *fdef, int idx);
int fcompare_priority(int box, MAIL_INFO *mail, FILTER_DEF *fdef, int idx);
int fcompare_member(int box, MAIL_INFO *mail, FILTER_DEF *fdef, int idx);
int fcompare_bigger(int box, MAIL_INFO *mail, FILTER_DEF *fdef, int idx);
int fcompare_smaller(int box, MAIL_INFO *mail, FILTER_DEF *fdef, int idx);
int fcompare_has_attachment(int box, MAIL_INFO *mail, FILTER_DEF *fdef, int idx);
int fcompare_always(int box, MAIL_INFO *mail, FILTER_DEF *fdef, int idx);
int faction_nothing(int *box, MAIL_INFO **mail, FILTER_DEF *fdef, int idx);
int faction_moveto(int *box, MAIL_INFO **mail, FILTER_DEF *fdef, int idx);
int faction_copyto(int *box, MAIL_INFO **mail, FILTER_DEF *fdef, int idx);
int faction_remove(int *box, MAIL_INFO **mail, FILTER_DEF *fdef, int idx);
int faction_forwardto(int *box, MAIL_INFO **mail, FILTER_DEF *fdef, int idx);
int faction_markcolour(int *box, MAIL_INFO **mail, FILTER_DEF *fdef, int idx);
int faction_select(int *box, MAIL_INFO **mail, FILTER_DEF *fdef, int idx);
int faction_markread(int *box, MAIL_INFO **mail, FILTER_DEF *fdef, int idx);
int faction_markunread(int *box, MAIL_INFO **mail, FILTER_DEF *fdef, int idx);
int faction_stoprules(int *box, MAIL_INFO **mail, FILTER_DEF *fdef, int idx);
int faction_skipnext(int *box, MAIL_INFO **mail, FILTER_DEF *fdef, int idx);
int faction_jumpto(int *box, MAIL_INFO **mail, FILTER_DEF *fdef, int idx);
int faction_setidentity(int *box, MAIL_INFO **mail, FILTER_DEF *fdef, int idx);
																				 
																			/* File: FIND.C
																				 ------------ */
void open_find(int top);
int replace_ask(void);
void open_replace(int top);

																			/* File: FONT.C
																				 ------------ */
int select_font_size(int x, int y);
void scan_fontnames(void);
int find_font_id(int id, char *fnt_name);
void select_font_popup(int x, int y, int *zw, char *fname);

																			/* File: FORMATML.C
																			   ---------------- */
char *parameter(char *l);
void clear_inputbuffer(void);
void go_position(int in, long pos);
long get_current_position(void);
int get_line(int in, char *line, int max);
int get_part(char *title, char *box,  MAIL_INFO *entry, char **mem, 
						 long *body_len, long **ptr, int *width, int *lines, int *ansi,
						 int head_flg, int part_no);
int get_body(char *title, char *box,  MAIL_INFO *entry, char **mem, 
						 long *body_len, long **ptr, int *width, int *lines,
						 int head_flg);
int format_mail(char *box, 	MAIL_INFO *entry, char **mem, long *blen,
								long **ptr,	int *width, int *lines, char *bdry, int *ansi);
void quick_mailcheck(char *file, MAIL_MEM *buffer);
void quick_check(int f, MAIL_MEM *buffer, FILE_MAIL_MEM *header);

																			/* File: FREEDROP.C
																			   ---------------- */
int free_droplist(int x, int y, int w, char **strings);
								
																			/* File: GENMAIL.C
																			   --------------- */
char *gen_mail(void);

																			/* File: GRAFMODE.C
																			   ---------------- */
void detect_pixeltype(void);

																			/* File: HEADERCD.C
																			   ---------------- */
void decode_header(char *line);

																			/* File: IDENTITY.C 
																				 ---------------- */
void setIdentityChange(void);
int hasDefaultIdentity(void);
int getDefaultIdentity(IDENTITY *store);
int getIdentityIndex(char *name);
IDENTITY *getIdentityPtr(int i);
int getIdentity(char *name, IDENTITY *store);
int getNumberOfIdentities(void);
char *getIdentityName(int idx);
void edit_identities(void);
void load_identities(void);
void save_identities(void);
int select_identity(int x, int y, IDENTITY *id);
int open_idsmtp(int idx);
int send_idqueue(char *identity, int all);
int check_id(char *identity, int flg);
int DialogIdentitySelect(char *buf, int x, int y, int w, char *first);

																			/* File: IMAGES.C
																			   -------------- */
void init_colorcache(void);
char *load_intro(void);
void load_my_images(void);
void load_toolcollections(void);
void load_boxcollections(void);
void load_collections(char *file);
void load_toolbuttons(void);
void load_boxicons(void);
void select_toolbuttons(void);
void select_boxicons(void);

																			/* File: INFO.C
																			   ------------ */
void clear_infostop(void);
void start_info(char *t, char *l);
void change_info(char *ninfo);
void end_info(void);
int info_stop(void);
void start_progressinfo(int number, long bytes, clock_t starttime, int download);
void change_progressinfo(int numproc, long currbytes, long currsize, long currtotal);

																			/* File: INTRO.C
																			   ------------- */
int cdecl introdraw(PARMBLK *parmblock);
void open_intro(void);
void close_intro(void);

																			/* File: MAIL.C
																			   ------------ */
void create_empty_header(void);
void external_mail(char *in_cmd);
void new_mail(char *to, char *subject);
void clear_buffer(MAIL_MEM *buffer);

																			/* File: MAIL_IO.C
																			   --------------- */
void base_path(char *buf);
void create_mailbox(char *box);
void create_new_folder(int box, int type, char *new_desc, char *identity, int icon);
int delete_folder(char *box);
void load_box_options(char *box);
void save_box_options(void);
void load_box_index(int box);
void save_box_index(int box);
void build_file(char *fn);
int fnext_sellist(int box);
int ffirst_sellist(int box);
void delete_index(char *del_file, int box);
void free_index(int box);
void change_index(int box, char *file, char *ofile, MAIL_MEM *buffer);
int change_mail(char *file, char *ofile, int box, MAIL_MEM *buffer);
void add_index(int box, char *file, MAIL_MEM *buffer);
int store_mail(char *file, int box, MAIL_MEM *buffer, int remove);
int create_file(char *file);
int create_incoming(void);
int create_outgoing(char *f);
int create_temp(char *f);
int open_file(char *file, char *box);
int rwopen_file(char *file, char *box);
int wcreate_file(char *file, char *box);
int delete_file(char *file);
int store_incoming(char *file);
void move_mail(int src_box, int des_box);
int move_onemail(int src_box, int des_box, int no);
int copy_onemail(int src_box, int des_box, int no);
void do_save(int box, MAIL_INFO *entry);
int fileselect(char *buf, char *title, char *extension);
int text_fileselect(char *buf, char *title);
char *save_message(int box, MAIL_INFO *entry);

																			/* File: MAILLIST.C
																			   ---------------- */
void set_normalmouse(void);
void set_sizemouse(void);
void calc_listbutpos(void);
void select_listbutton(int box, int no);
void list_enable(int box);
void set_listslider(int box);
void set_listinfo(int box);
void list_window(int box);
void close_listwindow(int box);
void redraw_listwindow(int box, int rx, int ry, int rw, int rh);
void list_window_message(int *msg, int box);
void list_button(int box);
void select_all_list(int box);
void unselect_all_list(int box);
int is_listwindow(int hndl);
int window_box(int hndl);
void delete_listmail(int box);
void drag_mail(int box, int page, int num);
void forward_mail(int box);
void reply_mail(int box);
void print_mail(int box);
void save_mail(int box);
void send_again(int box);
void set_sorting(int box);
void list_keybd(int idx);
int get_listwind_button(int box, int mousex, int mousey);
void redraw_listbutton(int box, int x);
void redraw_all_listbuttons(int box);
void redraw_one_selbuttons(int box);
void list_button_action(int box);
void column_resize(int box, int mouse_x, int mouse_y);
void resize_column(int box, int col);

																			/* File: MAILSEND.C
																			   ---------------- */
int close_smtp(void);
void mail_error();
int mail_send(char *f);

																			/* File: MAILWIND.C
																			   ---------------- */
void calc_butpos(void);
void select_mbbutton(int no);
void edit_enable(void);
void new_left(void);
void set_mailslider(void);
void clear_bodyline_cache(char *ptr);
void calc_bodyarea(int *xy);
void open_mailwindow(void);
int  close_mailwindow(void);
void redraw_mailwindow(int rx, int ry, int rw, int rh);
void mail_window_message(int *msg);
void redraw_wholemail(void);
void get_mailcursor(int *xy);
void mail_keybd(void);
void redraw_topedit(int lin, char *ed);
void mail_button(void);
void force_bodyredraw(void);
void redraw_mbbutton(int x);
int get_mailwind_button(int mousex, int mousey);
void mail_button_action(void); /*int obj);*/
void call_address(void);
void mark_text(void);
void unmark(void);
long get_mark(void);
void paste_mailadr(char *buffer);
void select_all_edit(void);
void check_editpaste(void);
int copy_edit(void);
void del_edit(void);
void cut_edit(void);
void paste_edit(void);
void paste_file(void);
void search_in_editor(char *ptr, int sensitive, int use_expr, int backwards, int find_mode);
int replace_editor(char *set, int ask);
void register_undo_insert(char *ed, long i);
void register_undo_delete(char *ed, long i);
void register_undo_replace(char *ed, long i);
void register_undo(char *ed, long i, int mode);
void undo_edit(void);

																			/* File: MAIN.C
																			   ------------ */
void message_handler(void);
void cdecl app_callback( int which, int *msg, EVNTDATA *ev, int kr, int br );
int check_user_message(void);

																			/* File: MATCH.C
																			   ------------- */
int matchpattern(unsigned char *s, unsigned char *p, unsigned char cs);
int matchpattern2(unsigned char *s, unsigned char *e, unsigned char *p, unsigned char cs);

																			/* File: MD5.C
																			   ----------- */
void MDString (char *string, char *dest);

																			/* File: MENU.C
																			   ------------ */
void init_menu(void);
void menu_action(int *msg);
void system_keys(void);
void enabler(void);

																			/* File: MIMEDECD.C
																			   ---------------- */
void Decode7Bit(int in, int out, char *line, char *boundary);
void Decode8Bit(int in, int out, char *line, char *boundary);
void DecodeQuoted(int in, int out, char *line, char *boundary);
void DecodeBase64(int in, int out, char *line, char *boundary);
void DecodeBinary(int in, int out, char *line, char *boundary);
void DecodeUudecode(int in, int out, char *line, char *boundary, long endpos);

void MemDecode7Bit(char **mem, long *len, int in, char *line, char *boundary, long max_end);
void MemDecode8Bit(char **mem, long *len, int in, char *line, char *boundary, long max_end);
void MemDecodeQuoted(char **mem, long *len, int in, char *line, char *boundary, long max_end);
void MemDecodeBase64(char **mem, long *len, int in, char *line, char *boundary, long max_end);
void MemDecodeBinary(char **mem, long *len, int in, char *line, char *boundary, long max_end);

void DecodeBase64Line(char *dest, char *line);

																			/* File: MIMEENCD.C
																			   ---------------- */
int EncodeFile(int in, int out, char *info, int textflg, char *name, long length, int encoding, int eight_allowed);
void EncodeBase64Line(char *dest, char *line);
void EncodeBase64Memory(char *dest, char *line, int bytes);

																			/* File: MISC.C
																			   ------------ */
short Mxmask (VOID);
char *stristr( const char *s1, const char *s2 );
long check_cookie(long cook);
void *alloc_shared(int size);
int CheckSystem(void);

int min(int a, int b);																			   
int max(int a, int b);																			   
void CopyPart(int out, int in, long length);
int CopyFile2File(char *outfile, char *infile);
void CopyFile(int out, char *infile);
int ClearError(void);
void WriteBytesLF(int f, char *buf, long len);
void WriteBytes(int f, char *buf, long len);
void BreakedStringLF(int f, char *str1, char *str2);
void WriteStringLF(int f, char *string);
void WriteString(int f, char *string);

int rc_intersect(GRECT *s1, GRECT *s2);
void ins_char(char **mem, long *len, int *lines, char **lptr, int c);
void del_char(char **mem, long *len, int *lines, char **lptr);
void clear_inbuffer(void);
int get_response( int s, char *buf);
void send_cmd(int s, char *cmd, char *par1, char *par2, char *par3);
int send_quoted(int s, char *buf, char *cmd, char *par1, char *par2, char *par3);
void default_enable(void);
void get_aesversion(void);
int check_connection(int function, char *identity, int flg);
int check_scrap(void);
int misalnum(unsigned char chr);
void not_demo(void);
void wait_mouse_release(void);
void clear_temp(void);
void check_mouse(void);

int TestIncoming(int s);
int TestException(int s);

																			/* File: OPTIONS.C
																			   --------------- */
void options(void);
void set_options(void);
void load_mail_config(int flg);
void save_mail_config(void);

																			/* File: POLL.C
																			   ------------ */
void poll_window_message(int *msg);
void setPollInitialize(void);
void stopPoll(void);
void blockPoll(int flg);
int isPolling(void);
int isIdentityUsed(char *server, char *user);
void lockIdentity(char *server, char *user);
void unlockIdentity(void);
void doPoll(void);
void load_recvids(void);
void save_recvids(void);

																			/* File: POP.C
																			   ----------- */
void calc_popbutpos(void);																			   
void select_popbutton(int no);
void pop_enable(void);
void set_popslider(void);
void pop_window(void);
void close_popwindow(void);
void redraw_popwindow(int rx, int ry, int rw, int rh);
void pop_window_message(int *msg);
void pop_button(void);
void redraw_popbutton(int x);
int get_popwind_button(int mousex, int mousey);
void redraw_all_popbuttons(void);
void press_popbutton(int n);
void mark_retrieval(void);
void mark_both(void);
void mark_deletion(void);
void pop_button_action(void);
void disconnect_pop(int s);
int connect_pop(char *server, int port, char *user, char *pass, int coded);
int pop_login(char *user, char *pass);
void clear_pop(void);
int scan_pop(char *server, int port, char *user, char *pass, int coded, 
						 int receive, int del_rcvd, long maxsize, char *identity);
void select_all(void);

																			/* File: POPUP.C
																			   ------------- */
int positioned_popup(OBJECT *poptree, int x, int y);
int popup(OBJECT *poptree);

																			/* File: PRINT.C
																			   ------------- */
void do_print(int box, MAIL_INFO *entry, int part_no);
int print_setup(void);
void gdos_print(char *mem, long *ptr, int lines, int box, MAIL_INFO *entry, int part_no);
void PrinterSetup(void);

																			/* File: PROVIDER.C
																			   ---------------- */
int provider_sel(void);

																			/* File: RCLICK.C
																			   -------------- */
void identity_popup(int box);
void queue_popup(int box);
void folder_popup(int box);
void editor_popup(void);

																			/* File: RECENT.C
																			   -------------- */
int find_matchingrecent(char *set);
void add_recent(char *url);
void recent_select(int lin, char **ptr, int *maxlen);
void save_recent(void);
void load_recent(void);

																			/* File: REPLY.C
																			   ------------- */
void do_reply(int box, MAIL_INFO *entry, 
							char *mem, long *ptr, int lines, 
							long len, long start, long end);

																			/* File: RSC.C
																			   ----------- */
int init_rsc(void);

																			/* File: SIGNATUR.C
																			   ---------------- */
SIGNATURE *getSignaturePtr(char *sig);
void edit_signatures(void);
int  select_signature(int x, int y, int w, char *sig);
void load_signatures(void);
void save_signatures(void);

																			/* File: SMTPAUTH.C
																			   ---------------- */
int smtp_auth(int smtp_s, IDENTITY *identity, int type);

																			/* File: SORT.C
																			   ------------ */
void sort_box(int box);

																			/* File: TREE.C
																			   ------------ */
void tree_enable(void);
void open_tree(void);
void close_tree(void);
void redraw_treewind(int rx, int ry, int rw, int rh);
void tree_window_message(int *msg);
int tree_select(int x, int y);
void tree_button(void);
void tree_createfolder(void);
void tree_delete(int box);

																			/* File: VIEWMAIL.C
																			   ---------------- */
void view_enable(int idx);
int view_mail(int box, MAIL_INFO *entry, int part_no);
void switch_ansiview(int idx);
void calc_viewbutpos(void);
void redraw_viewwindow(int idx, int rx, int ry, int rw, int rh);
void view_window_message(int *msg, int idx);
void set_viewslider(int idx);
void view_button(int box);
int is_viewwindow(int hndl);
int window_view(int hndl);
int link_click(int idx);
void open_attachment(int idx, int type);
void view_keybd(int idx);
void switch_headerview(int idx);
void reply_view(int idx);
void forward_view(int box);
void save_view(int idx);
void print_view(int idx);
void send_view_again(int idx);
void delete_viewmail(int idx);
void send_queue_view(int idx);
int get_viewwind_button(int idx, int mousex, int mousey);
void redraw_viewbutton(int idx, int x);
void redraw_all_viewbuttons(int idx);
void select_viewbutton(int idx, int no);
void view_button_action(int idx);
void mark_viewtext(int idx);
long get_viewmark(int idx, int mousex, int mousey);
int copy_view(int idx);

																				/* File: WINDOW.C
																					 -------------- */
void register_window(int wind);
void unregister_window(int wind);
void next_window(void);
int get_number_of_windows(void);

																				/* File: USERDEF.C
																				   --------------- */
void obj_clip(PARMBLK *parm, int flg);
void icon_copy(void *from, int xf, int yf, int xt, int yt, int w, int h);

																			/* File: MILAN.C
																			   ------------- */
void milan_check(void);
void milan_crack(void);
