typedef struct
							{
							char provider[21];
							char prov_path[MAXPATH + MAXFILE + MAXEXT];
							}PROVIDER;

typedef struct options
							{
							long dcfg;
							char provider[21];
							
/* Connect options */
							char user[36];
							char password[36];
							char phone_no[21];
							char term_before;
							char term_after;

/* Modem configuration */
							char modem_init[50];
							char modem_dial[50];
							char modem_hangup[50];
							char modem_cmdok[50];
							char modem_conmsg[50];
							char modem_fail1[50];
							char modem_fail2[50];

/* RS232 settings */
							int port;
							int baud;
							int parity;
							int bits;
							int stopbits;
							
/* Protocol options */
							long prot_cookie;
							int  protocol;
							char ip_compression;
							char soft_compression;		

/* Gateway options */
							unsigned long nameserver1;
							unsigned long nameserver2;
							unsigned long target1, gateway1;
							unsigned long target2, gateway2;
							unsigned long target3, gateway3;
							unsigned long std_gateway;
							int			subnet1, subnet2, subnet3;
							char  	default_gw;

/* TCP options */
							char ip_assign;
							unsigned long ip;
							unsigned long subnet;							
							char host[21];
							char domain[21];

/* Proxys */
							char http[41];
							char http_port[5];
							char ftp[41];
							char ftp_port[5];
							char gopher[41];
							char gopher_port[5];
							char secure[41];
							char secure_port[5];
							char exclude[3][47];
							
/* Mail */
							char email[43];
							char email2[43];
							char mailpass[43];
							char popuser[43];
							char popserver[43];
							char smtpserver[43];
							
							int  timeout;
							char netlogon, force_enc, tonline;
							
							}CFG_OPT;

typedef struct mail_set
							{
							char maildir[256];
							char mailfile[64];
							
							int  _pass_coded;
							int  save_opt;
							char _username[21];
							char _organization[21];
							int  _eight_allowed;
							int  _mime_allowed;
							int  _confirm_read;
							int  _confirm_rcpt;
							int  _priority;
							int	 _word_wrap;
							int  _send_immediately;
							int  _popauth_required;
							int	 _download_immediately;
							int  _delete_rcvd;
							int  startup_check;
							int  allow_readconfirm;
							long _maxsize;
							int	 bubblegem, allheads;
							int  printmode, print_ff, printwrap;
							char printinit[51];
							char printexit[51];
							char boldon[51];
							char boldoff[51];
							int	 pagewidth, pageheight;
							int  _editwidth;
							
							int  from_flg;
							int  sub_flg;
							int  bcc_flg;
							int  cc_flg;
							char unused[20];
							int  ansi_flg;
							char _signature_file[256];
							int	 replyto_flg;
							char toolbfile[9];
							char prt_settings[1024];
							char pad;
							
							int  viewlength;
							int  viewtabs;
							int  viewwrap, saveview;
							int	 text_colour, quoted_colour, link_colour;
							int  font, fontsize;
							int	 prompt_reply, remove_attaches;
							int	 open_notify;
							int  play_sound;
							char soundfile[256];
							int	 confirm_delete;
							int	 idline_flg;
							int	 icon_cache;
							
							int  prt_font, prt_fontsize;
							int  left_margin, right_margin;
							int  top_margin, bottom_margin;
							int  line_spacing;
							int	 use_colours, reformat;
							int	 print_header, print_footer;
							int	 print_attaches;
							}MAIL_OPT;
							
typedef struct box_info
							{
							int  type;
							char file[9], desc[21];
							int  icon;
							int	 fav_index, expanded, level, auto_apply;		/* New 2.0 */
							char identity[22];		/* New 2.0 */
							}BOX_INFO;

typedef struct box_manager
							{
							int box_entries, box_sort, box_cols[10];		/* Boxcols mit Reserve */	/* 0-4 belegt */
							int box_coords[4];														/* 5 = New 2.0 -> Identity */
							long box_total;
							MAIL_INFO *index;
							
							/* List window information  */
							int list_wind;
							int lbut_disabled[8], lbut_selected[8];
							char *list_info;
							long list_marked;
							int list_page, list_left;
							int list_marks;
							
							int index_changed;
							}BOX_MANAGER;
														
typedef struct img_head
							{
							unsigned left, top;
							unsigned w, h;
							int  planes;
							int  cols;
							int  transp;
							int	 delay;
							int	 img_width;
							int  mask_width;
							}IMG_HEAD;
							
typedef struct image_inf
											{
											long size, pos;
											}IMG_INF;

typedef struct file_fmt
							{
							long				id;
							int 				width, height, rollover;
							IMG_INF			images[10];
							}PALETTE_FILE;		
							
typedef struct identity
							{
							int  identifier;
							char name[21];
							
							int use_providerdata;

/* Mail */
							char email[43];
							char email2[43];
							char popuser[43];
							char mailpass[43];
							char popserver[43];
							char smtpserver[43];
							
							int  check;
							int  pass_coded;
							int	 download_immediately;
							int  delete_rcvd;
							long maxsize;

							int  pop_port;
							int  poll_every;
							int	 count_only;

							char username[31];
							char organization[31];

							int  smtp_port;
							int  eight_allowed;
							int  mime_allowed;
							int  send_immediately;
							int  auth_required;

							int	 word_wrap;
							int  editwidth, tabwidth;
						  char floating, quote_mail;
						  char quote_char;
							int  confirm_rcpt, last_rcpt;
							int  confirm_read, last_read;
							int  priority, last_priority;

							char reply_to1[43];
							char reply_to2[43];
							char signature[21];
													  
						  int  address_completion;

							char smtpuser[43];
							char smtppass[43];
							
							}IDENTITY;

typedef struct external
							{
							char pattern[40+1];
							char description[40+1];
							char mimetype[40+1];
							char program[256];
							int	 use_va;
							}EXTERNAL_DEF;
							
typedef struct signature
							{
							char name[21];
							int  len;
							char *sig;
							}SIGNATURE;

typedef struct filter
							{
							char folder[9];
							char name[31], condedit[3][41];
							int  cond[3], condi[3], oper[3];
							int  andor1, andor2;
							char edit[6][41];
							int  esel[3];
							int  active;
							}FILTER_DEF;
							