/*
 * Copyright (c) Draconis Internet Package Project
 * Jens Heitmann <jh_draconis@users.sourceforge.net>
 * 
 * This software is licenced under the GNU Public License.
 * Please see COPYING for further information.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 * or have a look to http://www.gnu.org.
 * 
 * Author: Jens Heitmann
 * Version-Date: 2007-07-15
 * 
 */
 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <tos.h>
#include <aes.h>
#include <setjmp.h>

extern long oldbus, oldaddr, oldillegal;

void cls_vwork(void);

jmp_buf trapcont;

long regs[18];
char buffer[81 * 25];

char *regnames[] = {"D0", "D1", "D2", "D3", "D4", "D5", "D6", "D7",
			 						  "A0", "A1", "A2", "A3", "A4", "A5", "A6", "A7",
			 						  "USP"};

void dump_locations(FILE *fh);

/*
{
int i, j;
unsigned char *stack;

printf("\nException-Type: %d at address $%08lx\n", type, regs[17]);
printf("------------------\n");

for (i = 0; i < 17; i++)
	{
	printf("%s=$%08lx", regnames[i], regs[i]);
	if (i < 16)
		printf(", ");

	if ((i + 1) % 4 == 0)
		printf("\n");
	}
printf("\n\n");

printf("Stack dump:\n");
printf("-----------\n");

stack = (unsigned char *)regs[16];
for (i = 0; i < 4; i++)
	{
	printf("%08lx: ", stack);
	for (j = 0; j < 16; j++)
		printf("%02x ", (int)*(stack++));
	printf("\n");
	}

printf("\nBasepage: $%08lx\n", _BasPag);
printf("Text segment: $%08lx		length: $%lx\n", _BasPag->p_tbase, _BasPag->p_tlen);
printf("Data segment: $%08lx		length: $%lx\n", _BasPag->p_dbase, _BasPag->p_dlen);
printf("BSS segment : $%08lx		length: $%lx\n", _BasPag->p_bbase, _BasPag->p_blen);

printf("Please report at least the 'Basepage', 'Exception type & address',\n");
printf("and the first line of the stack dump to 'jheitmann@dc2.uni-bielefeld.de'\n");
printf("Also it would be helpful, if you can describe detailed the situation\nwhen and how this error happens\n");

printf("\nPress any key...\n");
Crawcin();

cls_vwork();
appl_exit();
exit(0);
}
*/						 
/* -------------------------
   | Dump trap information |
   ------------------------- */									 
void trapinfo(int type)
{
char key;
int i, j;
unsigned char *stack;

sprintf(buffer, "\nException-Type: %d at address $%08lx\n", type, regs[17]);

#ifdef SMALLTRAP
	sprintf(buffer + strlen(buffer), "------------------\n");
	
	for (i = 0; i < 17; i++)
		{
		sprintf(buffer + strlen(buffer), "%s=$%08lx", regnames[i], regs[i]);
		if (i < 16)
			strcat(buffer, ", ");
	
		if ((i + 1) % 4 == 0)
			strcat(buffer, "\n");
		}
	strcat(buffer, "\n\n");
	
	strcat(buffer, "Stack dump:\n");
	strcat(buffer, "-----------\n");
	
	stack = (unsigned char *)regs[16];
	for (i = 0; i < 4; i++)
		{
		sprintf(buffer + strlen(buffer), "%08lx: ", stack);
		for (j = 0; j < 16; j++)
			sprintf(buffer + strlen(buffer), "%02x ", (int)*(stack++));
		strcat(buffer, "\n");
		}
#endif

sprintf(buffer + strlen(buffer), "\nBasepage: $%08lx\n", _BasPag);
sprintf(buffer + strlen(buffer), "Text segment: $%08lx		length: $%lx\n", _BasPag->p_tbase, _BasPag->p_tlen);

#ifndef SMALLTRAP
	strcat(buffer, "\nLast logged locations:\n");
	printf(buffer);
	
	dump_locations(stdout);
#else
	printf(buffer);
#endif

printf("\nPlease report the above information to 'draconis@atari.org'\n");

printf("Also it would be helpful, if you can describe detailed the situation\nwhen and how this error happens\n");

printf("\n(D)ump, (C)ontinue, E(x)it...\n");
for(;;)
	{
	key = Crawcin();

	switch (key & 0xDF)
		{
		case 'D':
			{
			FILE *fh = fopen("ADAMAS.DMP", "a+");
			
			if (fh)
				{
				fprintf(fh, ">-------------------------------<\n");
				fprintf(fh, buffer);
#				ifndef	SMALLTRAP				
					dump_locations(fh);
#				endif					
				fclose(fh);
				}
			break;
			}
		
		case 'C':
			longjmp(trapcont, 0);
			break;
	
		case 'X':
			{
			long old_stk;
			
			old_stk = Super(0L);
			*(long *)0x8 = oldbus;
			*(long *)0xC = oldaddr;
			*(long *)0x10 = oldillegal;
			Super((void *)old_stk);
			cls_vwork();
			appl_exit();
			exit(0);
			}
		}
	}
}
