/*
 * Copyright (c) Draconis Internet Package Project
 * Jens Heitmann <jh_draconis@users.sourceforge.net>
 * 
 * This software is licenced under the GNU Public License.
 * Please see COPYING for further information.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 * or have a look to http://www.gnu.org.
 * 
 * Author: Jens Heitmann
 * Version-Date: 2007-07-15
 * 
 */
 
#include "extern.h"

#ifdef EVAL
#  define NOPRINT
#endif

#ifdef MILAN
#  define NOPRINT
#endif

static char view_bdry[20][80];
static char view_file[20][13];
static int  view_box[20];
			 int 	view_wind[20];
static int 	view_count = 0;
static int 	view_lines[20];
static int 	view_width[20];
static char view_title[20][61];
static int  view_left[20];
static int  view_page[20];
static char *view_mem[20];
static long *view_ptr[20];
static int  view_sel[20];
static long view_len[20];
static int 	view_type[20];
static int	view_allh[20];
static int  view_ansi[20];
static int  view_hoffset[20];

long vmark_start[20], vmark_end[20];

int vbut_pos[10], vbut_disabled[20][10], vbut_selected[20][10];
int vbut_no[10] = {38-1, 41-1, 20-1, 23-1, 26-1, 29-1, 44-1, 47-1, 50-1, 2-1};

/* -----------------------
   | Enable view options |
   ----------------------- */
void view_enable(int idx)
{
DEBUG();
if (view_sel[idx] == -1)
	menu_ienable(menu_adr, M_SAVATT, FALSE);
else
	menu_ienable(menu_adr, M_SAVATT, TRUE);

menu_icheck(menu_adr, ALLHEAD, view_allh[idx]);
menu_ienable(menu_adr, ALLHEAD, TRUE);

menu_ienable(menu_adr, M_FWD, 	TRUE);
menu_ienable(menu_adr, M_REPLY, !boxes[view_box[idx]].type);
menu_ienable(menu_adr, M_AGAIN, boxes[view_box[idx]].type != 0 &&
																view_box[idx] != box_number("QUEUE"));
menu_ienable(menu_adr, M_SEND, 	view_box[idx] == box_number("QUEUE"));
/*menu_ienable(menu_adr, M_DELETE, TRUE);*/
menu_ienable(menu_adr, M_SELALL, FALSE);

menu_icheck(menu_adr, M_ANSI, view_ansi[idx]);

menu_ienable(menu_adr, M_COPY, vmark_start[idx] != -1);
menu_icheck(menu_adr, M_WRAP, mail_options.viewwrap);
menu_ienable(menu_adr, M_WRAP, TRUE);

#ifndef NOPRINT
	menu_ienable(menu_adr, M_PRINT, TRUE);
	menu_ienable(menu_adr, SAVE_MSG, TRUE);
#endif	
}

/* --------------------
   | Mail view slider |
   -------------------- */
void set_viewslider(int idx)
{
int wx, wy, ww, wh;
int size, pos, new, old;
int tx_width, tx_height, dummy;

DEBUG();
set_default_text();
vst_font(vdi_handle, mail_options.font);
vst_height(vdi_handle, mail_options.fontsize, &dummy, &dummy, &tx_width, &tx_height);

wind_get(view_wind[idx], WF_WORKXYWH, &wx, &wy, &ww, &wh);
if (ww + view_left[idx] * tx_width >= view_width[idx] * tx_width)
	{
	new = view_width[idx] - ww / tx_width;
	if (new < 0) new = 0;
	if (new != view_left[idx])
		{
		view_left[idx] = new;
		redraw_viewwindow(idx, wx, wy + iheight + 1, ww, wh - iheight - 1);
		}
	}
	
if (ww >= view_width[idx] * tx_width)
	{
	size = 1000;
	pos = 0;
	}
else
	{
	pos = (int)(view_left[idx] * 1000L / (view_width[idx] - ww / tx_width));
	size = (int)(ww * 1000L / tx_width / view_width[idx]);
	}
wind_get_int(view_wind[idx], WF_HSLSIZE, &old);
if (size != old)
	wind_set_int(view_wind[idx], WF_HSLSIZE, size);

wind_get_int(view_wind[idx], WF_HSLIDE, &old);
if (pos != old)
	wind_set_int(view_wind[idx], WF_HSLIDE, pos);

if ((wh - iheight - 1) / tx_height - 1 + view_page[idx] >= view_lines[idx])
	{
	new = view_lines[idx] - (wh - iheight - 1) / tx_height + 1;
	if (new < 0) new = 0;
	if (new != view_page[idx])
		{
		view_page[idx] = new;
		redraw_viewwindow(idx, wx, wy + iheight + 1, ww, wh - iheight - 1);
		}
	}
	
if ((wh - iheight - 1) / tx_height - 1 >= view_lines[idx])
	{
	if (view_page[idx] > 0)
		{
		view_page[idx] = 0;
		redraw_viewwindow(idx, wx, wy + iheight + 1, ww, wh - iheight - 1);
		}
	size = 1000;
	pos = 0;
	}
else
	{
	pos = (int)(view_page[idx] * 1000L / (view_lines[idx] - (wh - iheight - 1) / tx_height + 1));
	size = (int)(((wh - iheight - 1) / tx_height - 1) * 1000L / view_lines[idx]);
	}

wind_get_int(view_wind[idx], WF_VSLSIZE, &old);
if (size != old)
	wind_set_int(view_wind[idx], WF_VSLSIZE, size);

wind_get_int(view_wind[idx], WF_VSLIDE, &old);
if (pos != old)
	wind_set_int(view_wind[idx], WF_VSLIDE, pos);
}

/* --------------------
   | open view window |
   -------------------- */
int view_mail(int box, MAIL_INFO *entry, int part_no)
{
GRECT wrec;
int w_handle;

DEBUG();
if (view_count == 20)
	{
	form_alert(1, tomanywin_msg);
	return FALSE;
	}

full_header = view_allh[view_count];

view_ansi[view_count] = -1;
if (part_no == -1)
	{
	if (!format_mail(boxes[box].file, entry, 
										&view_mem[view_count], &view_len[view_count],
										&view_ptr[view_count], &view_width[view_count], 
										&view_lines[view_count], view_bdry[view_count],
										&view_ansi[view_count]))
		{
		full_header = FALSE;
		return FALSE;
		}
		
	view_type[view_count] = -1;
	}
else
	{
	if (!get_part(viewmail_text,
							 boxes[box].file, entry, 
							 &view_mem[view_count], &view_len[view_count], 
							 &view_ptr[view_count], &view_width[view_count], 
							 &view_lines[view_count], &view_ansi[view_count], 
							 TRUE, part_no))
		{
		full_header = FALSE;
		return FALSE;
		}
		
	view_type[view_count] = part_no;
	}
full_header = FALSE;
	
wind_get_grect(ROOT, WF_WORKXYWH, &wrec);

view_wind[view_count] = 
w_handle = wind_create(NAME|CLOSER|FULLER|MOVER|SIZER|UPARROW|DNARROW|
											 VSLIDE|LFARROW|RTARROW|HSLIDE,
											 &wrec);
											 
strncpy(view_title[view_count], entry->subject, 60);
view_title[view_count][60] = 0;

wind_set_string(w_handle, WF_NAME, view_title[view_count]);

view_left[view_count] = 0;
view_page[view_count] = 0;
view_sel[view_count] = -1;
view_box[view_count] = box;
view_allh[view_count] = 0;
strcpy(view_file[view_count], entry->file);

memset(vbut_disabled[view_count], FALSE, sizeof(vbut_disabled[0]));
memset(vbut_selected[view_count], FALSE, sizeof(vbut_selected[0]));

vbut_disabled[view_count][2] = TRUE;			/* Cut	 		*/
vbut_disabled[view_count][3] = TRUE;			/* Copy		 	*/
vbut_disabled[view_count][4] = TRUE;			/* Paste 		*/
vbut_disabled[view_count][5] = TRUE;			/* Delete		*/

#ifdef EVAL
	vbut_disabled[view_count][0] = TRUE;			/* Reply 			*/
	vbut_disabled[view_count][1] = TRUE;			/* Forward		*/
	vbut_disabled[view_count][7] = TRUE;			/* Print			*/
#endif

#ifdef MILAN
	vbut_disabled[view_count][7] = TRUE;			/* Print			*/
#endif

vmark_start[view_count] = vmark_end[view_count] = -1L;

wind_open(w_handle, &wrec);
register_window(w_handle);
set_viewslider(view_count);
view_enable(view_count++);

return TRUE;
}

/* ---------------------
   | Close view window |
   --------------------- */
void close_viewwindow(int idx)
{
DEBUG();
if (view_wind[idx] > -1)
	{
	if (view_mem[idx]) free(view_mem[idx]);
	if (view_ptr[idx]) free(view_ptr[idx]);
	
	wind_close(view_wind[idx]);
	unregister_window(view_wind[idx]);
	wind_delete(view_wind[idx]);

	view_count--;
	strcpy(view_bdry[idx], view_bdry[view_count]);
	strcpy(view_file[idx], view_file[view_count]);
	view_box[idx] 	= view_box[view_count];
	view_wind[idx] 	= view_wind[view_count];
	view_lines[idx] = view_lines[view_count];
	view_width[idx] = view_width[view_count];
	view_left[idx] 	= view_left[view_count];
	view_page[idx] 	= view_page[view_count];
	view_mem[idx] 	= view_mem[view_count];
	view_ptr[idx] 	= view_ptr[view_count];
	view_sel[idx] 	= view_sel[view_count];
	view_len[idx] 	= view_len[view_count];
	view_type[idx] 	= view_type[view_count];
	view_allh[idx] 	= view_allh[view_count];
	strcpy(view_title[idx], view_title[view_count]);
	view_allh[view_count] = 0;

	memcpy(vbut_disabled[idx], vbut_disabled[view_count], sizeof(vbut_disabled[0]));
	memcpy(vbut_selected[idx], vbut_selected[view_count], sizeof(vbut_selected[0]));
	}
}

/* --------------------
   | Toggle ansi view |
   -------------------- */
void switch_ansiview(int idx)
{
int wx, wy, ww, wh;

DEBUG();
if (view_wind[idx] > -1)
	{
	view_ansi[idx] ^= 1;
	
	if (view_ansi[idx])
		convert_from_ansi((unsigned char *)view_mem[idx], view_len[idx]);
	else
		convert_to_ansi((unsigned char *)view_mem[idx], view_len[idx]);

	wind_get(view_wind[idx], WF_WORKXYWH, &wx, &wy, &ww, &wh);
	redraw_viewwindow(idx, wx, wy, ww, wh);
	}
}

/* ---------------------------------------
   | Calculate horizontal button offsets |
   --------------------------------------- */
void calc_viewbutpos(void)
{
int ispace, ox;

ispace = isize / 2;
	
		 vbut_pos[0] = 2;																/* Reply		*/
ox = vbut_pos[1] = 2  + isize + 4;									/* Forward	*/
ox = vbut_pos[2] = ox + isize + ispace + 4;					/* Cut	 		*/
ox = vbut_pos[3] = ox + isize + 4;									/* Copy			*/
ox = vbut_pos[4] = ox + isize + 4;									/* Paste 		*/
ox = vbut_pos[5] = ox + isize + 4;									/* Delete		*/
ox = vbut_pos[6] = ox + isize + ispace + 4;					/* Save			*/
ox = vbut_pos[7] = ox + isize + 4;									/* Print		*/
ox = vbut_pos[8] = ox + isize + ispace + 4;					/* Delete		*/
		 vbut_pos[9] = ox + isize + ispace + 4;					/* Close		*/
}

/* -------------------------
   | Draw a toolbar button |
   ------------------------- */
void draw_viewbutton(int idx, int no, int x, int y)
{
int bnum;

DEBUG();
bnum = vbut_no[no]; 
if (vbut_disabled[idx][no])
	bnum += 2;
else
	if (vbut_selected[idx][no])
		bnum++;
		
blt_copy(mw_toolbar, 0, bnum * iheight, NULL, x, y, isize, iheight, S_ONLY);
}

/* ----------------------------------------
   | Redraw toolbar of mail editor window |
   ---------------------------------------- */
void redraw_viewbar(int idx)
{
int wx, wy, ww, wh;
int x, w;

DEBUG();
wind_get(view_wind[idx], WF_WORKXYWH, &wx, &wy, &ww, &wh);

x = wx;
w = ww;
while (w > 0)
	{
	blt_copy(mw_toolbar, 0, 0 * iheight, NULL, x, wy, isize, iheight, S_ONLY);
	x += isize;
	w -= isize;
	}	

draw_viewbutton(idx, 0, wx + vbut_pos[0], wy);			/* Reply 		*/
draw_viewbutton(idx, 1,	wx + vbut_pos[1], wy);			/* Forward	*/
draw_viewbutton(idx, 2, wx + vbut_pos[2], wy);			/* Cut	 		*/
draw_viewbutton(idx, 3, wx + vbut_pos[3], wy);			/* Copy		 	*/
draw_viewbutton(idx, 4, wx + vbut_pos[4], wy);			/* Paste 		*/
draw_viewbutton(idx, 5, wx + vbut_pos[5], wy);			/* Delete		*/
draw_viewbutton(idx, 6, wx + vbut_pos[6], wy);			/* Save		 	*/
draw_viewbutton(idx, 7, wx + vbut_pos[7], wy);			/* Print  	*/
draw_viewbutton(idx, 8, wx + vbut_pos[8], wy);			/* Delete  	*/
draw_viewbutton(idx, 9, wx + vbut_pos[9], wy);			/* Close  	*/
}

/* ------------------
   | Draw body text |
   ------------------ */
void draw_vtext(int idx, int x, int y, char *buf, char *ptr, int len, int colour, int marklinks)
{
int soff = -1, eoff = -1;
char sc, ec;

DEBUG();
memcpy(buf, ptr, len);
buf[len] = 0;

if (colours > 4)
	vst_color(vdi_handle, colour);
if (vmark_start[idx] != -1 &&
		ptr < vmark_end[idx] + view_mem[idx] &&
		ptr + len > vmark_start[idx] + view_mem[idx])
	{
	if (vmark_start[idx] + view_mem[idx] > ptr && vmark_start[idx] + view_mem[idx] < ptr + len)
		soff = (int)(vmark_start[idx] + view_mem[idx] - ptr);

	if (vmark_end[idx] + view_mem[idx] > ptr && vmark_end[idx] + view_mem[idx] < ptr + len)
		eoff = (int)(vmark_end[idx] + view_mem[idx] - ptr);
	
	if (soff == -1 && eoff == -1)
		{
		int ext[8], fxy[4];
		
		vst_color(vdi_handle, 0);
		vqt_extent(vdi_handle, buf, ext);
		fxy[0] = x;
		fxy[1] = y;
		fxy[2] = abs(ext[2] - ext[6]) - 1 + x;
		fxy[3] = abs(ext[3] - ext[7]) - 1 + y;
		vr_recfl(vdi_handle, fxy);
		v_gtext(vdi_handle, x, y, buf);
		vst_color(vdi_handle, colour);
		}
	else
		{
		int ext[8], fxy[4], sw;

		if (soff > -1)
			{
			sc = buf[soff];
			buf[soff] = 0;
			v_gtext(vdi_handle, x, y, buf);
			vqt_extent(vdi_handle, buf, ext);
			sw = abs(ext[2] - ext[6]);
			buf[soff] = sc;
			}
		else
			sw = soff = 0;
		
		if (eoff > -1)
			{
			ec = buf[eoff];
			buf[eoff] = 0;
			}
			
		vst_color(vdi_handle, 0);
		vqt_extent(vdi_handle, buf + soff, ext);
		fxy[0] = x + sw;
		fxy[1] = y;
		fxy[2] = abs(ext[2] - ext[6]) - 1 + fxy[0];
		fxy[3] = abs(ext[3] - ext[7]) - 1 + fxy[1];
		vr_recfl(vdi_handle, fxy);
		v_gtext(vdi_handle, x + sw, y, buf + soff);
		vst_color(vdi_handle, colour);
		
		if (eoff > -1)
			{
			buf[eoff] = ec;
			v_gtext(vdi_handle, fxy[2] + 1, y, buf + eoff);
			}
		}
	}		
else
	{
	char *s1, *s2, *s3, *s4, *p, pc;
	int nx, extent[8], w;
	
	s1 = strstr(buf, "http:");
	s2 = strstr(buf, "ftp:");
	s3 = strstr(buf, "mailto:");
	s4 = strchr(buf, '@');
	if (s4)
		if (s4 == buf || !isalnum(s4[-1]) || !isalnum(s4[1])) 
			s4 = NULL;
		else
			while(s4 > buf && (isalnum(s4[-1]) || s4[-1] == '.' || s4[-1] == '_')) 
				s4--;
		
		
	if (marklinks && (s1 || s2 || s3 || s4))
		{
		nx = x;
		p = buf;
		
		do
			{
			if (!s1) s1 = s2;
			if (!s1) s1 = s3;
			if (!s1) s1 = s4;
			if (s2 < s1 && s2) s1 = s2;
			if (s3 < s1 && s3) s1 = s3;
			if (s4 < s1 && s4) s1 = s4;
			
			pc = *s1;
			*s1 = 0;
			v_gtext(vdi_handle, nx, y, p);
			vqt_extent(vdi_handle, p, extent);
			
			w = extent[4] - extent[6];
			nx += w;
			*s1 = pc;
			
			p = s1;
			while(*p && !isspace(*p) && *p != '"')
				p++;
				
			if ((isspace(*p) || !*p) && (p[-1] == '.' || p[-1] == '!' || p[-1] == '?' || p[-1] == ';'))
				p--;
			
			vst_color(vdi_handle, mail_options.link_colour);
			pc = *p;
			*p = 0;
			v_gtext(vdi_handle, nx, y, s1);
			vqt_extent(vdi_handle, s1, extent);
			
			w = extent[4] - extent[6];
			nx += w;
			*p = pc;
			vst_color(vdi_handle, colour);
			
			s1 = strstr(p, "http:");
			s2 = strstr(p, "ftp:");
			s3 = strstr(p, "mailto:");
			s4 = strchr(p, '@');
			if (s4)
				if (s4 == buf || !isalnum(s4[-1]) || !isalnum(s4[1])) 
					s4 = NULL;
				else
					while(s4 > buf && (isalnum(s4[-1]) || s4[-1] == '.' || s4[-1] == '_')) 
						s4--;
			}while(s1 || s2 || s3 || s4);
		v_gtext(vdi_handle, nx, y, p);
		}
	else
		v_gtext(vdi_handle, x, y, buf);
	}
}

char *wrap_mem = NULL;
char *wrapptr[4];

/* ------------------------
	 | Wrap attachment text |
	 ------------------------ */
char **wrap_text(char *s, int *l)
{
char *wptr;
int c, wc = 0;

if (wrap_mem)
	free(wrap_mem);

*l = 0;
wptr = wrap_mem = (char *)malloc(strlen(s) + 5);
while (*s && wc < 3)
	{
	int mc;
	c = 0;
	
	mc = 0;
	while(s[c])
		{
		while (s[c] && (isalnum(s[c]) || ((s[c] == '\'' || s[c] == '"') && isalnum(s[c + 1]))))
			c++;
		while (s[c] && !isalnum(s[c]) && ((s[c] != '\'' && s[c] != '"') || !isalnum(s[c + 1])))
			c++;
			
		if (c < 30 || mc == 0)
			mc = c;
		else
			break;
		}
		
	wrapptr[wc++] = wptr;
	strncpy(wptr, s, mc);
	if (mc > 30)
		{
		wptr[30] = 0;
		wptr += 31;
		if (*l < 30) *l = 30;
		}
	else
		{
		wptr[mc] = 0;
		wptr += mc + 1;
		if (*l < mc) *l = mc;
		}
	s += mc;
	}
wrapptr[wc] = NULL;
return wrapptr;
}

/* ----------------------
   | Redraw list window |
   ---------------------- */
void redraw_viewwindow(int idx, int rx, int ry, int rw, int rh)
{
GRECT t1, t2;
int xy[4], xy2[4];
int wx, wy, ww, wh;
int x, y, w, lw, tx_width, tx_height, dummy, to_colon;
int hg, l, msg, att, att_offset, att_count, max_att_lines;
char *buf;
int extent[8];

DEBUG();
t2.g_x = rx;
t2.g_y = ry;
t2.g_w = rw;
t2.g_h = rh;

wind_update(BEG_UPDATE);
graf_mouse(M_OFF, 0L);

wind_get(view_wind[idx], WF_WORKXYWH, &wx, &wy, &ww, &wh);

set_default_text();
vst_font(vdi_handle, mail_options.font);
vst_height(vdi_handle, mail_options.fontsize, &dummy, &dummy, &tx_width, &tx_height);

hg = (wh - iheight - 1 + tx_height - 1) / tx_height - 1;
x = wx;
buf = (char *)malloc(w = ww / tx_width + 1);

max_att_lines = 0;
vqt_extent(vdi_handle, attachm_text, extent);
to_colon = abs(extent[2] - extent[0]);
for (msg = 0; msg < view_lines[idx] && view_mem[idx][view_ptr[idx][msg]] == 1; msg++)
	{
	char xbuf[14], *ptr;
	int w;
		
	memcpy(xbuf, view_mem[idx] + view_ptr[idx][msg] + view_left[idx] + 1, 13);
	xbuf[13] = 0;
	
	ptr = xbuf;
	while(*ptr == ' ') ptr++;
						
	vqt_extent(vdi_handle, ptr, extent);
	w = abs(extent[2] - extent[0]);
	if (w > to_colon) to_colon = w;
	}
view_hoffset[idx] = to_colon;

wind_get(view_wind[idx], WF_FIRSTXYWH, &t1.g_x, &t1.g_y, &t1.g_w, &t1.g_h);
while(t1.g_w && t1.g_h)
	{
	y = wy + iheight + 1;
	if (rc_intersect(&t2, &t1))
		{
		xy[0] = t1.g_x;
		xy[1] = t1.g_y;
		xy[2] = t1.g_x + t1.g_w - 1;
		xy[3] = t1.g_y + t1.g_h - 1;
		vs_clip(vdi_handle, 1, xy);

		redraw_viewbar(idx);

		vswr_mode(vdi_handle, MD_REPLACE);
		xy2[0] = wx;
		xy2[1] = y;
		xy2[2] = wx + ww - 1;
		xy2[3] = wy + wh - 1;
		vsf_interior(vdi_handle, FIS_HOLLOW);
		vr_recfl(vdi_handle, xy2);

		xy2[0] = wx;
		xy2[2] = wx + ww - 1;
		xy2[1] = xy2[3] = wy + iheight;
		v_pline(vdi_handle, 2, xy2);

		vswr_mode(vdi_handle, MD_TRANS);
		vsf_color(vdi_handle, 1);
		vsf_interior(vdi_handle, FIS_SOLID);

		att = 0;
		att_offset = tx_width * 2;
		att_count = 0;
		for (msg = view_page[idx], l = 0; l < hg && msg - att_count < view_lines[idx]; l++, msg++)
			if (view_ptr[idx][msg] < view_len[idx])
				{
				lw = (int)(view_ptr[idx][msg + 1] - view_ptr[idx][msg] - 1);
				if (lw > view_left[idx] || view_mem[idx][view_ptr[idx][msg]] == 2)
					{
					lw -= view_left[idx];
					if (lw > w) lw = w;
					
					switch(view_mem[idx][view_ptr[idx][msg]])
						{
						case 0x2:
							if (view_type[idx] == -1)
								{
								char *s, **wrapped;
								int cx, cy, cw, ch, att_width, l, i;
								
								vst_font(vdi_handle, 1);
								set_default_text();
								s = view_mem[idx] + view_ptr[idx][msg] + 1 + 2 + 8;
								
								if (!*s)
									s += strlen(s) + 1;
								if (!*s)
									s += strlen(s) + 1;
		
								vst_height(vdi_handle, 4, &cx, &cy, &cw, &ch);
	
								wrapped = wrap_text(s, &l);
								att_width = cw * l;
								if (att_width < 32) att_width = 32;
								
								blt_copy(boxicons, 0, 5 * 32, NULL, 
												 x + att_offset + att_width / 2 - 16 - view_left[idx] * tx_width,
						  		 			 y, 32, 32, 
						  		 			 (view_sel[idx] == att_count) ? S_OR_NOTD : S_ONLY);
		
								i = 0;
								while(wrapped[i])
									{
									int sl = (int)strlen(wrapped[i]);
									
									if (i > max_att_lines)
										max_att_lines = i;
									v_gtext(vdi_handle, x + (l * cw / 2) - (sl * cw / 2) + att_offset - view_left[idx] * tx_width, y + 38 + i * ch, wrapped[i]);
									i++;
									}
									
								att_offset += att_width;
								att_offset += tx_width;
								att++;
								att_count++;
								if (att == 4)
									{
									y += icon_height + max_att_lines * ch;
									att = 0;
									att_offset = tx_width * 2;
									max_att_lines = 0;
									}
								set_default_text();
								l--;
								break;
								}
							
						case 0x1:
							{
							char xbuf[14];
							int w, extent[8];
							
							vst_effects(vdi_handle, 1);
	
							if (view_allh[idx])
								draw_vtext(idx, x + 20, y, buf, view_mem[idx] + view_ptr[idx][msg] + view_left[idx] + 1, lw - 1, mail_options.text_colour, FALSE);
							else
								{
								memcpy(xbuf, view_mem[idx] + view_ptr[idx][msg] + view_left[idx] + 1, 13);
								xbuf[13] = 0;
								if (lw - 1 < 13)
									xbuf[lw] = 0; 
								
								vqt_extent(vdi_handle, xbuf, extent);
								w = abs(extent[2] - extent[0]);
								draw_vtext(idx, x + to_colon + 20 - w, y, buf, view_mem[idx] + view_ptr[idx][msg] + view_left[idx] + 1, lw - 1, mail_options.text_colour, FALSE);
								}
							vst_effects(vdi_handle, 0);
							y += tx_height;
							break;
							}
							
						case 0x3: /* Reply */
							{
							draw_vtext(idx, x, y, buf, view_mem[idx] + view_ptr[idx][msg] + view_left[idx] + 1, lw - 1, mail_options.quoted_colour, TRUE);
							y += tx_height;
							break;
							}
							
						default:
							if (att_count > 0)
								break;
							draw_vtext(idx, x, y, buf, view_mem[idx] + view_ptr[idx][msg] + view_left[idx], lw, mail_options.text_colour, TRUE);
							y += tx_height;
							break;
						}
					}
				else
					{
					if (att_count > 0)
						break;
					y += tx_height;
					}
				}
			else
				break;
				
		vswr_mode(vdi_handle, MD_REPLACE);
		vs_clip(vdi_handle, 0, xy);
		}

	wind_get(view_wind[idx], WF_NEXTXYWH, &t1.g_x, &t1.g_y, &t1.g_w, &t1.g_h);
	}
free(buf);
vst_font(vdi_handle, 1);

graf_mouse(M_ON, 0L);
wind_update(END_UPDATE);
}

/* --------------------------
   | Message on view window |
   -------------------------- */
void view_window_message(int *msg, int idx)
{
int wx, wy, ww, wh;
int tx_width, tx_height, dummy;

DEBUG();
set_default_text();
vst_font(vdi_handle, mail_options.font);
vst_height(vdi_handle, mail_options.fontsize, &dummy, &dummy, &tx_width, &tx_height);
		
wind_get(view_wind[idx], WF_WORKXYWH, &wx, &wy, &ww, &wh);
switch(msg[0])
	{
	case WM_REDRAW:
		redraw_viewwindow(idx, msg[4], msg[5], msg[6], msg[7]);
		break;
		
	case WM_CLOSED:
		close_viewwindow(idx);
		enabler();
		break;
		
	case WM_ARROWED:
		{
		switch(msg[4])
			{
			case WA_UPPAGE:
				if (view_page[idx] > 0) 
					{
					view_page[idx] -= (wh - iheight - 1) / tx_height - 1;
					if (view_page[idx] < 0) view_page[idx] = 0;
					redraw_viewwindow(idx, wx, wy + iheight + 1, ww, wh - iheight - 1);
					set_viewslider(idx);
					}
				break;
				
			case WA_DNPAGE:
				if (view_page[idx] + ((wh - iheight - 1) / tx_height - 1) < view_lines[idx])
					{
					view_page[idx] += (wh - iheight - 1) / tx_height - 1;
					if (view_page[idx] + ((wh - iheight - 1) / tx_height - 1) >= view_lines[idx]) 
						view_page[idx] = view_lines[idx] - (wh - iheight - 1) / tx_height + 1;

					redraw_viewwindow(idx, wx, wy + iheight + 1, ww, wh - iheight - 1);
					set_viewslider(idx);
					}
				break;
				
			case WA_UPLINE:
				if (view_page[idx] > 0) 
					{
					view_page[idx]--;
					blt_copy(NULL, wx, wy + iheight + 1, NULL, wx, wy + iheight + 1 + tx_height, ww, wh - iheight - 1 - tx_height, S_ONLY);
					redraw_viewwindow(idx, wx, wy + iheight + 1, ww, tx_height);
					set_viewslider(idx);
					}
				break;
				
			case WA_DNLINE:
				if (view_page[idx] + ((wh - iheight - 1) / tx_height - 1) < view_lines[idx])
					{
					view_page[idx]++;
					blt_copy(NULL, wx, wy + iheight + 1 + tx_height, NULL, wx, wy + iheight + 1, ww, wh - iheight - 1 - tx_height, S_ONLY);
					redraw_viewwindow(idx, wx, wy + wh - tx_height - ((wh - iheight - 1) % tx_height), 
																 ww, tx_height + ((wh - iheight - 1) % tx_height));
					set_viewslider(idx);
					}
				break;
				
			case WA_LFPAGE:
				if (view_left[idx] > 0) 
					{
					view_left[idx] -= ww / tx_width;
					if (view_left[idx] < 0) view_left[idx] = 0;
					redraw_viewwindow(idx, wx, wy + iheight + 1, ww, wh - iheight - 1);
					set_viewslider(idx);
					}
				break;
				
			case WA_RTPAGE:
				if (view_left[idx] + (ww / tx_width) < view_width[idx])
					{
					view_left[idx] += ww / tx_width;
					if (view_left[idx] + (ww / tx_width) >= view_width[idx]) 
						view_left[idx] = view_width[idx] - ww / tx_width;

					redraw_viewwindow(idx, wx, wy + iheight + 1, ww, wh - iheight - 1);
					set_viewslider(idx);
					}
				break;
				
			case WA_LFLINE:
				if (view_left[idx] > 0)
					{
					view_left[idx]--;
					blt_copy(NULL, wx, wy + iheight + 1, NULL, wx + tx_width, wy + iheight + 1, ww - tx_width, wh - iheight - 1, S_ONLY);
					redraw_viewwindow(idx, wx, wy + iheight + 1, tx_width, wh - iheight - 1);
					set_viewslider(idx);
					}
				break;
				
			case WA_RTLINE:
				if (view_width[idx] - view_left[idx] > ww / tx_width)
					{
					view_left[idx]++;
					blt_copy(NULL, wx + tx_width, wy + iheight + 1, NULL, wx, wy + iheight + 1, ww - tx_width, wh - iheight - 1, S_ONLY);
					redraw_viewwindow(idx, wx + ww - tx_width - (ww % tx_width), wy + iheight + 1, tx_width + (ww % tx_width), wh - iheight - 1);
					set_viewslider(idx);
					}
				break;
			}
		break;
		}
		
	case WM_HSLID:
	  view_left[idx] = (int)((long)msg[4] * (view_width[idx] - ww / tx_width) / 1000);
		redraw_viewwindow(idx, wx, wy + iheight + 1, ww, wh - iheight - 1);
		set_viewslider(idx);
		break;
		
	case WM_VSLID:
	  view_page[idx] = (int)((long)msg[4] * (view_lines[idx] - wh / tx_height + 1) / 1000);
		redraw_viewwindow(idx, wx, wy + iheight + 1, ww, wh - iheight - 1);
		set_viewslider(idx);
		break;
	}			
}

/* ----------------------
   | Redraw list window |
   ---------------------- */
int find_viewattachment(int idx, int mousex, int mousey)
{
int wx, wy, ww, wh;
int y;
int hg, l, msg, att, att_offset, att_count, max_att_lines;
int tx_width, tx_height, dummy;

DEBUG();
set_default_text();
vst_font(vdi_handle, mail_options.font);
vst_height(vdi_handle, mail_options.fontsize, &dummy, &dummy, &tx_width, &tx_height);

wind_get(view_wind[idx], WF_WORKXYWH, &wx, &wy, &ww, &wh);

hg = (wh - iheight - 1 + tx_height - 1) / tx_height - 1;
y = wy + iheight + 1;

max_att_lines = 0;
att = 0;
att_offset = tx_width * 2;
att_count = 0;
for (msg = view_page[idx], l = 0; l < hg && msg - att_count < view_lines[idx]; l++, msg++)
	{
	if (view_mem[idx][view_ptr[idx][msg]] == 2)
		{
		char *s, **wrapped;
		int cx, cy, cw, ch, att_width, l, i;
		
		vst_font(vdi_handle, 1);
		set_default_text();
		s = view_mem[idx] + view_ptr[idx][msg] + 1 + 2 + 8;
		if (!*s)
			s += strlen(s) + 1;
		if (!*s)
			s += strlen(s) + 1;

		vst_height(vdi_handle, 4, &cx, &cy, &cw, &ch);
						
		wrapped = wrap_text(s, &l);
		att_width = cw * l;
		if (att_width < 32) att_width = 32;
			
		i = 0;
		while(wrapped[i])
			{
			if (i > max_att_lines)
				max_att_lines = i;
			i++;
			}
			
		if (mousex >= wx + att_offset + att_width / 2 - 16 - view_left[idx] * tx_width && 
				mousex < wx + att_offset + att_width / 2 + 16 - view_left[idx] * tx_width &&
				mousey >= y && mousey < y + icon_height + i * ch)
			return att_count;

		att_count++;	
		att_offset += att_width;
		att_offset += tx_width;
		att++;
		if (att == 4)
			{
			y += icon_height + max_att_lines * ch;
			att = 0;
			att_offset = tx_width * 2;
			max_att_lines = 0;
			}
		l--;
		}
	else
		{
		if (att_count > 0)
			break;
		y += tx_height;
		}
	}
return -1;
}

/* ----------------------
   | Redraw list window |
   ---------------------- */
void get_attachmentpos(int idx, int att_no, int *ax, int *ay, int *aw, int *ah)
{
int wx, wy, ww, wh;
int x, y;
int hg, l, msg, att, att_offset, att_count, max_att_lines;
int tx_width, tx_height, dummy;

DEBUG();
set_default_text();
vst_font(vdi_handle, mail_options.font);
vst_height(vdi_handle, mail_options.fontsize, &dummy, &dummy, &tx_width, &tx_height);

wind_get(view_wind[idx], WF_WORKXYWH, &wx, &wy, &ww, &wh);

hg = (wh + tx_height - 1) / tx_height - 1;
x = wx;
y = wy;

max_att_lines = 0;
att = 0;
att_offset = tx_width * 2;
att_count = 0;
for (msg = view_page[idx], l = 0; l < hg && msg - att_count < view_lines[idx]; l++, msg++)
	{
	if (view_mem[idx][view_ptr[idx][msg]] == 2)
		{
		char *s, **wrapped;
		int cx, cy, cw, ch, att_width, l, i;
		
		vst_font(vdi_handle, 1);
		set_default_text();
		s = view_mem[idx] + view_ptr[idx][msg] + 1 + 2 + 8;
		if (!*s)
			s += strlen(s) + 1;
		if (!*s)
			s += strlen(s) + 1;

		vst_height(vdi_handle, 4, &cx, &cy, &cw, &ch);

		wrapped = wrap_text(s, &l);
		att_width = cw * l;
		if (att_width < 32) att_width = 32;

		i = 0;
		while(wrapped[i])
			{
			if (i > max_att_lines)
				max_att_lines = i;
			i++;
			}
			
		if (att_count == att_no)
			{
			*ax = x + att_offset;
			*ay = y;
			*aw = att_width;
			*ah = 4 * tx_height;
			return;
			}

		att_count++;	
		att_offset += att_width;
									
		att_offset += tx_width;
		att++;
		if (att == 4)
			{
			y += icon_height + max_att_lines * ch;
			att = 0;
			att_offset = tx_width * 2;
			max_att_lines = 0;
			}
		}
	else
		{
		if (att_count > 0)
			break;
		y += tx_height;
		}
	}
}

/* ------------------------
   | Click on view window |
   ------------------------ */
void view_button(int idx)
{
int sel_att;
int ax, ay, aw, ah;
int wx, wy, ww, wh;
OBJECT *poptree;

DEBUG();
if (evnt.bstate & 1)
	{
	wind_get(view_wind[idx], WF_WORKXYWH, &wx, &wy, &ww, &wh);

	if (evnt.y >= wy && evnt.y < wy + iheight)
		{
		view_button_action(idx);
		return;
		}
	}
	
sel_att = find_viewattachment(idx, evnt.x, evnt.y);
if (sel_att != view_sel[idx])
	{
	get_attachmentpos(idx, view_sel[idx], &ax, &ay, &aw, &ah);

	view_sel[idx] = sel_att;
	redraw_viewwindow(idx, ax, ay, aw, ah);
	if (sel_att > -1)
		{
		get_attachmentpos(idx, sel_att, &ax, &ay, &aw, &ah);
		redraw_viewwindow(idx, ax, ay, aw, ah);
		}
	}

if (clicks == 2 && sel_att == -1)
	{
	if (link_click(idx))
		return;
	}
	
if (sel_att == -1)
	mark_viewtext(idx);

if (evnt.bstate & 2)
	{
	rsrc_gaddr(R_TREE, V_POPUP, &poptree);

	if (view_sel[idx] > -1)
		poptree[V_SAVATT].ob_state &= ~DISABLED;
	else
		poptree[V_SAVATT].ob_state |= DISABLED;
			
	switch(popup(poptree))
		{
		case V_VIEWAT:	open_attachment(idx, 1);						break;
		case V_OPENATT:	open_attachment(idx, 2);						break;
		case V_SAVATT:	open_attachment(idx, 0);					 	break;
		case V_CLOSE:		close_viewwindow(idx); 	enabler(); 	break;
		}
	}
else
	{
	if (clicks == 2 && view_sel[idx] > -1)
		{
		open_attachment(idx, -1);
		view_sel[idx] = -1;
		redraw_viewwindow(idx, ax, ay, aw, ah);
		}
	}
view_enable(idx);
}

/* --------------------------------------------
   | Return if window is a opened list window |
   -------------------------------------------- */
int is_viewwindow(int hndl)
{
int i;

DEBUG();
for (i = 0; i < view_count; i++)
	if (view_wind[i] == hndl)
		return TRUE;
return FALSE;
}

/* --------------------------------------
   | Return box index for a list window |
   -------------------------------------- */
int window_view(int hndl)
{
int i;

DEBUG();
for (i = 0; i < view_count; i++)
	if (view_wind[i] == hndl)
		return i;
return -1;
}

/* ----------------------
   | Execute link click |
   ---------------------- */
int link_click(int idx)
{
char *s1, *s2, *s3, *s4, *p, pc;
int nx, extent[8], w;
int wx, wy, ww, wh;
int y, x, lw;
int hg, l, msg, fnd, att_count;
int tx_width, tx_height, dummy;

DEBUG();
set_default_text();
vst_font(vdi_handle, mail_options.font);
vst_height(vdi_handle, mail_options.fontsize, &dummy, &dummy, &tx_width, &tx_height);

wind_get(view_wind[idx], WF_WORKXYWH, &wx, &wy, &ww, &wh);

hg = (wh - iheight - 1 + tx_height - 1) / tx_height - 1;
y = wy + iheight + 1;
x = wx;

att_count = 0;
fnd = -1;
for (msg = view_page[idx], l = 0; l < hg && msg - att_count < view_lines[idx]; l++, msg++)
	{
	if (view_mem[idx][view_ptr[idx][msg]] == 2)
		{
		att_count++;
		l--;
		}
	else
		{
		if (evnt.y >= y && evnt.y < y + tx_height)
			{
			fnd = msg;
			break;
			}
		
		if (att_count > 0)
			break;
				
		y += tx_height;
		}
	}

if (fnd == -1)
	return FALSE;

lw = (int)(view_ptr[idx][fnd + 1] - view_ptr[idx][fnd] - 1);
if (lw > view_left[idx])
	{
	char *ptr;
	char *buf;
	
	lw -= view_left[idx];

	ptr = view_mem[idx] + view_ptr[idx][msg];
	if (*ptr >= 1 && *ptr <= 3)
		ptr++;

	buf = (char *)malloc(lw + 1);
	memcpy(buf, ptr, lw);
	buf[lw] = 0;
	
	s1 = strstr(buf, "http:");
	s2 = strstr(buf, "ftp:");
	s3 = strstr(buf, "mailto:");
	s4 = strchr(buf, '@');
	if (s4)
		if (s4 == buf || !isalnum(s4[-1]) || !isalnum(s4[1])) 
			s4 = NULL;
		else
			while(s4 > buf && (isalnum(s4[-1]) || s4[-1] == '.' || s4[-1] == '_')) 
				s4--;
	
	if (s1 || s2 || s3 || s4)
		{
		nx = x;
		p = buf;
		
		do
			{
			if (!s1) s1 = s2;
			if (!s1) s1 = s3;
			if (!s1) s1 = s4;
			if (s2 < s1 && s2) s1 = s2;
			if (s3 < s1 && s3) s1 = s3;
			if (s4 < s1 && s4) s1 = s4;
			
			pc = *s1;
			*s1 = 0;
			vqt_extent(vdi_handle, p, extent);
			
			w = extent[4] - extent[6];
			nx += w;
			*s1 = pc;
			
			p = s1;
			while(*p && !isspace(*p) && *p != '"')
				p++;
				
			if ((isspace(*p) || !*p) && (p[-1] == '.' || p[-1] == '!' || p[-1] == '?' || p[-1] == ';'))
				p--;
			
			pc = *p;
			*p = 0;
/*			Link: v_gtext(vdi_handle, nx, y, s1);*/
			vqt_extent(vdi_handle, s1, extent);
			
			w = extent[4] - extent[6];
			
			if (nx <= evnt.x && nx + w > evnt.x)
				{
				if (!strnicmp(s1, "mailto:", 7) || s1 == s4)
					{
					if (s1 != s4)
						{
						s1 += 7;
						while (isspace(*s1))
							s1++;
						}
						
					new_mail(s1, NULL);
					}
				else	
					if (has_external(s1, FALSE))
						exec_external(s1, s1);
					
				free(buf);
				return TRUE;
				}
				
			nx += w;
			*p = pc;
			
			s1 = strstr(p, "http:");
			s2 = strstr(p, "ftp:");
			s3 = strstr(p, "mailto:");
			s4 = strchr(p, '@');
			if (s4)
				if (s4 == buf || !isalnum(s4[-1]) || !isalnum(s4[1])) 
					s4 = NULL;
				else
					while(s4 > buf && (isalnum(s4[-1]) || s4[-1] == '.' || s4[-1] == '_')) 
						s4--;
			}while(s1 || s2 || s3 || s4);
		}
	free(buf);
	}
return FALSE;
}
	
/* -------------------
   | Open attachment |
   ------------------- */
void open_attachment(int idx, int open_type)
{
int i, ac, in;
char *offset, *name, *desc, *type;
long loffset, llen;

DEBUG();
i = 0;
for (i = 0, ac = 0; i - ac < view_lines[idx]; i++)
	if (view_mem[idx][view_ptr[idx][i]] == 0x2)
		{
		if (ac == view_sel[idx])		break;
		ac++;
		}
	else
		if (ac > 0)
			break;
		
if (i == view_lines[idx])
	return;

offset = view_mem[idx] + view_ptr[idx][i] + 1;
name = offset + 8 + 2;
desc = name + strlen(name) + 1;
type = desc + strlen(desc) + 1;

if (open_type == -1)
	if (has_external(name, TRUE))
		open_type = 2;
		
if (open_type == 2)
	{
	if (has_external(name, FALSE))
		{
		in = open_file(view_file[idx], boxes[view_box[idx]].file);
		if (in > 0)
			{
			char tmp[256], *s;
			long tmplist;
			
			s = getenv("TMP");
			if (s)
				strcpy(tmp, s);
			else
				{
				tmp[0] = Dgetdrv() + 'A';
				tmp[1] = ':';
				Dgetpath(tmp + 2, 0);
				}

			if (tmp[strlen(tmp) - 1] != '\\')
				strcat(tmp, "\\");
								
			build_file(tmp + strlen(tmp));
			s = strrchr(name, '.');
			if (s)
				strcat(tmp, s);
			else
				strcat(tmp, ".TMP");
			
			memcpy(&loffset, offset + 2, 4);
			memcpy(&llen, offset + 6, 4);
			go_position(in, loffset);
			save_attach(name, in, view_bdry[idx], loffset + llen, type, tmp);
			Fclose((int)in);

			tmplist = Fopen("tmpfiles.dat", FO_RW);
			if (tmplist == -33)
				tmplist = Fcreate("tmpfiles.dat", 0);
			if (tmplist > 0)
				{
				Fseek(0, (int)tmplist, SEEK_END);
				Fwrite((int)tmplist, strlen(tmp), tmp);
				Fwrite((int)tmplist, 2, "\r\n");
				Fclose((int)tmplist);
				}
			exec_external(name, tmp);
			return;
			}
		}
	}
	
if (open_type == 1 || (!strnicmp(type, "text", 4) && open_type == -1))
	{
	MAIL_INFO ent;
	int part_no;

	strcpy(ent.subject, view_title[idx]);	
	memcpy(&part_no, offset, 2);
	strcpy(ent.file, view_file[idx]);
	view_mail(view_box[idx], &ent, part_no);
	}
else
	{
	in = open_file(view_file[idx], boxes[view_box[idx]].file);
	if (in > 0)
		{
		memcpy(&loffset, offset + 2, 4);
		memcpy(&llen, offset + 6, 4);
		go_position(in, loffset);
		save_attach(name, in, view_bdry[idx], loffset + llen, type, NULL);
		Fclose((int)in);
		}
	}
}

/* -----------------------------------
   | Handle keystroke in mail window |
   ----------------------------------- */
void view_keybd(int idx)
{
int wx, wy, ww, wh;
int tx_width, tx_height, dummy;

DEBUG();
set_default_text();
vst_font(vdi_handle, mail_options.font);
vst_height(vdi_handle, mail_options.fontsize, &dummy, &dummy, &tx_width, &tx_height);
		
wind_get(view_wind[idx], WF_WORKXYWH, &wx, &wy, &ww, &wh);

if (k_return == 0x5100 && !evnt.kstate) 	/* Page down */
	{
	k_return = '2';
	evnt.kstate = 1;
	}

if (k_return == 0x4900 && !evnt.kstate) 	/* Page up */
	{
	k_return = '8';
	evnt.kstate = 1;
	}

if (k_return == 0x4F00)		/* End */
	if (evnt.kstate == 4)
		{
		k_return = '7';
		evnt.kstate = 1;
		}

if (evnt.kstate & 3)
	{
	switch (k_return & 0xFF)
		{
		case '8':										/* Shift Up */
			if (view_page[idx] > 0) 
				{
				view_page[idx] -= wh / tx_height - 1;
				if (view_page[idx] < 0) view_page[idx] = 0;
				redraw_viewwindow(idx, wx, wy + iheight + 1, ww, wh - iheight - 1);
				set_viewslider(idx);
				}
			return;
		
		case '2':											/* Shift down */
			if (view_page[idx] + ((wh - iheight - 1) / tx_height - 1) < view_lines[idx])
				{
				view_page[idx] += (wh - iheight - 1) / tx_height - 1;
				if (view_page[idx] + ((wh - iheight - 1) / tx_height - 1) >= view_lines[idx]) 
					view_page[idx] = view_lines[idx] - (wh - iheight - 1) / tx_height + 1;
	
				redraw_viewwindow(idx, wx, wy + iheight + 1, ww, wh - iheight - 1);
				set_viewslider(idx);
				}
			return;
			
		case '7':														/* End */
			if (view_page[idx] + ((wh - iheight - 1) / tx_height - 1) < view_lines[idx])
				{
				view_page[idx] = view_lines[idx] - (wh - iheight - 1) / tx_height + 1;
				redraw_viewwindow(idx, wx, wy + iheight + 1, ww, wh - iheight - 1);
				set_viewslider(idx);
				}
			return;
		}
	}
	
switch(k_return)
	{
	case 0x4700:			/* Home */
		if (view_page[idx] > 0) 
			{
			view_page[idx] = 0;
			redraw_viewwindow(idx, wx, wy + iheight + 1, ww, wh - iheight - 1);
			set_viewslider(idx);
			}
		break;

	case 0x4800:			/* Up */
		if (view_page[idx] > 0) 
			{
			view_page[idx]--;
			blt_copy(NULL, wx, wy + iheight + 1, NULL, wx, wy + iheight + 1 + tx_height, ww, wh - iheight - 1 - tx_height, S_ONLY);
			redraw_viewwindow(idx, wx, wy + iheight + 1, ww, tx_height);
			set_viewslider(idx);
			}
		break;
		
	case 0x5000:			/* Down */
		if (view_page[idx] + ((wh - iheight - 1) / tx_height - 1) < view_lines[idx])
			{
			view_page[idx]++;
			blt_copy(NULL, wx, wy + iheight + 1 + tx_height, NULL, wx, wy + iheight + 1, ww, wh - iheight - 1 - tx_height, S_ONLY);
			redraw_viewwindow(idx, wx, wy + wh - tx_height - ((wh - iheight - 1) % tx_height), 
														 ww, tx_height + ((wh - iheight - 1) % tx_height));
			set_viewslider(idx);
			}
		break;
		
	case 0x7300:			/*  Control + Left */
		if (view_left[idx] > 0) 
			{
			view_left[idx] -= ww / tx_width;
			if (view_left[idx] < 0) view_left[idx] = 0;
			redraw_viewwindow(idx, wx, wy + iheight + 1, ww, wh - iheight - 1);
			set_viewslider(idx);
			}
		break;
		
	case 0x7400:			/*  Control + Right */
		if (view_left[idx] + (ww / tx_width) < view_width[idx])
			{
			view_left[idx] += ww / tx_width;
			if (view_left[idx] + (ww / tx_width) >= view_width[idx]) 
				view_left[idx] = view_width[idx] - ww / tx_width;

			redraw_viewwindow(idx, wx, wy + iheight + 1, ww, wh - iheight - 1);
			set_viewslider(idx);
			}
		break;
		
	case 0x4b00:			/*	Left */
		if (view_left[idx] > 0)
			{
			view_left[idx]--;
			blt_copy(NULL, wx, wy + iheight + 1, NULL, wx + tx_width, wy + iheight + 1, ww - tx_width, wh - iheight - 1, S_ONLY);
			redraw_viewwindow(idx, wx, wy + iheight + 1, tx_width, wh - iheight - 1);
			set_viewslider(idx);
			}
		break;
		
	case 0x4d00:			/*  Right */
		if (view_width[idx] - view_left[idx] > ww / tx_width)
			{
			view_left[idx]++;
			blt_copy(NULL, wx + tx_width, wy + iheight + 1, NULL, wx, wy + iheight + 1, ww - tx_width, wh - iheight - 1, S_ONLY);
			redraw_viewwindow(idx, wx + ww - tx_width - (ww % tx_width), wy + iheight + 1, tx_width + (ww % tx_width), wh - iheight - 1);
			set_viewslider(idx);
			}
		break;
	}
}

/* ----------------------------------
   | Switch the current header view |
   ---------------------------------- */
void switch_headerview(int idx)
{
MAIL_INFO entry;
int wx, wy, ww, wh;

DEBUG();
if (view_mem[idx]) free(view_mem[idx]);
if (view_ptr[idx]) free(view_ptr[idx]);

strcpy(entry.subject, view_title[idx]);	
strcpy(entry.file, view_file[idx]);

view_allh[idx] ^= 1;
full_header = view_allh[idx];

if (view_type[idx] == -1)
	{
	if (!format_mail(boxes[view_box[idx]].file, &entry, 
										&view_mem[idx], &view_len[idx],
										&view_ptr[idx], &view_width[idx], 
										&view_lines[idx], view_bdry[idx], &view_ansi[idx]))
		{
		close_viewwindow(idx);
		full_header = FALSE;
		return;
		}
	}
else
	{
	if (!get_part(viewmail_text,
							 boxes[view_box[idx]].file, &entry, 
							 &view_mem[view_count], &view_len[view_count], 
							 &view_ptr[view_count], &view_width[view_count], 
							 &view_lines[view_count], &view_ansi[idx], TRUE, view_type[idx]))
		{
		close_viewwindow(idx);
		full_header = FALSE;
		return;
		}
	}
full_header = FALSE;

wind_get(view_wind[idx], WF_WORKXYWH, &wx, &wy, &ww, &wh);	
redraw_viewwindow(idx, wx, wy, ww, wh);
view_enable(idx);
set_viewslider(idx);
}

/* ----------------------------
   | Reply to a selected mail |
   ---------------------------- */
void reply_view(int idx)
{
int i, box;
/*
if (!cfg_options.smtpserver[0])
	if (!provider_sel())
		return;
*/
DEBUG();
box = view_box[idx];
for (i = 0; i < box_manager[box].box_entries; i++)
	if (!strcmp(box_manager[box].index[i].file, view_file[idx]))
		{
		do_reply(box, &box_manager[box].index[i], 
						 view_mem[idx], view_ptr[idx], view_lines[idx], 
						 view_len[idx], vmark_start[idx], vmark_end[idx]);
		close_viewwindow(idx);
		break;
		}
}

/* ---------------------------
   | Forward a selected mail |
   --------------------------- */
void forward_view(int idx)
{
int i, box;
/*
if (!cfg_options.smtpserver[0])
	if (!provider_sel())
		return;
*/
DEBUG();
box = view_box[idx];
for (i = 0; i < box_manager[box].box_entries; i++)
	if (!strcmp(box_manager[box].index[i].file, view_file[idx]))
		{
		do_forward(box, &box_manager[box].index[i]);
		close_viewwindow(idx);
		break;
		}
}

/* ----------------------
   | Save selected mail |
   ---------------------- */
void save_view(int idx)
{
int i, box;

DEBUG();
box = view_box[idx];
for (i = 0; i < box_manager[box].box_entries; i++)
	if (!strcmp(box_manager[box].index[i].file, view_file[idx]))
		{
		do_save(box, &box_manager[box].index[i]);
		break;
		}
}

/* ----------------------
   | Save selected mail |
   ---------------------- */
void print_view(int idx)
{
int i, box;

DEBUG();
if (!mail_options.printmode)
	if (form_alert(1, printmsg) != 1)
		return;

box = view_box[idx];
for (i = 0; i < box_manager[box].box_entries; i++)
	if (!strcmp(box_manager[box].index[i].file, view_file[idx]))
		{
#ifdef PRINTING
		do_print(box, &box_manager[box].index[i], view_type[idx]);
#endif
		break;
		}
}

/* ----------------------------
   | Send selected mail again |
   ---------------------------- */
void send_view_again(int idx)
{
int i, box;
int wx, wy, ww, wh;
char bufs[51 * 2 + MAXFILE * 2 + 1];

DEBUG();
box = view_box[idx];

base_path(bufs);
strcat(bufs, boxes[box].file);
strcat(bufs, "\\");

strcpy(strrchr(bufs, '\\') + 1, view_file[idx]);
for (i = 0; i < box_manager[box].box_entries; i++)
	if (!strcmp(box_manager[box].index[i].file, view_file[idx]))
		{
		strcpy(strrchr(bufs, '\\') + 1, view_file[idx]);
		if (move_onemail(box, box_number("QUEUE"), i))
			close_viewwindow(idx);
		else
			{
			wind_get(box_manager[box].list_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);
			redraw_listwindow(box, wx, wy, ww, wh);
			
			box = box_number("QUEUE");
			if (box_manager[box].list_wind > -1) 
				{
				wind_get(box_manager[box].list_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);
				redraw_listwindow(box, wx, wy, ww, wh);
				}
			}
		break;
		}
}

/* ----------------------------
   | Delete messages from box |
   ---------------------------- */
void delete_viewmail(int idx)
{
char buf[256];
int i, l, box;
int wx, wy, ww, wh;

DEBUG();
box = view_box[idx];

if (mail_options.confirm_delete)
	{
	if (form_alert(2, deletethis) != 1)
		return;
	}

base_path(buf);
strcat(buf, boxes[box].file);
strcat(buf, "\\");

l = (int)strlen(buf);

for (i = 0; i < box_manager[box].box_entries; i++)
	if (!strcmp(box_manager[box].index[i].file, view_file[idx]))
		{
		strcpy(buf + l, view_file[idx]);
		if (!Fdelete(buf))
			delete_index(view_file[idx], box);
		break;
		}	
close_viewwindow(idx);

wind_get(box_manager[box].list_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);
redraw_listwindow(box, wx, wy, ww, wh);

save_box_index(box);
enabler();
set_listinfo(box);
set_listslider(box);
}

/* ----------------------------
   | Send selected mail again |
   ---------------------------- */
void send_queue_view(int idx)
{
int i, s, to_box, box, err;
char bufs[51 * 2 + MAXFILE * 2 + 1];
int wx, wy, ww, wh;
int ididx;

DEBUG();
if (!check_connection(2, "\0", FALSE))
	return;
	
box = view_box[idx];

base_path(bufs);
strcat(bufs, boxes[box].file);
strcat(bufs, "\\");

err = FALSE;
for (i = 0; i < box_manager[box].box_entries; i++)
	if (!strcmp(box_manager[box].index[i].file, view_file[idx]))
		{
		ididx = getIdentityIndex(box_manager[box].index[i].identity);
		if (ididx == -1)
			return;
			
		if (!open_idsmtp(ididx))
			{
			show_error(TRUE);
			return;
			}
			
		strcpy(strrchr(bufs, '\\') + 1, view_file[idx]);
		if (!strncmp(box_manager[box].index[i].subject, "RC: ", 4))
			{
			s = 1;
			mail_send(bufs);
			
			if (!Fdelete(bufs))
				delete_index(box_manager[box].index[i].file, box);
			}
		else
			{
			if (mail_send(bufs))
				to_box = box_number("SENT");
			else
				{
				to_box = box_number("SENTERR");
				err = TRUE;
				}
				
			s = move_onemail(box, to_box, i);
			}
			
		if (s) 
			{
			if (box_manager[box].list_wind > -1)
				{
				wind_get(box_manager[box].list_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);
				redraw_listwindow(box, wx, wy, ww, wh);
				}
	
			if (box_manager[to_box].list_wind > -1) 
				{
				wind_get(box_manager[to_box].list_wind, WF_WORKXYWH, &wx, &wy, &ww, &wh);
				redraw_listwindow(to_box, wx, wy, ww, wh);
				}
			set_listinfo(to_box);
			set_listinfo(box);
			i--;
			}
			
		close_smtp();
		break;
		}

if (err)
	show_error(TRUE);
}

/* ------------------------------------
   | Get button number in mail window |
   ------------------------------------ */
int get_viewwind_button(int idx, int mousex, int mousey)
{
int i;
int wx, wy, ww, wh;

DEBUG();
if (view_wind[idx] == -1)
	return -1;
	
wind_get(view_wind[idx], WF_WORKXYWH, &wx, &wy, &ww, &wh);

if (mousey >= wy && mousey < wy + iheight)
	for (i = 0; i < 10; i++)
		if (mousex >= wx + vbut_pos[i] && mousex < wx + vbut_pos[i] + isize)
			return i;

return -1;
}

/* ----------------------
   | Select mail button |
   ---------------------- */
void redraw_viewbutton(int idx, int x)
{
GRECT t1;
int xy[4];
int wx, wy, ww, wh;

DEBUG();
calc_butpos();

wind_update(BEG_UPDATE);
graf_mouse(M_OFF, 0L);

wind_get(view_wind[idx], WF_WORKXYWH, &wx, &wy, &ww, &wh);

wind_get(view_wind[idx], WF_FIRSTXYWH, &t1.g_x, &t1.g_y, &t1.g_w, &t1.g_h);
while(t1.g_w && t1.g_h)
	{
	xy[0] = t1.g_x;
	xy[1] = t1.g_y;
	xy[2] = t1.g_x + t1.g_w - 1;
	xy[3] = t1.g_y + t1.g_h - 1;
	vs_clip(vdi_handle, 1, xy);

	draw_viewbutton(idx, x, wx + vbut_pos[x], wy);

	vs_clip(vdi_handle, 0, xy);
		
	wind_get(view_wind[idx], WF_NEXTXYWH, &t1.g_x, &t1.g_y, &t1.g_w, &t1.g_h);
	}

graf_mouse(M_ON, 0L);
wind_update(END_UPDATE);
}

/* ---------------------------
   | Redraw all view buttons |
   --------------------------- */
void redraw_all_viewbuttons(int idx)
{
int i;

DEBUG();
for (i = 0; i < 10; i++)
	redraw_listbutton(idx, i);
}

/* -----------------------------
   | Select mail editor button |
   ----------------------------- */
void select_viewbutton(int idx, int no)
{
DEBUG();
vbut_selected[idx][0] = 
vbut_selected[idx][1] = 
vbut_selected[idx][2] = 
vbut_selected[idx][3] = 
vbut_selected[idx][4] = 
vbut_selected[idx][5] = 
vbut_selected[idx][6] = 
vbut_selected[idx][7] = 
vbut_selected[idx][8] =
vbut_selected[idx][9] = FALSE;

if (no != -1)
	vbut_selected[idx][no] = TRUE;
}

/* ---------------------
   | Press mail button |
   --------------------- */
void press_viewbutton(int idx, int n)
{
DEBUG();
vbut_selected[idx][n] = TRUE;
redraw_viewbutton(idx, n);

wait_mouse_release();
	
vbut_selected[idx][n] = FALSE;
redraw_viewbutton(idx, n);
}
   
/* -----------------------
   | Mail button pressed |
   ----------------------- */
void view_button_action(int idx)
{
DEBUG();
switch(get_viewwind_button(idx, evnt.x, evnt.y))
	{
	case 0:														/* Reply */
		press_viewbutton(idx, 0);
		reply_view(idx);
		break;
		
	case 1:														/* Forward */
		press_viewbutton(idx, 1);
		forward_view(idx);
		break;

	case 2:														/* Cut / Always disabled */
		break;
		
	case 3:														/* Copy */
		press_viewbutton(idx, 3);
		copy_view(idx);
		break;

	case 4:														/* Paste / Always disabled */
	case 5:														/* Delete / Always disabled */
		break;

	case 6:														/* Save */
		press_viewbutton(idx, 6);
		save_view(idx);
		break;
		
	case 7:														/* Print */
		press_viewbutton(idx, 7);
		print_view(idx);
		break;

	case 8:														/* Delete */
		press_viewbutton(idx, 8);
		delete_viewmail(idx);
		break;
		
	case 9:														/* Close	*/
		press_viewbutton(idx, 9);
		close_viewwindow(idx);	
		break;
	}
}

/* ----------------------
   | Mark text by mouse |
   ---------------------- */
void mark_viewtext(int idx)
{
long mark, start_mark;
int red;
int old_mx, old_my;
int old_ln, new_ln, x_start, x_width;
int wx, wy, ww, wh;
int tx_width, tx_height, dummy;

DEBUG();
set_default_text();
vst_font(vdi_handle, mail_options.font);
vst_height(vdi_handle, mail_options.fontsize, &dummy, &dummy, &tx_width, &tx_height);

wind_get(view_wind[idx], WF_WORKXYWH, &wx, &wy, &ww, &wh);

if (clicks == 2)
	{
	vmark_start[idx] = vmark_end[idx] = get_viewmark(idx, evnt.x, evnt.y);
	
	while(vmark_start[idx] > 0  && misalnum(((unsigned char *)view_mem[idx])[vmark_start[idx] - 1]))
		vmark_start[idx]--;
		
	while(vmark_end[idx] < view_len[idx] && misalnum(((unsigned char *)view_mem[idx])[vmark_end[idx]]))
		vmark_end[idx]++;
		
	if (vmark_start[idx] != vmark_end[idx])
		redraw_viewwindow(idx, wx, wy, ww, wh);
	else
		{
		vmark_start[idx] = vmark_end[idx] = -1;
		vbut_disabled[idx][3] = TRUE;
		redraw_viewwindow(idx, wx, wy, ww, wh);
		}

	return;
	}
	
graf_mkstate(&evnt);
if ((evnt.bstate & 1) || (evnt.kstate & 3))
	{
	mark = get_viewmark(idx, evnt.x, evnt.y);
	if (mark != -1L)
		{
		if (evnt.kstate & 3)
			{
			if (mark < vmark_start[idx])
				vmark_start[idx] = mark;
			else
				{
				vmark_end[idx] = mark + 1;
				if (vmark_end[idx] > view_len[idx]) vmark_end[idx] = view_len[idx];
				}
			redraw_viewwindow(idx, wx, wy, ww, wh);
			}
		else
			{
			start_mark = vmark_start[idx] = mark;
			vmark_end[idx]   = mark + 1;
			if (vmark_end[idx] > view_len[idx]) vmark_end[idx] = view_len[idx];
			redraw_viewwindow(idx, wx, wy, ww, wh);
			
			old_mx = evnt.x;
			old_my = evnt.y;
			do
				{
				graf_mkstate(&evnt);
	
				if (evnt.x < wx + tx_width / 2 && view_left[idx] > 0)
					{
					old_mx += tx_width;
					view_left[idx]--;
					blt_copy(NULL, wx, wy + iheight + 1, 
									 NULL, wx + tx_width, wy + iheight + 1, 
									 ww - tx_width, wh - iheight - 1, S_ONLY);
					redraw_viewwindow(idx, wx, wy + iheight + 1, tx_width, wh - iheight - 1);
					set_viewslider(idx);
					}
				else
					if (evnt.x > wx + ww - tx_width / 2 && view_width[idx] - view_left[idx] > ww / tx_width)
						{
						old_mx -= tx_width;
						view_left[idx]++;
						blt_copy(NULL, wx + tx_width, wy + iheight + 1, 
										 NULL, wx, wy + iheight + 1, 
										 ww - tx_width, wh - iheight - 1, S_ONLY);
						redraw_viewwindow(idx, wx + ww - tx_width - (ww % tx_width), wy + iheight + 1, tx_width + (ww % tx_width), wh - iheight - 1);
						set_viewslider(idx);
						}
	
				if (evnt.y < wy + iheight - 1 + tx_height / 2 && view_page[idx] > 0)
					{
					old_my += tx_height;
					evnt.y = wy + iheight + 1;
				  view_page[idx]--;
					blt_copy(NULL, wx, wy + iheight + 1, 
									 NULL, wx, wy + tx_height + iheight + 1, 
									 ww, wh - iheight - 1 - tx_height, S_ONLY);
					redraw_viewwindow(idx, wx, wy + iheight + 1, ww, tx_height);
					set_viewslider(idx);
					}
				else
					if (evnt.y > wy + wh - tx_height / 2 && 
							view_page[idx] + ((wh - iheight - 1) / tx_height - 1) < view_lines[idx])
						{
						old_my -= tx_height;
						evnt.y = wy + wh - 1;
						view_page[idx]++;
						blt_copy(NULL, wx, wy + iheight + 1 + tx_height, 
										 NULL, wx, wy + iheight + 1, 
										 ww, wh - iheight - 1 - tx_height, S_ONLY);
						redraw_viewwindow(idx, wx, wy + wh - tx_height - ((wh - iheight - 1) % tx_height), 
																	 ww, tx_height + ((wh - iheight - 1) % tx_height));
						set_viewslider(idx);
						}
	
				mark = get_viewmark(idx, evnt.x, evnt.y);
				red = FALSE;
				if (mark != -1)
					{
					if (mark <= start_mark)
						{
						if (vmark_start[idx] != mark)
							{
							vmark_start[idx] = mark;
							vmark_end[idx] = start_mark + 1;
							if (vmark_end[idx] > view_len[idx]) vmark_end[idx] = view_len[idx];
							red = TRUE;
							}
						}
					else
						{
						if (mark + 1 != vmark_end[idx])
							{
							vmark_start[idx] = start_mark;
							vmark_end[idx] = mark + 1;
							if (vmark_end[idx] > view_len[idx]) vmark_end[idx] = view_len[idx];
							red = TRUE;
							}
						}
	
					if (red)
						{
						old_ln = (old_my - wy - iheight - 1) / tx_height;
						new_ln = (evnt.y - wy - iheight - 1) / tx_height;
		
						if (old_ln > new_ln)
							{
							x_start = 0;
							x_width = ww;
								
							old_ln++;	
							redraw_viewwindow(idx, wx + x_start,  wy + iheight + 1 + new_ln * tx_height, x_width, 
															  (old_ln - new_ln) * tx_height);
							}
						else
							{
							if (old_ln == new_ln)
								{
								if (old_mx < evnt.x)
									{
									x_start = (old_mx - wx) / tx_width;
									x_start *= tx_width;
									x_width = (evnt.x - old_mx + tx_width - 1) / tx_width + 1;
									x_width *= tx_width;
									}
								else
									{
									x_start = (evnt.x - wx) / tx_width;
									x_start *= tx_width;
									x_width = (old_mx - evnt.x + tx_width - 1) / tx_width + 1;
									x_width *= tx_width;
									}
								}
							else
								{
								x_start = 0;
								x_width = ww;
								}
							
							new_ln++;	
							redraw_viewwindow(idx, wx + x_start, 
																wy + iheight + 1 + old_ln * tx_height,
															  x_width, 
															  (new_ln - old_ln) * tx_height);
							}
						}
					}
	
				old_mx = evnt.x;
				old_my = evnt.y;
				}while(evnt.bstate & 1);
				
			if (vmark_start[idx] == vmark_end[idx])
				vmark_start[idx] = vmark_end[idx] = -1L;
			}
		}

	red = vbut_disabled[idx][3];
	
	vbut_disabled[idx][3] = vmark_start[idx] == -1;
	
	if (red != vbut_disabled[idx][3])
		redraw_viewbutton(idx, 3);
	}
else
	{
	if (vmark_start[idx] != -1)
		{
		vmark_start[idx] = vmark_end[idx] = -1;
		vbut_disabled[idx][3] = TRUE;
		redraw_viewwindow(idx, wx, wy, ww, wh);
		}
	}
}

/* ------------------
   | Calculate mark |
   ------------------ */
long get_viewmark(int idx, int mousex, int mousey)
{
int wx, wy, ww, wh;
int y;
int hg, l, msg;
int tx_width, tx_height, dummy;

DEBUG();
set_default_text();
vst_font(vdi_handle, mail_options.font);
vst_height(vdi_handle, mail_options.fontsize, &dummy, &dummy, &tx_width, &tx_height);

wind_get(view_wind[idx], WF_WORKXYWH, &wx, &wy, &ww, &wh);

hg = (wh - iheight - 1 + tx_height - 1) / tx_height;
y = wy + iheight + 1;

for (msg = view_page[idx], l = 0; l < hg && msg < view_lines[idx]; l++, msg++)
	{
	if (view_mem[idx][view_ptr[idx][msg]] == 2)
		break;
	else
		{
		if (mousey >= y && mousey < y + tx_height)
			{
			long ptr;
			int xpos, lw, linestart;
			int j, extent[8];
			char *buf;
			
			lw = (int)(view_ptr[idx][msg + 1] - view_ptr[idx][msg] - 1);

			if (view_mem[idx][view_ptr[idx][msg]] == 1)
				{
				vst_effects(vdi_handle, 1);
				ptr = view_ptr[idx][msg] + 1;
				lw--;

				if (view_allh[idx])
					linestart = 0;
				else
					{
					char xbuf[14];
					int w;
					
					memcpy(xbuf, view_mem[idx] + view_ptr[idx][msg] + view_left[idx] + 1, 13);
					xbuf[13] = 0;
					if (lw - 1 < 13)
						xbuf[lw] = 0; 
					
					vqt_extent(vdi_handle, xbuf, extent);
					w = abs(extent[2] - extent[0]);
					linestart = view_hoffset[idx] + 20 - w;
					}
				}
			else
				{
				vst_effects(vdi_handle, 0);
				ptr = view_ptr[idx][msg];
				
				linestart = 0;
				}

			if (view_left[idx] > lw)
				xpos = lw;
			else
				{
				int c;
				
				buf = (char *)malloc(lw + 1);
				for (c = 0, j = view_left[idx]; j < lw; j++)
					{
					buf[c] = view_mem[idx][ptr + j];
					buf[++c] = 0;
					vqt_extent(vdi_handle, buf, extent);

					if (extent[2] < extent[0]) 
						{
						int zw = extent[0];
						extent[0] = extent[2];
						extent[2] = zw;
						}
					
					if (extent[0] + wx + linestart <= mousex && extent[2] + wx + linestart > mousex)
						break;
					}
				free(buf);

				xpos = j;
				}
				
			return ptr + xpos;				
			}
			
		y += tx_height;
		}
	}
	
return -1;
}

/* ------------------
   | Copy from view |
   ------------------ */
int copy_view(int idx)
{
char scrap[256];
long fh;
int i, eol;

DEBUG();
if (scrp_read(scrap))
	{
	strcat(scrap, "scrap.txt");

	fh = Fcreate(scrap, 0);
	if (fh > 0)
		{
		for (i = 0; i < view_lines[idx]; i++)
			{
			long ptr = view_ptr[idx][i];
			int len = (int)(view_ptr[idx][i + 1] - view_ptr[idx][i]);
			eol = TRUE;
			
			if (view_mem[idx][ptr] == 1) 
				{
				ptr++;
				len--;
				}
			if (view_mem[idx][ptr + len - 1] == '\r') 
				len--;
				
			if (ptr + len > vmark_start[idx] && ptr < vmark_end[idx])
				{
				if (ptr >= vmark_start[idx] && ptr + len <= vmark_end[idx])
					{
					if (Fwrite((int)fh, len, view_mem[idx] + ptr) != len)
						{
						form_alert(1, scrap_error);
						Fclose((int)fh);
						return FALSE;
						}
					if (Fwrite((int)fh, 2, "\r\n") != 2)
						{
						form_alert(1, scrap_error);
						Fclose((int)fh);
						return FALSE;
						}
					}
				else
					{
					if (ptr < vmark_start[idx] && ptr + len > vmark_start[idx])
						{
						len -= (int)(vmark_start[idx] - ptr);
						ptr = vmark_start[idx];
						}
						
					if (ptr < vmark_end[idx] && ptr + len > vmark_end[idx])
						{
						len  = (int)(vmark_end[idx] - ptr);
						eol = FALSE;
						}
						
					if (len)
						{
						if (Fwrite((int)fh, len, view_mem[idx] + ptr) != len)
							{
							form_alert(1, scrap_error);
							Fclose((int)fh);
							return FALSE;
							}
						if (eol)
							if (Fwrite((int)fh, 2, "\r\n") != 2)
								{
								form_alert(1, scrap_error);
								Fclose((int)fh);
								return FALSE;
								}
						}
					}
				}
			else
				if (ptr > vmark_end[idx])
					break;
			}
			
		Fclose((int)fh);
		return TRUE;
		}
	else
		form_alert(1, scrap_error);
	}
return FALSE;
}
